#ifndef _ADAPTOR_H
#define _ADAPTOR_H

#include <linux/version.h>
#include <linux/module.h>
#if defined(MODVERSIONS)
#include <linux/modversions.h>
#endif

#include <linux/kernel.h>
#include <linux/string.h>
#include <linux/errno.h>
#include <linux/sched.h>
#include <linux/utsname.h>
#include <linux/spinlock.h>

#define ADAPTOR_NAME_SIZE 32

extern int atoi(const char *nptr);
extern int register_adaptor(char *adaptor_name, int id, void *callback);
extern int unregister_adaptor(char *adaptor_name);
extern int call_adaptor_by_name(char* adaptor_name, int parameter1, int parameter2,
int parameter3, int parameter4);
extern int call_adaptor_by_id(int id, int parameter1, int parameter2,
int parameter3, int parameter4);
extern int get_next_adaptor(int prev_id);

typedef struct _adaptor_node{
	char name[ADAPTOR_NAME_SIZE];	
	int id;
	void *callback;
	struct _adaptor_node *next; 
} adaptor_node;

#endif
