#ifndef MODULE
#define MODULE
#endif
#ifndef __KERNEL__
#define __KERNEL__
#endif

#include <linux/version.h>
#include <linux/module.h> 
#include <linux/autoconf.h> 
#if defined(MODVERSIONS)
#include <linux/modversions.h>
#endif

#include <linux/kernel.h>
#include <linux/mm.h>
#include <linux/swap.h>
#include <linux/sched.h>
#include "adaptor.h"

MODULE_AUTHOR("CERCS - GaTech");
MODULE_DESCRIPTION("Control Module (DWCS CPU)");
MODULE_LICENSE("GPL");

/* parameter1 = pid, parameter2 = type (0=period,1=own,2=owd,3=flags,4=service_time), 
parameter3 = value , parameter4 = unused */
int dwcs_cpu_callback(int parameter1, int parameter2, int parameter3, int parameter4)
{
	int result = -1;
#ifdef CONFIG_DWCS
	struct task_struct *task;

	task = find_task_by_pid(parameter1);
	if (parameter2 == 0) {
		task->dwcs_params->period = (long) parameter3;
		result = 0;
	} else if (parameter2 == 1) {
		task->dwcs_params->own = (unsigned int) parameter3;
		result = 0;
	} else if (parameter2 == 2) {
		task->dwcs_params->owd = (unsigned int) parameter3;
		result = 0;
	} else if (parameter2 == 3) {
		task->dwcs_params->flags = (unsigned int) parameter3;
		result = 0;
	} else if (parameter2 == 4) {
		task->dwcs_params->service_time = (unsigned long) parameter3;
		result = 0;
	}
#endif

	return result;
}

int init_module(void)
{
	register_adaptor("DWCS CPU Scheduler", 2, (void *)dwcs_cpu_callback);
	return 0;
}

void cleanup_module(void)
{
	unregister_adaptor("DWCS CPU Scheduler");
	return;
}
