#ifndef MODULE
#define MODULE
#endif
#ifndef __KERNEL__
#define __KERNEL__
#endif

#include <linux/version.h>
#include <linux/module.h> 
#if defined(MODVERSIONS)
#include <linux/modversions.h>
#endif

#include <linux/kernel.h>
#include <linux/mm.h>
#include <linux/swap.h>
#include "adaptor.h"

MODULE_AUTHOR("CERCS - GaTech");
MODULE_DESCRIPTION("Control Module (Linux CPU)");
MODULE_LICENSE("GPL");

/* parameter1 = pid, parameter2 = new rt priority, parameter3 = inc/dec, 
parameter4 = unused */
int linux_cpu_callback(int parameter1, int parameter2, int parameter3, int parameter4)
{
	struct task_struct *task;
	int result = -1;

	task = find_task_by_pid(parameter1);
	if ((parameter2 != -1) && ((task->policy == SCHED_RR) || 
		(task->policy == SCHED_FIFO))) {
		task->rt_priority = parameter2;
		result = 0;
	} else if (parameter3 != 0) {
		if (parameter3 > 0) {
			if (task->policy != SCHED_OTHER) {
				task->rt_priority++;
				result = 0;
			} else if (task->nice > -20) {
				task->nice--;
				result = 0;
			}
		} else {
			if (task->policy != SCHED_OTHER) {
				task->rt_priority--;
				result = 0;
			} else if (task->nice < 19) {
			 	task->nice++;
				result = 0;
			}
		}
	}
	return result;
}

int init_module(void)
{
	register_adaptor("Linux CPU Scheduler", 1, (void *)linux_cpu_callback);
	return 0;
}

void cleanup_module(void)
{
	unregister_adaptor("Linux CPU Scheduler");
	return;
}
