#ifndef MODULE
#define MODULE
#endif
#ifndef __KERNEL__
#define __KERNEL__
#endif

#include <linux/version.h>
#include <linux/module.h> 
#if defined(MODVERSIONS)
#include <linux/modversions.h>
#endif

#include <linux/kernel.h>
#include <linux/mm.h>
#include <linux/swap.h>
#include "adaptor.h"
#include "../kecho/include/ecalls_module.h"

MODULE_AUTHOR("CERCS - GaTech");
MODULE_DESCRIPTION("Control Module (Linux Upcall)");
MODULE_LICENSE("GPL");

static int ecalls_id = -1;

/* parameter1 = pid, parameter2 = new rt priority, parameter3 = inc/dec, 
parameter4 = unused */
int upcall_callback(int parameter1, int parameter2, int parameter3, int parameter4)
{
	do_upcall(ecalls_id, parameter1, 0, 0, 0, 0);
	return 0;
}

int init_module(void)
{
	ecalls_id = register_adaptor("Upcall", 4, (void *)upcall_callback);
	register_ecalls_service("Adaptor", NULL, NULL, 0);

	return 0;
}

void cleanup_module(void)
{
	unregister_ecalls_service("Adaptor");
	unregister_adaptor("Upcall");
	return;
}
