#ifndef __KERNEL__
#define __KERNEL__
#endif
#ifndef MODULE
#define MODULE
#endif


#include <linux/kernel.h> 
#include <linux/version.h>
#include <linux/module.h> 

#if defined(MODVERSIONS)
  #include <linux/modversions.h>
#endif
//#define EXPORT_SYMTAB

#include <linux/sched.h>
#include <linux/interrupt.h>
#include <linux/timer.h>
#include <linux/proc_fs.h>
#include <asm/uaccess.h>
#include <linux/kernel_stat.h>
#include <linux/types.h>
#include <linux/errno.h>
#include <linux/sched.h>
#include <linux/kernel.h>
#include <linux/kernel_stat.h>
#include <linux/tty.h>
#include <linux/string.h>
#include <linux/mman.h>
#include <linux/proc_fs.h>
#include <linux/ioport.h>
#include <linux/config.h>
#include <linux/mm.h>
#include <linux/pagemap.h>
#include <linux/swap.h>
#include <linux/slab.h>
#include <linux/smp.h>
#include <linux/signal.h>
#include <linux/module.h>
#include <linux/init.h>
#include <linux/smp_lock.h>
#include <linux/seq_file.h>
 
#include <asm/uaccess.h>
#include <asm/pgtable.h>
#include <asm/io.h>

#include "kthread.h"

#include "monitor.h"
#define CPU_FREQ	(2*HZ)	/* 2 sec intervals */

#define CPU_BUF_SIZE	SERVICE_DATA_SIZE

#define CPU_DATA_TYPE	FLOAT_DATA

MODULE_AUTHOR("Rajiv Ratnam");
MODULE_DESCRIPTION("Cpu_mon Module(Dproc)");
MODULE_LICENSE("GPL");

//kthread_t cpumon_thread_data;
char cpumon_monitor_string[CPU_BUF_SIZE];
static PServiceLink cpumon_servicelink;
static int cpumon_serviceid = -1; 

static unsigned long oldjif = 0;
static unsigned long now;

unsigned int old_user = 0, old_nice = 0, old_system = 0;
unsigned long old_idle =0;

extern unsigned long total_forks; 
void get_cpu_info();

int data(void **data_buf,int *data_len){
        get_cpu_info();
        *data_buf=(void *)cpumon_monitor_string;
	*data_len=CPU_BUF_SIZE;
	return MON_OK;
}



void get_cpu_info()
{
       int i, len =0;

       unsigned long jif = jiffies;
       unsigned int user = 0, nice = 0, system = 0;

       unsigned long delay =0, idle =0;


       for (i = 0 ; i < smp_num_cpus; i++) {

                 int cpu = cpu_logical_map(i);
 
                 user += kstat.per_cpu_user[cpu];
                 nice += kstat.per_cpu_nice[cpu];
                 system += kstat.per_cpu_system[cpu];
         }
 
	 idle = jif * smp_num_cpus - (user + nice + system);

	 len = sprintf(cpumon_monitor_string, 
                                         "Total User:       %8u\n"
                                         "Total Nice:       %8u\n"
                                         "Total System:     %8u\n"
		                         "Total Idle:       %8lu\n\n",
                                         user, nice, system, idle
                                         );


         for (i = 0 ; i < smp_num_cpus; i++) {
	        len += sprintf(cpumon_monitor_string+len, 
                         "CPU %u\n"
                         "User:             %8u\n"
                         "Nice:             %8u\n"
                         "System:           %8u\n"
	                 "Idle:             %8lu\n\n",
                         i,
                         kstat.per_cpu_user[cpu_logical_map(i)],
                         kstat.per_cpu_nice[cpu_logical_map(i)],
                         kstat.per_cpu_system[cpu_logical_map(i)],
                         jif - (kstat.per_cpu_user[cpu_logical_map(i)] \
                                    + kstat.per_cpu_nice[cpu_logical_map(i)] \
                                    + kstat.per_cpu_system[cpu_logical_map(i)]));


                 }

	 /* find averages */
	 now = jif;

	 delay = now - oldjif;
	 len += sprintf(cpumon_monitor_string+len, 
                                         "Avg User/s:       %8lu\n"
                                         "Avg Nice/s:       %8lu\n"
                                         "Avg System/s:     %8lu\n"
			                 "Avg Idle/s:       %8lu\n\n",
			((user - old_user) * HZ) /delay, ((nice - old_nice) * HZ) /delay, ((system - old_system) * HZ) /delay, 
			((idle - old_idle) * HZ) /delay
		       );
	 

	 old_user = user;
	 old_nice = nice;
	 old_system = system;
	 old_idle = idle;
	 oldjif = now;

}

#if 0
void cpumon_thread(kthread_t *kthread)
{
	init_kthread(kthread, "cpumon thread");
	
	cpumon_serviceid = register_service("cpu", data, CPU_DATA_TYPE, &cpumon_servicelink);
	while(1){
		/* fall asleep for one second */
                interruptible_sleep_on_timeout(&kthread->queue, CPU_FREQ);

                /* We need to do a memory barrier here to be sure that
                   the flags are visible on all CPUs. 
                */
                 mb();
                
                /* here we are back from sleep, either due to the timeout
                   (one second), or because we caught a signal.
                */
                if (kthread->terminate)
                {
                        /* we received a request to terminate ourself */
                        break;    
                }
                
		/*print_progress();*/

                //get_cpu_info();

		/*printk(KERN_CRIT "cpumon_monitor = %s at time=%ld\n",cpumon_monitor_string, jiffies);
		  print_progress();*/

	}
	
	/* cleanup the thread, leave */
        exit_kthread(kthread);
	return;
}
#endif 


/* load the module */
int init_module(void)
{
	/* create new kernel threads */
	// start_kthread(cpumon_thread, &cpumon_thread_data);

	cpumon_serviceid = register_service("cpu", data, CPU_DATA_TYPE, &cpumon_servicelink);

	return(0);
}

/* remove the module */
void cleanup_module(void)
{
	/* terminate the kernel threads */
	deregister_service(cpumon_serviceid);
	//stop_kthread(&cpumon_thread_data);
	//printk(KERN_CRIT "cpumon exiting.. \n");
	return;
}
