#ifndef __KERNEL__
#define __KERNEL__
#endif
#ifndef MODULE
#define MODULE
#endif


#include <linux/kernel.h> 
#include <linux/version.h>
#include <linux/module.h> 

#if defined(MODVERSIONS)
  #include <linux/modversions.h>
#endif
//#define EXPORT_SYMTAB

#include <linux/sched.h>
#include <linux/interrupt.h>
#include <linux/timer.h>
#include <linux/proc_fs.h>
#include <asm/uaccess.h>
#include <linux/kernel_stat.h>
#include <linux/types.h>
#include <linux/errno.h>
#include <linux/sched.h>
#include <linux/kernel.h>
#include <linux/kernel_stat.h>
#include <linux/tty.h>
#include <linux/string.h>
#include <linux/mman.h>
#include <linux/proc_fs.h>
#include <linux/ioport.h>
#include <linux/config.h>
#include <linux/mm.h>
#include <linux/pagemap.h>
#include <linux/swap.h>
#include <linux/slab.h>
#include <linux/smp.h>
#include <linux/signal.h>
#include <linux/module.h>
#include <linux/init.h>
#include <linux/smp_lock.h>
#include <linux/seq_file.h>
 
#include <asm/uaccess.h>
#include <asm/pgtable.h>
#include <asm/io.h>


#include "kthread.h"


#include "monitor.h"
#define CTX_FREQ	(2*HZ)	/* 2 sec intervals */

#define CTX_BUF_SIZE	SERVICE_DATA_SIZE

#define CTX_DATA_TYPE	FLOAT_DATA


MODULE_AUTHOR("Rajiv Ratnam");
MODULE_DESCRIPTION("Ctxmon Module(Dproc)");
MODULE_LICENSE("GPL");

static unsigned long oldjif = 0;
static unsigned long now;

//kthread_t ctxmon_thread_data;
char ctxmon_monitor_string[CTX_BUF_SIZE];
static PServiceLink ctxmon_servicelink;
static int ctxmon_serviceid = -1; 

extern unsigned long total_forks; 

unsigned int old_ctx =0;
unsigned long old_forks =0;
void get_ctx_switch_info();

int data(void **data_buf,int *data_len){
        get_ctx_switch_info();
        *data_buf=(void *)ctxmon_monitor_string;
	*data_len=CTX_BUF_SIZE;
	return MON_OK;
}

void get_ctx_switch_info()
{
       int len =0;

       unsigned int ctx = kstat.context_swtch;
       unsigned long forks = total_forks;
       unsigned long delay =0;

       len = sprintf(ctxmon_monitor_string, 
                 "Context Switches:   %8u\n" 
   	         "Total Processes:    %8lu\n\n",
		 ctx, forks 
		 );


	 /* find averages */
	 now = jiffies;

	 delay = now - oldjif;

        len += sprintf(ctxmon_monitor_string + len, 
                 "Average Context Switches/s: %8lu\n" 
		 "Average Forks/s:            %8lu\n",
		 ((ctx - old_ctx) * HZ) /delay, ((forks - old_forks) * HZ) /delay
		 );


	 old_ctx = ctx; 
	 old_forks = forks;
	 oldjif = now;       
}

#if 0
void ctxmon_thread(kthread_t *kthread)
{
	init_kthread(kthread, "ctxmon thread");
	
	ctxmon_serviceid = register_service("process", data, CTX_DATA_TYPE, &ctxmon_servicelink);
	while(1){
		/* fall asleep for one second */
                interruptible_sleep_on_timeout(&kthread->queue, CTX_FREQ);

                /* We need to do a memory barrier here to be sure that
                   the flags are visible on all CPUs. 
                */
                 mb();
                
                /* here we are back from sleep, either due to the timeout
                   (one second), or because we caught a signal.
                */
                if (kthread->terminate)
                {
                        /* we received a request to terminate ourself */
                        break;    
                }
                
		/*print_progress();*/

                //get_ctx_switch_info();

		/*printk(KERN_CRIT "ctxmon_monitor = %s at time=%ld\n",ctxmon_monitor_string, jiffies);
		  print_progress();*/

	}
	
	/* cleanup the thread, leave */
        exit_kthread(kthread);
	return;
}
#endif


/* load the module */
int init_module(void)
{
	/* create new kernel threads */
	//start_kthread(ctxmon_thread, &ctxmon_thread_data);
	ctxmon_serviceid = register_service("process", data, CTX_DATA_TYPE, &ctxmon_servicelink);
	return(0);
}

/* remove the module */
void cleanup_module(void)
{
	/* terminate the kernel threads */
	deregister_service(ctxmon_serviceid);
	//stop_kthread(&ctxmon_thread_data);
	//printk(KERN_CRIT "ctxmon exiting.. \n");
	return;
}
