#ifndef __KERNEL__
#define __KERNEL__
#endif
#ifndef MODULE
#define MODULE
#endif


#include <linux/kernel.h> 
#include <linux/version.h>
#include <linux/module.h> 

#if defined(MODVERSIONS)
  #include <linux/modversions.h>
#endif
//#define EXPORT_SYMTAB

#include <linux/sched.h>
#include <linux/interrupt.h>
#include <linux/timer.h>
#include <linux/proc_fs.h>
#include <asm/uaccess.h>
#include <linux/kernel_stat.h>
#include <linux/types.h>
#include <linux/errno.h>
#include <linux/sched.h>
#include <linux/kernel.h>
#include <linux/kernel_stat.h>
#include <linux/tty.h>
#include <linux/string.h>
#include <linux/mman.h>
#include <linux/proc_fs.h>
#include <linux/ioport.h>
#include <linux/config.h>
#include <linux/mm.h>
#include <linux/pagemap.h>
#include <linux/swap.h>
#include <linux/slab.h>
#include <linux/smp.h>
#include <linux/signal.h>
#include <linux/module.h>
#include <linux/init.h>
#include <linux/smp_lock.h>
#include <linux/seq_file.h>
 
#include <asm/uaccess.h>
#include <asm/pgtable.h>
#include <asm/io.h>

#include "kthread.h"

#include "monitor.h"
#define DISKIO_FREQ	(2*HZ)	/* 2 sec intervals */

#define DISKIO_BUF_SIZE	SERVICE_DATA_SIZE

#define DISKIO_DATA_TYPE	FLOAT_DATA

MODULE_AUTHOR("Rajiv Ratnam");
MODULE_DESCRIPTION("Diskio_mon Module(Dproc)");
MODULE_LICENSE("GPL");

//kthread_t diskiomon_thread_data;
char diskiomon_monitor_string[DISKIO_BUF_SIZE];
static PServiceLink diskiomon_servicelink;
static int diskiomon_serviceid = -1; 

static unsigned long oldjif = 0;
static unsigned long now;

struct disk_info {

  unsigned int rio, rblk, wio, wblk;

  int active_flag;
};

struct disk_info old_dk[DK_MAX_MAJOR][DK_MAX_DISK];
void get_diskio_info();

int data(void **data_buf,int *data_len){
        get_diskio_info();
        *data_buf=(void *)diskiomon_monitor_string;
	*data_len=DISKIO_BUF_SIZE;
	return MON_OK;
}

void get_diskio_info()
{
       int len =0;
       int major, disk; 
       unsigned int rio, rblk, wio, wblk; 

       unsigned long delay =0;


       for (major = 0; major < DK_MAX_MAJOR; major++) {
                for (disk = 0; disk < DK_MAX_DISK; disk++) {
                         int active = kstat.dk_drive[major][disk] +
                                 kstat.dk_drive_rblk[major][disk] +
                                 kstat.dk_drive_wblk[major][disk];

			 /* only print stats if active */

                         if (active) {
			                rio  = kstat.dk_drive_rio[major][disk];
					rblk = kstat.dk_drive_rblk[major][disk];
					wio  = kstat.dk_drive_wio[major][disk];
					wblk = kstat.dk_drive_wblk[major][disk];

                                 len += sprintf(diskiomon_monitor_string+len, 
                                         "Major:         %8u\n"
                                         "Disk:          %8u\n"
                                         "Total I/O:     %8u\n"
                                         "Read I/O:      %8u\n"
                                         "Read Blocks:   %8u\n"
                                         "Write I/O:     %8u\n"
                                         "Write Blocks:  %8u\n\n", 
                                         major, disk,
                                         kstat.dk_drive[major][disk],
 					 rio, rblk, wio, wblk
						);

				 old_dk[major][disk].active_flag = 1;
			 }
			 else
			   old_dk[major][disk].active_flag = 0;
		}
         }


	 /* find averages */
	 now = jiffies;

	 delay = now - oldjif;

         for (major = 0; major < DK_MAX_MAJOR; major++) {
                for (disk = 0; disk < DK_MAX_DISK; disk++) {
			 /* only print stats if active */

                         if (old_dk[major][disk].active_flag) {
			                rio  = kstat.dk_drive_rio[major][disk];
					rblk = kstat.dk_drive_rblk[major][disk];
					wio  = kstat.dk_drive_wio[major][disk];
					wblk = kstat.dk_drive_wblk[major][disk];

                                 len += sprintf(diskiomon_monitor_string+len, 
					 "Major:               %8u\n"
                                         "Disk:                %8u\n"
                                         "Read I/O Avg/s:      %8lu\n"
                                         "Read Blocks Avg/s:   %8lu\n"
                                         "Write I/O Avg/s:     %8lu\n"
                                         "Write Blocks Avg/s:  %8lu\n\n", 
					  major, disk,
 					 ((rio - old_dk[major][disk].rio) * HZ) /delay, 
 					 ((rblk - old_dk[major][disk].rblk) * HZ) /delay, 
 					 ((wio - old_dk[major][disk].wio) * HZ) /delay, 
 					 ((wblk - old_dk[major][disk].wblk) * HZ) /delay
						);

				 
				 old_dk[major][disk].rio = rio;
				 old_dk[major][disk].rblk = rblk;
				 old_dk[major][disk].wio = wio;
				 old_dk[major][disk].wblk = wblk;

				 
			 }
		}
	 }
	 
	 oldjif = now;
}       int major, disk; 

#if 0
void diskiomon_thread(kthread_t *kthread)
{
	init_kthread(kthread, "diskiomon thread");
	
	diskiomon_serviceid = register_service("diskio", data, DISKIO_DATA_TYPE, &diskiomon_servicelink);
	while(1){
		/* fall asleep for one second */
                interruptible_sleep_on_timeout(&kthread->queue, DISKIO_FREQ);

                /* We need to do a memory barrier here to be sure that
                   the flags are visible on all CPUs. 
                */
                 mb();
                
                /* here we are back from sleep, either due to the timeout
                   (one second), or because we caught a signal.
                */
                if (kthread->terminate)
                {
                        /* we received a request to terminate ourself */
                        break;    
                }
                
		/*print_progress();*/

                //get_diskio_info();

		/*printk(KERN_CRIT "diskiomon_monitor = %s at time=%ld\n",diskiomon_monitor_string, jiffies);
		  print_progress();*/

	}
	
	/* cleanup the thread, leave */
        exit_kthread(kthread);
	return;
}
#endif

/* load the module */
int init_module(void)
{
       int major, disk; 
        for (major = 0; major < DK_MAX_MAJOR; major++) {
                for (disk = 0; disk < DK_MAX_DISK; disk++) {
                                 old_dk[major][disk].rio = 0;
				 old_dk[major][disk].rblk = 0;
				 old_dk[major][disk].wio = 0;
				 old_dk[major][disk].wblk = 0;
		}
	}

	/* create new kernel threads */
	//start_kthread(diskiomon_thread, &diskiomon_thread_data);

	diskiomon_serviceid = register_service("diskio", data, DISKIO_DATA_TYPE, &diskiomon_servicelink);
	return(0);
}

/* remove the module */
void cleanup_module(void)
{
	/* terminate the kernel threads */
	deregister_service(diskiomon_serviceid);
	//stop_kthread(&diskiomon_thread_data);
	//printk(KERN_CRIT "diskiomon exiting.. \n");
	return;
}
