#ifndef __KERNEL__
#define __KERNEL__
#endif
#ifndef MODULE
#define MODULE
#endif


#include <linux/kernel.h> 
#include <linux/version.h>
#include <linux/module.h> 

#if defined(MODVERSIONS)
  #include <linux/modversions.h>
#endif
//#define EXPORT_SYMTAB

#include <linux/sched.h>
#include <linux/interrupt.h>
#include <linux/timer.h>
#include <linux/proc_fs.h>
#include <asm/uaccess.h>
#include <linux/kernel_stat.h>
#include <linux/types.h>
#include <linux/errno.h>
#include <linux/sched.h>
#include <linux/kernel.h>
#include <linux/kernel_stat.h>
#include <linux/tty.h>
#include <linux/string.h>
#include <linux/mman.h>
#include <linux/proc_fs.h>
#include <linux/ioport.h>
#include <linux/config.h>
#include <linux/mm.h>
#include <linux/pagemap.h>
#include <linux/swap.h>
#include <linux/slab.h>
#include <linux/smp.h>
#include <linux/signal.h>
#include <linux/module.h>
#include <linux/init.h>
#include <linux/smp_lock.h>
#include <linux/seq_file.h>
 
#include <asm/uaccess.h>
#include <asm/pgtable.h>
#include <asm/io.h>

#include "kthread.h"

#include "monitor.h"
#define INTR_FREQ	(2*HZ)	/* 2 sec intervals */

#define INTR_BUF_SIZE	SERVICE_DATA_SIZE

#define INTR_DATA_TYPE	FLOAT_DATA


//#define MAX_INTR NR_IRQS
#define MAX_INTR 16

MODULE_AUTHOR("Rajiv Ratnam");
MODULE_DESCRIPTION("Intr_mon Module(Dproc)");
MODULE_LICENSE("GPL");

//kthread_t intrmon_thread_data;
char intrmon_monitor_string[INTR_BUF_SIZE];
static PServiceLink intrmon_servicelink;
static int intrmon_serviceid = -1; 

static unsigned long oldjif = 0;
static unsigned long now;

unsigned int old_irqs[MAX_INTR];
void get_intr_info();

int data(void **data_buf,int *data_len){
        get_intr_info();
        *data_buf=(void *)intrmon_monitor_string;
	*data_len=INTR_BUF_SIZE;
	return MON_OK;
}

void get_intr_info()
{
       int i, j, len =0;

       unsigned int sum = 0;

       unsigned int irqs[MAX_INTR];

       unsigned long delay =0;

       for (i = 0 ; i < smp_num_cpus; i++){

         int cpu = cpu_logical_map(i);

	 for (j = 0 ; j < MAX_INTR; j++){

	     sum += kstat.irqs[cpu][j];
         }
       }
 
       len = sprintf(intrmon_monitor_string, "Total:       %8u\n\n", sum);

       len += sprintf(intrmon_monitor_string+len, "IRQ :  # of interrupts\n");

       for (i = 0 ; i < MAX_INTR; i++){
       	        irqs[i] = kstat_irqs(i);
	        len += sprintf(intrmon_monitor_string+len, 
			       "%3u: %8u\n", i, irqs[i]);

       }

       /* find averages */

       len += sprintf(intrmon_monitor_string+len, "\nIRQ :  Avg # of interrupts/s\n");

       now = jiffies;

       delay = now - oldjif;

       for (i = 0 ; i < MAX_INTR; i++){
	        len += sprintf(intrmon_monitor_string+len, 
			       "%3u: %8lu\n", i, ((irqs[i] - old_irqs[i]) * HZ) /delay);
		old_irqs[i] = irqs[i];

       }

       oldjif = now;
}

#if 0
void intrmon_thread(kthread_t *kthread)
{
	init_kthread(kthread, "intrmon thread");
	
	intrmon_serviceid = register_service("intr", data, INTR_DATA_TYPE, &intrmon_servicelink);

	while(1){
		/* fall asleep for one second */
                interruptible_sleep_on_timeout(&kthread->queue, INTR_FREQ);

                /* We need to do a memory barrier here to be sure that
                   the flags are visible on all CPUs. 
                */
                 mb();
                
                /* here we are back from sleep, either due to the timeout
                   (one second), or because we caught a signal.
                */
                if (kthread->terminate)
                {
                        /* we received a request to terminate ourself */
                        break;    
                }
                
		/*print_progress();*/

                //get_intr_info();

		/*printk(KERN_CRIT "intrmon_monitor = %s at time=%ld\n",intrmon_monitor_string, jiffies);
		  print_progress();*/

	}
	
	/* cleanup the thread, leave */
        exit_kthread(kthread);
	return;
}
#endif

/* load the module */
int init_module(void)
{
        int i;
        for (i = 0; i < MAX_INTR; i++)
	  old_irqs[i] = 0;

	/* create new kernel threads */
	//start_kthread(intrmon_thread, &intrmon_thread_data);
	intrmon_serviceid = register_service("intr", data, INTR_DATA_TYPE, &intrmon_servicelink);
	return(0);
}

/* remove the module */
void cleanup_module(void)
{
	/* terminate the kernel threads */
	deregister_service(intrmon_serviceid);
	//stop_kthread(&intrmon_thread_data);
	//printk(KERN_CRIT "intrmon exiting.. \n");
	return;
}
