#ifndef _LOADAVG_H
#define _LOADAVG_H

#include "monitor.h"
#define LOADAVG_EXP_1	1884
#define LOADAVG_FSHIFT	11			/*nr of bits of precision */
#define LOADAVG_FIXED_1	(1<<LOADAVG_FSHIFT)	/* 1.0 as fixed-point */
#define LOADAVG_FREQ	(5*HZ)	

#define CALC_LOADAVG(load,exp,n) 	\
	load *= exp; 			\
	load += n*(LOADAVG_FIXED_1-exp);\
	load >>= LOADAVG_FSHIFT;

#define LOAD_INT(x)	((x) >> FSHIFT)
#define LOAD_FRAC(x)	LOAD_INT(((x) & (LOADAVG_FIXED_1-1)) * 100)

//#define LOADAVG_BUF_SIZE	16
#define LOADAVG_BUF_SIZE	SERVICE_DATA_SIZE

#define LOADAVG_DATA_TYPE	FLOAT_DATA

#endif	// _LOADAVG_H
