#ifndef MODULE
#define MODULE
#endif
#ifndef __KERNEL__
#define __KERNEL__
#endif

#include <linux/version.h>
#include <linux/module.h> 
#if defined(MODVERSIONS)
#include <linux/modversions.h>
#endif

#include <linux/kernel.h> 
//#include <linux/malloc.h>
#include "kthread.h"
#include "loadavg.h"

#define print_progress()	printk(KERN_CRIT "In %s at %s.%d\n",__FUNCTION__,__FILE__,__LINE__);

MODULE_AUTHOR("Sandip Agarwala,Rajiv Ratnam");
MODULE_DESCRIPTION("Loadavg Module(Dproc)");
MODULE_LICENSE("GPL");


//kthread_t loadavg_thread_data;
char loadavg_monitor_string[LOADAVG_BUF_SIZE];
unsigned long loadavg_monitor = 0;
static PServiceLink loadavg_servicelink;
static int loadavg_serviceid = -1;


/*
 * Nr of active tasks - counted in fixed-point numbers
**/
/*
static unsigned long count_active_tasks(void){
	struct task_struct *p;
	unsigned long nr = 0;
	read_lock(&tasklist_lock);
	for_each_task(p) {
		if ((p->state == TASK_RUNNING ||
			       (p->state & TASK_UNINTERRUPTIBLE)))
			nr += FIXED_1;
	}
	read_unlock(&tasklist_lock);
	return nr;
}
*/

int data(void **data_buf,int *data_len){
//	int a = loadavg_monitor + (LOADAVG_FIXED_1 / 200);
// Remark by sandip: Unable to make 2 sec interval work.. will try later...	
        int a = avenrun[0] + (LOADAVG_FIXED_1/200);
	sprintf(loadavg_monitor_string,"%d\n",LOAD_INT(a) * 100 + LOAD_FRAC(a));
//	printk(KERN_CRIT "loadavg=%s",loadavg_monitor_string);
	*data_buf=(void *)loadavg_monitor_string;
	*data_len=LOADAVG_BUF_SIZE;
	return MON_OK;
}

#if 0
void loadavg_thread(kthread_t *kthread)
{
	unsigned int loadavg_monitor=0,active_tasks; /* fixed-point */
	
	
	init_kthread(kthread, "loadavg thread");
	
	loadavg_serviceid = register_service("loadavg", data, LOADAVG_DATA_TYPE, &loadavg_servicelink);
	while(1){
		/* fall asleep for one second */
                interruptible_sleep_on_timeout(&kthread->queue, LOADAVG_FREQ);

                /* We need to do a memory barrier here to be sure that
                   the flags are visible on all CPUs. 
                */
                 mb();
                
                /* here we are back from sleep, either due to the timeout
                   (one second), or because we caught a signal.
                */
                if (kthread->terminate)
                {
                        /* we received a request to terminate ourself */
                        break;    
                }
                
                /* this is monitor functions */
// Note by sandip: Since we are using "avenrun", no need to do our own stuff

//		print_progress();
		active_tasks = count_active_tasks();
//		print_progress();
		CALC_LOADAVG(loadavg_monitor, LOADAVG_EXP_1, active_tasks);
//		printk(KERN_CRIT "loadavg_monitor = %d at time=%ld\n",loadavg_monitor, jiffies);
//		print_progress();

	}
	
	/* cleanup the thread, leave */
        exit_kthread(kthread);
	return;
}
#endif

/* load the module */
int init_module(void)
{
	/* create new kernel threads */
	//start_kthread(loadavg_thread, &loadavg_thread_data);
	loadavg_serviceid = register_service("loadavg", data, LOADAVG_DATA_TYPE, &loadavg_servicelink);
	return(0);
}

/* remove the module */
void cleanup_module(void)
{
	/* terminate the kernel threads */
	deregister_service(loadavg_serviceid);
	//stop_kthread(&loadavg_thread_data);
	//printk(KERN_CRIT "loadavg exiting.. \n");
	return;
}
