#ifndef __KERNEL__
#define __KERNEL__
#endif
#ifndef MODULE
#define MODULE
#endif


#include <linux/kernel.h> 
#include <linux/version.h>
#include <linux/module.h> 

#if defined(MODVERSIONS)
  #include <linux/modversions.h>
#endif
//#define EXPORT_SYMTAB

#include <linux/sched.h>
#include <linux/interrupt.h>
#include <linux/timer.h>
#include <linux/proc_fs.h>
#include <asm/uaccess.h>
#include <linux/kernel_stat.h>
#include <linux/types.h>
#include <linux/errno.h>
#include <linux/sched.h>
#include <linux/kernel.h>
#include <linux/kernel_stat.h>
#include <linux/tty.h>
#include <linux/string.h>
#include <linux/mman.h>
#include <linux/proc_fs.h>
#include <linux/ioport.h>
#include <linux/config.h>
#include <linux/mm.h>
#include <linux/pagemap.h>
#include <linux/swap.h>
#include <linux/slab.h>
#include <linux/smp.h>
#include <linux/signal.h>
#include <linux/module.h>
#include <linux/init.h>
#include <linux/smp_lock.h>
#include <linux/seq_file.h>
 
#include <asm/uaccess.h>
#include <asm/pgtable.h>
#include <asm/io.h>

#include "kthread.h"

#include "monitor.h"
#define MEMMON_FREQ	(2*HZ)	/* 2 sec intervals */

#define MEMMON_BUF_SIZE	SERVICE_DATA_SIZE

#define MEMMON_DATA_TYPE	FLOAT_DATA

MODULE_AUTHOR("Rajiv Ratnam");
MODULE_DESCRIPTION("Memmon Module(Dproc)");
MODULE_LICENSE("GPL");

//kthread_t memmon_thread_data;
char memmon_monitor_string[MEMMON_BUF_SIZE];
static PServiceLink memmon_servicelink;
static int memmon_serviceid = -1; 
void get_memory_info();

int data(void **data_buf,int *data_len){
        get_memory_info();
        *data_buf=(void *)memmon_monitor_string;
	*data_len=MEMMON_BUF_SIZE;
	return MON_OK;
}

void get_memory_info()
{
       struct sysinfo i;
       int len =0;
       int pg_size ;

/*
 * display in kilobytes.
 */
 #define K(x) ((x) << (PAGE_SHIFT - 10))
 #define B(x) ((unsigned long long)(x) << PAGE_SHIFT)

         si_meminfo(&i);
	 si_swapinfo(&i);
         pg_size = atomic_read(&page_cache_size) - i.bufferram ;
 
         /*
         len = sprintf(memmon_monitor_string, 
                 "Mem:  %8Lu Total %8Lu Used %8Lu Free %8Lu Shared %8Lu Buffer %8Lu Cached\n"
  	         "Swap:  %8Lu Total %8Lu Used %8Lu Free\n",
                 B(i.totalram), B(i.totalram-i.freeram), B(i.freeram),
                 B(i.sharedram), B(i.bufferram),
                 B(pg_size), B(i.totalswap),
                 B(i.totalswap-i.freeswap), B(i.freeswap)); 
	 
     
         len += sprintf(memmon_monitor_string+len,
	 */

         len = sprintf(memmon_monitor_string,
                 "MemTotal:     %8lu KB\n"
                 "MemFree:      %8lu KB\n"
  	         // deprecated : "MemShared:    %8lu KB\n"
                 "Buffers:      %8lu KB\n"
                 "Cached:       %8lu KB\n"
                 "SwapCached:   %8lu KB\n"
                 "Active:       %8u KB\n"
                 "Inactive:     %8u KB\n"
                 "HighTotal:    %8lu KB\n"
                 "HighFree:     %8lu KB\n"
                 "LowTotal:     %8lu KB\n"
                 "LowFree:      %8lu KB\n"
                 "SwapTotal:    %8lu KB\n"
                 "SwapFree:     %8lu KB\n",
                 K(i.totalram),
                 K(i.freeram),
		 // K(i.sharedram),
                 K(i.bufferram),
                 K(pg_size - swapper_space.nrpages),
                 K(swapper_space.nrpages),
                 K(nr_active_pages),
                 K(nr_inactive_pages),
                 K(i.totalhigh),
                 K(i.freehigh),
                 K(i.totalram-i.totalhigh),
                 K(i.freeram-i.freehigh),
                 K(i.totalswap),
                 K(i.freeswap));

 
 #undef B
 #undef K
 
}

#if 0
void memmon_thread(kthread_t *kthread)
{
	init_kthread(kthread, "memmon thread");
	
	memmon_serviceid = register_service("mem", data, MEMMON_DATA_TYPE, &memmon_servicelink);
	while(1){
		/* fall asleep for one second */
                interruptible_sleep_on_timeout(&kthread->queue, MEMMON_FREQ);

                /* We need to do a memory barrier here to be sure that
                   the flags are visible on all CPUs. 
                */
                 mb();
                
                /* here we are back from sleep, either due to the timeout
                   (one second), or because we caught a signal.
                */
                if (kthread->terminate)
                {
                        /* we received a request to terminate ourself */
                        break;    
                }
                
		/*print_progress();*/

                //get_memory_info();

		/*printk(KERN_CRIT "memmon_monitor = %s at time=%ld\n",memmon_monitor_string, jiffies);
		  print_progress();*/

	}
	
	/* cleanup the thread, leave */
        exit_kthread(kthread);
	return;
}
#endif

/* load the module */
int init_module(void)
{
	/* create new kernel threads */
	//start_kthread(memmon_thread, &memmon_thread_data);
	memmon_serviceid = register_service("mem", data, MEMMON_DATA_TYPE, &memmon_servicelink);
	return(0);
}

/* remove the module */
void cleanup_module(void)
{
	/* terminate the kernel threads */
	deregister_service(memmon_serviceid);
	//stop_kthread(&memmon_thread_data);
	//printk(KERN_CRIT "memmon exiting.. \n");
	return;
}
