#ifndef MODULE
#define MODULE
#endif
#ifndef __KERNEL__
#define __KERNEL__
#endif

#include <linux/version.h>
#include <linux/module.h> 
#if defined(MODVERSIONS)
#include <linux/modversions.h>
#endif

#include <linux/kernel.h>
#include <linux/mm.h>
#include <linux/swap.h>
#include "monitor.h"
#define K(x) ((x) << (PAGE_SHIFT - 10))
#define MEMORY_DATA_SIZE	SERVICE_DATA_SIZE
//#define MEMORY_DATA_SIZE	16

MODULE_AUTHOR("Sandip Agarwala");
MODULE_DESCRIPTION("Loadavg Module(Dproc)");
MODULE_LICENSE("GPL");

static int freemem_service_id = -1;
static char freemem_string[MEMORY_DATA_SIZE];
static PServiceLink freemem_link;

int freemem_data(void **data_buf,int *data_len){
	sprintf(freemem_string,"%d\n",K(nr_free_pages()));
	*data_buf = (void *)freemem_string;
	*data_len = MEMORY_DATA_SIZE;
	return MON_OK;
}

/* load the module */
int init_module(void)
{
	freemem_service_id = register_service("freemem", freemem_data, INT_DATA , &freemem_link);
	return(0);
}

/* remove the module */
void cleanup_module(void)
{
	/* terminate the kernel threads */
	deregister_service(freemem_service_id);
//	printk(KERN_CRIT "memory exiting.. \n");
	return;
}
