#ifndef _MONITOR_H
#define _MONITOR_H

#define MON_ERR	-1
#define MON_OK	1

#define SERVICE_NAME_SIZE	20
#define SERVICE_DATA_SIZE	1000
//#define SERVICE_DATA_SIZE	4000

#define MON_RESOLUTION	100	// 100 jiffies

#define mon_assert(expr)						\
	if(!(expr)) {							\
		printk(KERN_CRIT "Assertion failed! expr=%s in %s at %s:%d\n",	\
		#expr,__FUNCTION__,__FILE__,__LINE__);			\
		return MON_ERR;						\
	}

#define print_progress()	\
	printk(KERN_CRIT "In %s at %s.%d\n",__FUNCTION__,__FILE__,__LINE__);

// Different data types that may be returned by the publishers
enum {INT_DATA='i', FLOAT_DATA='f', STRING_DATA='s'};

typedef int (*data_t)(void **data_buf, int *data_len);

typedef struct _service_link *PServiceLink;

extern int atoi(const char *nptr);
extern int register_service(char *service_name, data_t data, 
		int data_type, PServiceLink *slink);
extern int deregister_service(int service_id);

extern struct _local_resources *poll_resources(void);

#endif // _MONITOR_H
