#ifndef _POWER_H
#define _POWER_H

#include "monitor.h"
#define POWER_EXP_1   1981
#define POWER_FSHIFT  11                      /*nr of bits of precision */
#define POWER_FIXED_1 (1<<POWER_FSHIFT)     /* 1.0 as fixed-point */
#define POWER_FREQ    (2*HZ)  /* 2 sec intervals */

#define CALC_POWER(load,exp,n)        \
        load *= exp;                    \
        load += n*(POWER_FIXED_1-exp);\
        load >>= POWER_FSHIFT;

#define POWER_INT(x)     ((x) >> FSHIFT)
#define POWER_FRAC(x)    POWER_INT(((x) & (POWER_FIXED_1-1)) * 100)

//#define POWER_BUF_SIZE      16
#define POWER_BUF_SIZE        SERVICE_DATA_SIZE

#define POWER_DATA_TYPE       FLOAT_DATA

#endif  // _POWER_H

#define MAX_COUNT_SESSIONS  5
#define COUNT_SESSIONS	5
