#ifndef __KERNEL__
#define __KERNEL__
#endif
#ifndef MODULE
#define MODULE
#endif


#include <linux/kernel.h> 
#include <linux/version.h>
#include <linux/module.h> 

#if defined(MODVERSIONS)
  #include <linux/modversions.h>
#endif
//#define EXPORT_SYMTAB

#include <linux/sched.h>
#include <linux/interrupt.h>
#include <linux/timer.h>
#include <linux/proc_fs.h>
#include <asm/uaccess.h>
#include <linux/kernel_stat.h>
#include <linux/types.h>
#include <linux/errno.h>
#include <linux/sched.h>
#include <linux/kernel.h>
#include <linux/kernel_stat.h>
#include <linux/tty.h>
#include <linux/string.h>
#include <linux/mman.h>
#include <linux/proc_fs.h>
#include <linux/ioport.h>
#include <linux/config.h>
#include <linux/mm.h>
#include <linux/pagemap.h>
#include <linux/swap.h>
#include <linux/slab.h>
#include <linux/smp.h>
#include <linux/signal.h>
#include <linux/module.h>
#include <linux/init.h>
#include <linux/smp_lock.h>
#include <linux/seq_file.h>
 
#include <asm/uaccess.h>
#include <asm/pgtable.h>
#include <asm/io.h>

#include "kthread.h"
#include "monitor.h"
#define VMMON_FREQ	(2*HZ)	/* 2 sec intervals */

#define VMMON_BUF_SIZE	SERVICE_DATA_SIZE

#define VMMON_DATA_TYPE	FLOAT_DATA

MODULE_AUTHOR("Rajiv Ratnam");
MODULE_DESCRIPTION("Vmmon Module(Dproc)");
MODULE_LICENSE("GPL");

kthread_t vmmon_thread_data;
char vmmon_monitor_string[VMMON_BUF_SIZE];
static PServiceLink vmmon_servicelink;
static int vmmon_serviceid = -1; 

static unsigned long oldjif = 0;
static unsigned long now;

unsigned int curr_page_in = 0, curr_page_out = 0, curr_swap_in = 0, curr_swap_out = 0;
void get_memory_info();

int data(void **data_buf,int *data_len){
        get_memory_info();
        *data_buf=(void *)vmmon_monitor_string;
	*data_len=VMMON_BUF_SIZE;
	return MON_OK;
}

void get_memory_info()
{
       int len =0;
       unsigned page_in =0, page_out = 0, swap_in =0, swap_out =0;

       unsigned long delay =0; 

       page_in  = kstat.pgpgin >> 1;
       page_out = kstat.pgpgout >> 1;
       swap_in  = kstat.pswpin;
       swap_in  = kstat.pswpout;


       len = sprintf(vmmon_monitor_string, 
                 "Page In:    %8u KB\n" 
                 "Page Out:   %8u KB\n"
  	         "Swap In:    %8u KB\n" 
                 "Swap Out:   %8u KB\n\n",
	         page_in,
		 page_out,  
		 swap_in, 
		 swap_out);

	 /* find averages */
	 now = jiffies;

	 delay = now - oldjif;
	 len += sprintf(vmmon_monitor_string+len, 
                                         "Avg Page In/s:    %8lu\n"
                                         "Avg Page Out/s:   %8lu\n"
			                 "Avg Swap In/s:    %8lu\n"
			                 "Avg Swap/s:       %8lu\n\n",
			((page_in - curr_page_in) * HZ) /delay, ((page_out - curr_page_out) * HZ) /delay, ((swap_in - curr_swap_in) * HZ) /delay, 
			((swap_out - curr_swap_out) * HZ) /delay
		       );
	 

	 curr_page_in = page_in;
	 curr_page_out = page_out;
	 curr_swap_in = swap_in;
	 curr_swap_out = swap_out;

	 oldjif = now;

}

#if 0
void vmmon_thread(kthread_t *kthread)
{
        init_kthread(kthread, "vmmon thread");
	
	vmmon_serviceid = register_service("vminfo", data, VMMON_DATA_TYPE, &vmmon_servicelink);
	while(1){
		/* fall asleep for one second */
                interruptible_sleep_on_timeout(&kthread->queue, VMMON_FREQ);

                /* We need to do a memory barrier here to be sure that
                   the flags are visible on all CPUs. 
                */
                 mb();
                
                /* here we are back from sleep, either due to the timeout
                   (one second), or because we caught a signal.
                */
                if (kthread->terminate)
                {
                        /* we received a request to terminate ourself */
                        break;    
                }
                
		/*print_progress();*/

                get_memory_info();

		/*printk(KERN_CRIT "vmmon_monitor = %s at time=%ld\n",vmmon_monitor_string, jiffies);
		  print_progress();*/

	}
	
	/* cleanup the thread, leave */
        exit_kthread(kthread);
	return;
}
#endif


/* load the module */
int init_module(void)
{
	/* create new kernel threads */
  //	start_kthread(vmmon_thread, &vmmon_thread_data);
        vmmon_serviceid = register_service("vminfo", data, VMMON_DATA_TYPE, &vmmon_servicelink);
	return(0);
}

/* remove the module */
void cleanup_module(void)
{
	/* terminate the kernel threads */
	deregister_service(vmmon_serviceid);
	//stop_kthread(&vmmon_thread_data);
	//printk(KERN_CRIT "vmmon exiting.. \n");
	return;
}
