#include "imgHandler.h"

/*------------------------------------------------------------------------------*/

/*
 * cropImage:
 *
 * Parameters: inImage and its size and (inRow, inCol)
 *
 * Returns: outImage
 *
 */

int 
cropImage (Raw_data* inImage, Raw_data* outImage, 
	   int inRow, int inCol, int outWidth, int outHeight)
{
  int row, col;
  int outIndx, inIndx;

  if (outImage->buff == NULL) return -1;

  outImage->width = outWidth;
  outImage->height = outHeight;
  if (inRow < 0 || inRow > inImage->height) inRow = 0;
  if (inCol < 0 || inCol > inImage->width) inCol = 0;
  if (outImage->width < 0 || outImage->width > (inImage->width - inCol)) 
    outImage->width = inImage->width - inCol; 
  if (outImage->height < 0 || outImage->height > (inImage->height - inRow)) 
    outImage->height = inImage->height - inRow; 

  outImage->ppm1 = inImage->ppm1;
  outImage->ppm2 = inImage->ppm2;
  outImage->maxval = 255;

  for (row = 0; row < outImage->height; ++row) {
    for (col = 0; col < outImage->width; ++col) {      
	outIndx = (row * outImage->width * 3) + (col * 3);
	inIndx = ((inRow + row) * inImage->width * 3) + (inCol + col) * 3;
	outImage->buff[outIndx] = inImage->buff[inIndx];
	outImage->buff[outIndx+1] = inImage->buff[inIndx+1];
	outImage->buff[outIndx+2] = inImage->buff[inIndx+2];
    }
  }
  
  return 0;
} /* end cropImage */
