#include "imgHandler.h"

/*------------------------------------------------------------------------------*/

/*
 * reduceImage:
 *
 * Parameters: inImage and reduce factor (must be greater than 1)
 *
 * Returns: outImage
 *
 */

int 
reduceImage (Raw_data* inImage, Raw_data* outImage, int n)
{
  int row, inRow, col, inCol, suprow, supcol;
  int inIndx, outIndx;
  int sumR, sumG, sumB;
  int n2 = n * n;

  outImage->ppm1 = inImage->ppm1;
  outImage->ppm2 = inImage->ppm2;
  outImage->height = inImage->height / n;
  outImage->width = inImage->width / n;
  outImage->maxval = 255;

  for ( row = 0; row < outImage->height; ++row ) {
    for (col = 0; col < outImage->width; ++col) {
      outIndx = (row * outImage->width * 3) + col * 3;
      sumR = 0; sumG = 0; sumB = 0;
      for (suprow = 0; suprow < n; ++suprow) {
	inRow = row * n + suprow;
	for (supcol = 0; supcol < n; ++supcol) {
	  inCol = col * n + supcol;
	  inIndx = (inRow * inImage->width * 3) + inCol * 3;
	  sumR = sumR + inImage->buff[inIndx+0];
	  sumG = sumG + inImage->buff[inIndx+1];
	  sumB = sumB + inImage->buff[inIndx+2];
	}
      }
      outImage->buff[outIndx+0] = sumR / n2;
      outImage->buff[outIndx+1] = sumG / n2;
      outImage->buff[outIndx+2] = sumB / n2;
    }
  }
  
  return 0;
} /* end reduceImage */



