#include "imgHandler.h"

/*------------------------------------------------------------------------------*/

/*
 * greyImage:
 *
 * Parameters: inImage and its size (width, height)
 *
 * Returns: outImage in gray
 *
 */

int 
greyImage (Raw_data* inImage, Raw_data* outImage)
{
  int col, row, indx, outIndx;

  outImage->ppm1 = inImage->ppm1;
  outImage->ppm2 = '5';		/* RPGM_MAGIC2 */
  outImage->width = inImage->width;
  outImage->height = inImage->height;
  outImage->maxval = 255;

  indx = 0;
  outIndx = 0;
  for (row = 0; row < inImage->height; ++row) {
    for ( col = 0; col < inImage->width; ++col) {
      outImage->buff[outIndx] =  
	(unsigned char) ( (0.299 * inImage->buff[indx]   +
			   0.587 * inImage->buff[indx+1] +
			   0.114 * inImage->buff[indx+2]) + 
			  0.5 );
      indx += 3;
      ++outIndx;
    }
  }
  return 0;
} /* end greyImage */
