#include "imgHandler.h"

/*------------------------------------------------------------------------------*/

/*
 * mixImage:  Mixes two images together using the specified fade factor.
 *   The fade factor may be in the  range  from  0.0  (only inImage1's image 
 *   data) to 1.0 (only inImage2's image data).  Anything in between gains a
 *   smooth blend between the two images.
 *
 * Parameters: 
 *
 * Returns: 
 *
 */

int 
mixImage (Raw_data*inImage1, Raw_data*inImage2, Raw_data*outImage, float fade)
{
  int col, row, indx;
  long longfactor;

  outImage->ppm1 = inImage1->ppm1;
  outImage->ppm2 = inImage1->ppm2;
  outImage->width = inImage1->width;
  outImage->height = inImage1->height;
  outImage->maxval = 255;

  longfactor = (long)(fade * 65536);
  indx = 0;
  for (row = 0; row < inImage1->height; ++row) {
    for (col = 0; col < inImage1->width; ++col) {

      outImage->buff[indx] = inImage1->buff[indx] + 
	(((inImage2->buff[indx] - inImage1->buff[indx]) 
	  * longfactor) >> 16);

      outImage->buff[indx+1] = inImage1->buff[indx+1] + 
	(((inImage2->buff[indx+1] - inImage1->buff[indx+1]) 
	  * longfactor) >> 16);

      outImage->buff[indx+2] = inImage1->buff[indx+2] + 
	(((inImage2->buff[indx+2] - inImage1->buff[indx+2]) 
	  * longfactor) >> 16);
      
      indx += 3;
    }
  }

  return 0;
} /* end mixImage */
