#ifndef MODULE
#define MODULE
#endif
#ifndef __KERNEL__
#define __KERNEL__
#endif

#include <linux/version.h>
#include <linux/module.h> 
#if defined(MODVERSIONS)
#include <linux/modversions.h>
#endif

#include <linux/kernel.h>
#include <linux/mm.h>
#include <linux/swap.h>
#include "ppm_qos.h"

MODULE_AUTHOR("CERCS - GaTech");
MODULE_DESCRIPTION("Control Module");
MODULE_LICENSE("GPL");

#define APP_ID "PPMSTREAM"
#define GROUP_ID "VIDEO"
#define MAX_HOSTS 100

extern int con_register(char *, char *, void *);
extern int con_unregister(char *, char *);

long qos_con(int id, int cmd, void *data) 
{
	struct _hosts *qos_hosts;
	struct task_struct *task;
 	int i;

	qos_hosts = (struct _hosts *) data;

	for (i = 0; i < MAX_HOSTS; i++) {
		if (qos_hosts[i].used == 1) {
			if (qos_hosts[i].uinfo2 != -1) {
				task = find_task_by_pid(qos_hosts[i].uinfo2);
				if (task != NULL) {
					if (qos_hosts[i].uinfo1 > 0) 
						task->rt_priority++;
					else if (qos_hosts[i].uinfo1 < 0)
						task->rt_priority--;
					if (task->rt_priority > 99)
						task->rt_priority = 99;
					if (task->rt_priority < 1)
						task->rt_priority = 1;
				} else {
					qos_hosts[i].used = 0;
				}
			}
		}
	}

 	return 0;
}

int init_module(void)
{
	con_register(APP_ID, GROUP_ID, (void *)qos_con);
	return 0;
}

void cleanup_module(void)
{
	con_unregister(APP_ID, GROUP_ID);
	return;
}
