
/*
 *   reader.c
 *
 *   Copyright (C) 2001 Christian Poellabauer
 *
 */

/* 
 *   Kernel-loadable module for event channel support
 */

/* Required definitions. */
#ifndef MODULE
#define MODULE
#endif
#ifndef __KERNEL__
#define __KERNEL__
#endif

/* Various required header files. */
#include <linux/module.h> 
#include <linux/kernel.h> 
#include <linux/tty.h>
#include <linux/unistd.h>
#include <linux/socket.h>
#include <linux/kmod.h>
#include <linux/sched.h>
#include <linux/timer.h>
#include <linux/wait.h>
#include <asm/current.h>
#include "reader.h"
#include "../../include/io.h"
#include "../../include/atl.h"
#include "../../include/cm.h"
#include "../../include/echo.h"
#include "../../include/comm_group2.h"
#include "../../include/utils.h"

MODULE_AUTHOR("Christian Poellabauer");
MODULE_DESCRIPTION("Example 1 for KECho");
MODULE_LICENSE("GPL");

#define APP_NAME1 "TEST1"
#define GRP_TYPE1 "TEST1"

//#define rdtsc(x)	__asm__ __volatile__("rdtsc \n\t" : "=A" (*(x)))

/* Prototypes. */
int init_module(void);		       
void cleanup_module(void);

/* Global variables. */
static int loop_flag = 1;
kthread_t sender_thread;

/* Handler function. */
void rhandler2(void *event,int length, void *client_data, attr_list event_attrs)
{
  printk("event data2: %ld\n", *(long *)event);
//    printk("%d bytes received\n", length);
}

/* Reader function. */
static int read_data()
{
  static comm_group_return groups2;
  static signed long sleep_time2 = 0; 
  static long a = 2;
  static EChannel rchan2;
  static CManager rcm2;
  static EControlContext rcc2;
  static ECSourceHandle rhandle2;

  init_kthread(&sender_thread, "sender");

printk("CManager_create: %d\n", current->pid);
  rcm2 = CManager_create();

printk("ECho_CM_init\n");
  rcc2 = ECho_CM_init(rcm2);

printk("matching\n");
  groups2 = matching_comm_groups(APP_NAME1, GRP_TYPE1);
printk("open\n");
  rchan2 = EChannel_open(rcc2, groups2->list[0].info);
printk("chan:%s\n", (char *)groups2->list[0].info);

//  rhandle1 = ECsource_subscribe(rchan1);

printk("sink sub\n");
  (void) ECsink_subscribe(rchan2, rhandler2, NULL);

printk("start poll\n");
  while (loop_flag == 1) {
    CMpoll_network(rcm2);
    if (sleep_time2 == 0) {
//printk("submit\n");
//      ECsubmit_event(rhandle1, &a, sizeof(a));
      a++;
      sleep_time2 = HZ;
    }
    sleep_time2 = CMtask_sleep(sleep_time2);
  }

  exit_kthread(&sender_thread);
  
  return 0;
}

/* Initialize module. */
int init_module(void) 
{
  if (start_kthread(read_data, &sender_thread) < 0) {
    printk("Thread creation failed!\n");
    return -1;
  }
  return 0;
}

/* Remove module. */
void cleanup_module(void) 
{
  loop_flag = 0;
  stop_kthread(&sender_thread);
}
