
/*
 *   reader.c
 *
 *   Copyright (C) 2001 Christian Poellabauer
 *
 */

/* 
 *   Kernel-loadable module for event channel support
 */

/* Required definitions. */
#ifndef MODULE
#define MODULE
#endif
#ifndef __KERNEL__
#define __KERNEL__
#endif

/* Various required header files. */
#include <linux/module.h> 
#include <linux/kernel.h> 
#include <linux/tty.h>
#include <linux/unistd.h>
#include <linux/socket.h>
#include <linux/kmod.h>
#include <linux/sched.h>
#include <linux/timer.h>
#include <linux/wait.h>
#include <asm/current.h>
#include "reader.h"
#include "../../include/io.h"
#include "../../include/atl.h"
#include "../../include/cm.h"
#include "../../include/echo.h"
#include "../../include/comm_group2.h"
#include "../../include/utils.h"

MODULE_AUTHOR("Christian Poellabauer");
MODULE_DESCRIPTION("Example 1 for KECho");
MODULE_LICENSE("GPL");

#define APP_NAME1 "TEST1"
#define GRP_TYPE1 "TEST1"

//#define rdtsc(x)	__asm__ __volatile__("rdtsc \n\t" : "=A" (*(x)))

/* Prototypes. */
int init_module(void);		       
void cleanup_module(void);

/* Global variables. */
static int loop_flag2 = 1;
kthread_t reader_thread;

/* Handler function. */
void rhandler1(void *event,int length, void *client_data, attr_list event_attrs)
{
  printk("event data1: %ld\n", *(long *)event);
//    printk("%d bytes received\n", length);
}

/* Reader function. */
static int read_data()
{
  static comm_group_return groups;
  static signed long sleep_time = 0; 
  static long a = 200;
  static EChannel rchan1;
  static CManager rcm1;
  static EControlContext rcc1;
  static ECSourceHandle rhandle1;

  init_kthread(&reader_thread, "reader");

printk("CManager_create: %d\n", current->pid);
  rcm1 = CManager_create();

printk("ECho_CM_init\n");
  rcc1 = ECho_CM_init(rcm1);

printk("matching\n");
  groups = matching_comm_groups(APP_NAME1, GRP_TYPE1);
printk("open\n");
  rchan1 = EChannel_open(rcc1, groups->list[0].info);
printk("chan:%s\n", (char *)groups->list[0].info);

//  rhandle1 = ECsource_subscribe(rchan1);

printk("sink sub\n");
  (void) ECsink_subscribe(rchan1, rhandler1, NULL);

printk("start poll\n");
  while (loop_flag2 == 1) {
    CMpoll_network(rcm1);
    if (sleep_time == 0) {
//printk("submit\n");
//      ECsubmit_event(rhandle1, &a, sizeof(a));
      a++;
      sleep_time = HZ;
    }
    sleep_time = CMtask_sleep(sleep_time);
  }

  exit_kthread(&reader_thread);
  
  return 0;
}

/* Initialize module. */
int init_module(void) 
{
  if (start_kthread(read_data, &reader_thread) < 0) {
    printk("Thread creation failed!\n");
    return -1;
  }
  return 0;
}

/* Remove module. */
void cleanup_module(void) 
{
  loop_flag2 = 0;
  stop_kthread(&reader_thread);
}
