
#ifndef KECHO
#define KECHO
#endif

#include "config.h"
#include "../../include/io.h"
#include "../../include/atl.h"
#include "../../include/cm.h"
#include "../../include/echo.h"
#include "../../include/comm_group2.h"

#include <stdio.h>
#include <stdlib.h>
#ifdef HAVE_UNISTD_H
#include <unistd.h>
#endif

#define APP_NAME "USER1"
#define GRP_TYPE "USER1"

#define DATASIZE 20000

void handler(void *event, int length, void *client_data, attr_list event_attrs)
{
    printf("Event: %ld\n", *(long *) event);
}

int main()
{
    EChannel uchan;
    CManager ucm;
    EControlContext ucc;
    ECSourceHandle uhandle;
    char *channel_id;
    char *group_id;
    int i;
    long a = 0;
    char *buf;
    attr_list qos_list = create_attr_list();

    buf = malloc(DATASIZE);
    memset(buf, 'A', DATASIZE);
    buf[DATASIZE-1] = '\0';
  
    ucm = CManager_create();
    ucc = ECho_CM_init(ucm);

    //uchan = EChannel_create(ucc);
    uchan = EChannel_create_attr(ucc, qos_list);

    channel_id = ECglobal_id(uchan);
    printf("Channel ID is: %s\n", channel_id);

    group_id = setup_comm_group(NULL, APP_NAME, GRP_TYPE, 30,
	"moonstone.love.org", 5015);

    assoc_group_info(group_id, channel_id, strlen(channel_id) + 1);    

    uhandle = ECsource_subscribe(uchan);
//    (void) ECsink_subscribe(uchan, handler, NULL);

    set_attr(qos_list, attr_atom_from_string("QOS_DEADLINE"), Attr_Int4, (attr_value)4);

    for (i = 0; i < 10; i++) {
	printf("send\n");
	ECsubmit_event_attr(uhandle, buf, DATASIZE, qos_list);
	if (i == 1) {
    		memset(buf, 'B', DATASIZE);
    		buf[DATASIZE-1] = '\0';
	} else if (i == 2) {
    		memset(buf, 'C', DATASIZE);
    		buf[DATASIZE-1] = '\0';
	} else if (i == 3) {
    		memset(buf, 'D', DATASIZE);
    		buf[DATASIZE-1] = '\0';

	} else if (i == 4) {
    		memset(buf, 'E', DATASIZE);
    		buf[DATASIZE-1] = '\0';

	} else if (i == 5) {
    		memset(buf, 'F', DATASIZE);
    		buf[DATASIZE-1] = '\0';

	} else if (i == 6) {
    		memset(buf, 'G', DATASIZE);
    		buf[DATASIZE-1] = '\0';

	} else if (i == 7) {
    		memset(buf, 'H', DATASIZE);
    		buf[DATASIZE-1] = '\0';
	} else {
    		memset(buf, 'I', DATASIZE);
    		buf[DATASIZE-1] = '\0';
	}

     	a++;
	CMpoll_network(ucm);
	sleep(3);
    }

    return 1;
}

