# line 146 "virtual.ops"
/* This file is generated from virtual.ops.  Do not edit directly. */

#include "config.h"
#include "drisc.h"
#include "drisc_internal.h"
#ifndef MODULE
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <malloc.h>
#else
#ifdef MODULE
#ifndef __KERNEL__
#define __KERNEL__
#endif
#endif
#include <linux/kernel.h>
#include <linux/module.h>
#include <linux/string.h>
#include "kdrisc.h"
#include "library.h"

#define printf	printk
#define malloc (void *)DAllocMM
#define realloc(a,b) (void *)DReallocMM((addrs_t)a, b)
#define free(a) DFreeMM((addrs_t) a)
#define qsort _quicksort
#endif

#define INSN_OUT(c, i) \
if (c->p->cur_ip >= c->p->code_limit) {\
   expand_drisc_buffer(c);\
}\
*(virtual_insn*)c->p->cur_ip = i;\
if (c->drisc_debug) dump_cur_drisc_insn(c);\
c->p->cur_ip = ((char*)c->p->cur_ip)+ sizeof(virtual_insn)

typedef enum {iclass_arith3, iclass_arith3i, iclass_arith2, iclass_ret, iclass_convert, iclass_loadstore, iclass_loadstorei, iclass_set, iclass_setf, iclass_mov, iclass_reti, iclass_branch, iclass_branchi, iclass_jump_to_label, iclass_jump_to_reg, iclass_jump_to_imm, iclass_push, iclass_pushi, iclass_pushf, iclass_call, iclass_nop} insn_class;
typedef struct bitv {
    short len;
    char vec[2];
} *bit_vec;

typedef struct basic_block {
    int start;
    int end;
    int label;
    int end_branch_label;
    int fall_through;
    int pred_count;
    int *pred_list;
    int succ_count;
    int *succ_list;
    bit_vec regs_used;
    bit_vec regs_defined;
    bit_vec live_at_end;
    short *reg_assigns;
} *basic_block;
    
typedef struct mach_info {
    arg_info_list arg_info;
    int bbcount;
    basic_block bblist;
} *virtual_mach_info;

struct arith3 {
    unsigned short dest;
    unsigned short src1;
    unsigned short src2;
};

struct arith3i {
    unsigned short dest;
    unsigned short src;
    long imm;
};

struct arith2 {
    unsigned short dest;
    unsigned short src;
};

struct arith1 {
    unsigned short src;
};

struct setf {
    unsigned short dest;
    double imm;
};

struct branch {
    unsigned short src1;
    unsigned short src2;
    unsigned short label;
};

struct branchi {
    unsigned short src;
    unsigned short label;
    long imm;
};

union operands {
    struct arith3 a3;
    struct arith3i a3i;
    struct arith2 a2;
    struct arith1 a1;
    struct setf sf;
    struct branch br;
    struct branchi bri;
};

typedef struct {
    char class_code;
    char insn_code;
    union operands opnds;
} virtual_insn;


static int type_of(drisc_ctx c, int vreg);

static void 
drisc_varith3(drisc_ctx c, int op3, int op, int dest, int src1, int src2)
{
    virtual_insn i;
    i.class_code = iclass_arith3;
    i.insn_code = op3;
    i.opnds.a3.dest = dest;
    i.opnds.a3.src1 = src1;
    i.opnds.a3.src2 = src2;
    INSN_OUT(c, i);
}

static void 
drisc_varith3i(drisc_ctx c, int op3, int op, int dest, int src1, long imm)
{
    virtual_insn i;
    i.class_code = iclass_arith3i;
    i.insn_code = op3;
    i.opnds.a3i.dest = dest;
    i.opnds.a3i.src = src1;
    i.opnds.a3i.imm = imm;
    INSN_OUT(c, i);
}

static void drisc_varith2(drisc_ctx c, int op3, int op, int dest, int src)
{
    virtual_insn i;
    i.class_code = iclass_arith2;
    i.insn_code = op3;
    i.opnds.a2.dest = dest;
    i.opnds.a2.src = src;
    INSN_OUT(c, i);
}

extern void virtual_ret(drisc_ctx c, int data1, int data2, int src)
{
    virtual_insn i;
    i.class_code = iclass_ret;
    i.insn_code = data1;
    i.opnds.a1.src = src;
    INSN_OUT(c, i);
}


extern void
virtual_convert(drisc_ctx c, int from_type, int to_type, 
	      int dest, int src)
{
    virtual_insn i;
    i.class_code = iclass_convert;
    i.insn_code = (unsigned)((from_type<<4) + to_type);
    i.opnds.a2.dest = dest;
    i.opnds.a2.src = src;
    INSN_OUT(c, i);
}

extern void
virtual_load(drisc_ctx c, int type, int junk, int dest, int src1, int src2)
{
    virtual_insn i;
    i.class_code = iclass_loadstore;
    i.insn_code = type;
    i.opnds.a3.dest = dest;
    i.opnds.a3.src1 = src1;
    i.opnds.a3.src2 = src2;
    INSN_OUT(c, i);
}

extern void
virtual_loadi(drisc_ctx c, int type, int junk, int dest, int src1, long imm)
{
    virtual_insn i;
    i.class_code = iclass_loadstorei;
    i.insn_code = type;
    i.opnds.a3i.dest = dest;
    i.opnds.a3i.src = src1;
    i.opnds.a3i.imm = imm;
    INSN_OUT(c, i);
}

extern void
virtual_store(drisc_ctx c, int type, int junk, int dest, int src1, int src2)
{
    virtual_insn i;
    i.class_code = iclass_loadstore;
    i.insn_code = 0x10 | type;
    i.opnds.a3.dest = dest;
    i.opnds.a3.src1 = src1;
    i.opnds.a3.src2 = src2;
    INSN_OUT(c, i);
}

extern void
virtual_storei(drisc_ctx c, int type, int junk, int dest, int src1, long imm)
{
    virtual_insn i;
    i.class_code = iclass_loadstorei;
    i.insn_code = 0x10 | type;
    i.opnds.a3i.dest = dest;
    i.opnds.a3i.src = src1;
    i.opnds.a3i.imm = imm;
    INSN_OUT(c, i);
}

extern void
virtual_mov(drisc_ctx c, int type, int junk, int dest, int src)
{
    virtual_insn i;
    i.class_code = iclass_mov;
    i.insn_code = type;
    i.opnds.a2.dest = dest;
    i.opnds.a2.src = src;
    INSN_OUT(c, i);
}

extern void
virtual_pset(drisc_ctx c, int type, int junk, int dest, long imm)
{
    virtual_insn i;
    i.class_code = iclass_set;
    i.insn_code = type;
    i.opnds.a3i.dest = dest;
    i.opnds.a3i.imm = imm;
    INSN_OUT(c, i);
}

extern void
virtual_setf(drisc_ctx c, int type, int junk, int dest, double imm)
{
    virtual_insn i;
    i.class_code = iclass_setf;
    i.insn_code = type;
    i.opnds.sf.dest = dest;
    i.opnds.sf.imm = imm;
    INSN_OUT(c, i);
}

static void
virtual_reti(drisc_ctx c, int type, int junk, long imm)
{
    virtual_insn i;
    i.class_code = iclass_reti;
    i.insn_code = type;
    i.opnds.a3i.imm = imm;
    INSN_OUT(c, i);
}

static void
virtual_branch(drisc_ctx c, int op, int type, int src1, int src2, int label)
{
    virtual_insn i;
    i.class_code = iclass_branch;
    i.insn_code = op;
    i.opnds.br.src1 = src1;
    i.opnds.br.src2 = src2;
    i.opnds.br.label = label;
    INSN_OUT(c, i);
}

static void
virtual_branchi(drisc_ctx c, int op, int type, int src, long imm, int label)
{
    virtual_insn i;
    i.class_code = iclass_branchi;
    i.insn_code = op;
    i.opnds.bri.src = src;
    i.opnds.bri.imm = imm;
    i.opnds.bri.label = label;
    INSN_OUT(c, i);
}

static void
virtual_jump_to_label(drisc_ctx c, unsigned long label)
{
    virtual_insn i;
    i.class_code = iclass_jump_to_label;
    i.insn_code = 0;
    i.opnds.br.label = (unsigned short) label;
    INSN_OUT(c, i);
}

extern void virtual_jump_to_reg(drisc_ctx c, unsigned long reg)
{
    virtual_insn i;
    i.class_code = iclass_jump_to_reg;
    i.insn_code = 0;
    i.opnds.br.src1 = (unsigned short) reg;
    INSN_OUT(c, i);
}

extern void virtual_jump_to_imm(drisc_ctx c, unsigned long imm)
{
    virtual_insn i;
    i.class_code = iclass_jump_to_imm;
    i.insn_code = 0;
    i.opnds.bri.imm = imm;
    INSN_OUT(c, i);
}

extern int virtual_calli(drisc_ctx c, int type, void *xfer_address)
{
    virtual_insn i;
    i.class_code = iclass_call;
    i.insn_code = type;
    if (type != DR_V) i.opnds.bri.src = dr_getvreg(c, type);
    i.opnds.bri.imm = (long)xfer_address;
    INSN_OUT(c, i);
    return i.opnds.bri.src;
}

extern int virtual_callr(drisc_ctx c, int type, int src)
{
    virtual_insn i;
    i.class_code = iclass_call;
    i.insn_code = 0x10 | type;
    if (type != DR_V) i.opnds.bri.src = dr_getvreg(c, type);
    i.opnds.bri.imm = src;
    INSN_OUT(c, i);
    return i.opnds.bri.src;
}

extern void virtual_push(drisc_ctx c, int type, int reg)
{
    virtual_insn i;
    i.class_code = iclass_push;
    i.insn_code = type;
    i.opnds.a1.src = reg;
    INSN_OUT(c, i);
}

extern void virtual_pushi(drisc_ctx c, int type, long value)
{
    virtual_insn i;
    i.class_code = iclass_pushi;
    i.insn_code = type;
    i.opnds.a3i.imm = value;
    INSN_OUT(c, i);
}

extern void virtual_pushfi(drisc_ctx c, int type, double value)
{
    virtual_insn i;
    i.class_code = iclass_pushf;
    i.insn_code = type;
    i.opnds.sf.imm = value;
    INSN_OUT(c, i);
}

static int
virtual_init_disassembly_info(drisc_ctx c, void *ptr)
{
    return 1;
}

extern char *arith3_name[];
extern char *arith2_name[];
extern char *drisc_type_names[];
extern char *branch_op_names[];

static int
virtual_print_insn(drisc_ctx c, void *info_ptr, void *i)
{
    virtual_insn *insn = (virtual_insn *)i;
    switch(insn->class_code) {
    case iclass_arith3:
        printf("%s %d, %d, %d", arith3_name[(int)insn->insn_code], insn->opnds.a3.dest,
	       insn->opnds.a3.src1, insn->opnds.a3.src2);
        break;
    case iclass_arith3i:
        printf("%si %d, %d, %ld", arith3_name[(int)insn->insn_code], insn->opnds.a3i.dest,
	       insn->opnds.a3i.src, insn->opnds.a3i.imm);
        break;
    case iclass_arith2:
        printf("%s %d, %d", arith2_name[(int)insn->insn_code], insn->opnds.a2.dest,
	       insn->opnds.a2.src);
        break;
    case iclass_convert:
    {
	int from_index = (insn->insn_code >> 4) & 0xf;
	int to_index = insn->insn_code & 0xf;
        printf("cv%s2%s %d, %d", drisc_type_names[from_index],
	       drisc_type_names[to_index], insn->opnds.a2.dest,
	       insn->opnds.a2.src);
        break;
    }
    case iclass_loadstore:
    {
	int typ = insn->insn_code & 0xf;
	int store = insn->insn_code >> 4;
        printf("%s%si %d, %d, %d", store == 0 ? "ld" : "st", 
	       drisc_type_names[typ], insn->opnds.a3.dest,
	       insn->opnds.a3.src1, insn->opnds.a3.src2);
        break;
    }
    case iclass_loadstorei:
    {
	int typ = insn->insn_code & 0xf;
	int store = insn->insn_code >> 4;
        printf("%s%si %d, %d, %d", store == 0 ? "ld" : "st", 
	       drisc_type_names[typ], insn->opnds.a3i.dest,
	       insn->opnds.a3i.src, (int)insn->opnds.a3i.imm);
        break;
    }
    case iclass_set:
    {
	int typ = insn->insn_code & 0xf;
        printf("set%s %d, %d", 
	       drisc_type_names[typ], insn->opnds.a3i.dest,
	       (int)insn->opnds.a3i.imm);
        break;
    }
    case iclass_setf:
    {
	int typ = insn->insn_code & 0xf;
        printf("set%s %d, %g 0x(%lx)", 
	       drisc_type_names[typ], insn->opnds.sf.dest,
	       insn->opnds.sf.imm, (long unsigned int)insn->opnds.sf.imm);
        break;
    }
    case iclass_mov:
    {
	int typ = insn->insn_code & 0xf;
        printf("mov%s %d, %d", 
	       drisc_type_names[typ], insn->opnds.a2.dest,
	       insn->opnds.a2.src);
        break;
    }
    case iclass_reti:
    {
	int typ = insn->insn_code & 0xf;
        printf("ret%si %d", 
	       drisc_type_names[typ], (int)insn->opnds.a3i.imm);
        break;
    }
    case iclass_ret:
    {
	int typ = insn->insn_code & 0xf;
        printf("ret%s %d", 
	       drisc_type_names[typ], insn->opnds.a1.src);
        break;
    }
    case iclass_branch:
    {
	int br_op = insn->insn_code;
        printf("b%s %d, %d, L%d", branch_op_names[br_op], 
	       insn->opnds.br.src1, 
	       insn->opnds.br.src2, insn->opnds.br.label);
        break;
    }
    case iclass_branchi:
    {
	int br_op = insn->insn_code;
        printf("b%si %d, %d, L%d", branch_op_names[br_op], 
	       insn->opnds.bri.src, 
	       (int)insn->opnds.bri.imm, insn->opnds.bri.label);
        break;
    }
    case iclass_jump_to_label:
    {
        printf("br L%d", insn->opnds.br.label);
        break;
    }
    case iclass_jump_to_reg:
    {
        printf("jmp %d", insn->opnds.br.src1);
        break;
    }
    case iclass_jump_to_imm:
    {
        printf("jmp 0x%lx", insn->opnds.bri.imm);
        break;
    }
    case iclass_call:
    {
	int typ = insn->insn_code & 0xf;
	int reg = insn->insn_code & 0x10;
	if (typ != DR_V) {
	    if (reg != 0) {
		printf("call%s R%d, R%d", drisc_type_names[typ], 
		       (int)insn->opnds.bri.imm, insn->opnds.bri.src);
	    } else {
		printf("call%s 0x%lx, R%d", drisc_type_names[typ], 
		       insn->opnds.bri.imm, insn->opnds.bri.src);
	    }
	} else {
	    if (reg != 0) {
		printf("call%s R%d", drisc_type_names[typ], 
		       (int)insn->opnds.bri.imm);
	    } else {
		printf("call%s 0x%lx", drisc_type_names[typ], 
		       insn->opnds.bri.imm);
	    }
	}
        break;
    }
    case iclass_push:
    {
	int typ = insn->insn_code & 0xf;
        printf("push%s %d", drisc_type_names[typ], insn->opnds.a1.src);
        break;
    }
    case iclass_pushi:
    {
	int typ = insn->insn_code & 0xf;
        printf("push%si 0x%lx", drisc_type_names[typ], insn->opnds.a3i.imm);
        break;
    }
    case iclass_pushf:
    {
	int typ = insn->insn_code;
        printf("push%si %g", drisc_type_names[typ], insn->opnds.sf.imm);
        break;
    }
    case iclass_nop:
	printf("nop");
    }
    return sizeof(*insn);
}

static void
pushpop_inuse_regs(drisc_ctx c, int pop, virtual_insn *ip)
{
    int i = 0;
    /* no actual reg assigns, so only the params are in use */
    for(i=0; i<c->p->c_param_count; i++) {
	if (c->p->c_param_args[i].is_register) {
	    c->j->save_restore(c, pop, c->p->c_param_args[i].type,
			       c->p->c_param_args[i].in_reg);
	}
    }
}


#define end_bb(b, lab, f) \
bb->end_branch_label = lab;\
bb->fall_through = f;\
bb->end = i - 1;\
vmi->bbcount++;\
vmi->bblist = realloc(vmi->bblist, sizeof(struct basic_block) * (vmi->bbcount +1));\
bb = &vmi->bblist[vmi->bbcount];\
bb->start = i;\
bb->label = -1;\
bb->regs_used = new_bit_vec(c->p->vreg_count);\
bb->regs_defined = new_bit_vec(c->p->vreg_count);

static bit_vec
new_bit_vec(int max)
{
    int len = (max +7) >> 3;
    bit_vec ret = malloc(sizeof(struct bitv) + len - 2);
    ret->len = len;
    memset(&ret->vec[0], 0, len);
    return ret;
}

static void
bit_vec_set(bit_vec v, int bit)
{
    int index = bit >> 3;
    int mask = 1 << (bit & 0x7);
    v->vec[index] |= mask;
}

static int
bit_vec_is_set(bit_vec v, int bit)
{
    int index = bit >> 3;
    int mask = 1 << (bit & 0x7);
    return ((v->vec[index] & mask) == mask);
}

static void
dump_reg_vec(bit_vec v)
{
    int i;
    for (i=0; i < v->len; i++) {
	int j;
	for (j=0; j < 7; j++) {
	    if ((v->vec[i] & (1 << j)) != 0) {
		printf(" R%d", i * 8 + j + 100);
	    }
	}
    }
}

static void bb_defines(basic_block bb, int vreg)
{
    if (vreg >= 100) {
	/* not param */
	if (!bit_vec_is_set(bb->regs_used, vreg - 100)) {
	    bit_vec_set(bb->regs_defined, vreg - 100);
	}
    }
}

static void bb_uses(basic_block bb, int vreg)
{
    if (vreg >= 100) {
	/* not param */
	if (!bit_vec_is_set(bb->regs_defined, vreg - 100)) {
	    bit_vec_set(bb->regs_used, vreg - 100);
	}
    }
}

static void
add_pred(basic_block bb, int pred)
{
    bb->pred_list = realloc(bb->pred_list, (bb->pred_count+1) * sizeof(int));
    bb->pred_list[bb->pred_count] = pred;
    bb->pred_count++;
}

static void
dump_bbs(drisc_ctx c)
{
    virtual_mach_info vmi = (virtual_mach_info)c->p->mach_info;
    int i, j;
    for (i=0; i < vmi->bbcount; i++) {
	printf("\nBasic block %d, start %d, end %d, label %d, fall %d, branch_to %d\n",
	       i, vmi->bblist[i].start, vmi->bblist[i].end, 
	       vmi->bblist[i].label, vmi->bblist[i].fall_through,
	       vmi->bblist[i].end_branch_label);
	printf("    defines :"); dump_reg_vec(vmi->bblist[i].regs_defined);
	printf("\n    uses :"); dump_reg_vec(vmi->bblist[i].regs_used);
	printf("\n    live_at_end :"); dump_reg_vec(vmi->bblist[i].live_at_end);
	printf("\n    succ :"); 
	for (j=0; j < vmi->bblist[i].succ_count; j++) {
	    printf(" %d", vmi->bblist[i].succ_list[j]);
	}
	printf("\n    preds :"); 
	for (j=0; j < vmi->bblist[i].pred_count; j++) {
	    printf(" %d", vmi->bblist[i].pred_list[j]);
	}
	printf("\n");
	for (j = vmi->bblist[i].start; j <= vmi->bblist[i].end; j++) {
	    printf(" %d - ", j);
	    virtual_print_insn(c, NULL, ((char *)c->p->code_base) + 
			       j * sizeof(virtual_insn));
	    printf("\n");
	}
    }
}

static int
add_regs(bit_vec dest, bit_vec src)
{
    int change = 0;
    int i, len = dest->len;
    if (len > src->len) i = src->len;
    for (i=0; i < len; i++) {
	char tmp = (dest->vec[i] | src->vec[i]);
	if (tmp != dest->vec[i]) {
	    change = 1;
	    dest->vec[i] = tmp;
	}
    }
    return change;
}

static void
remove_regs(bit_vec dest, bit_vec src)
{
    int i, len = dest->len;
    if (len > src->len) i = src->len;
    for (i=0; i < len; i++) {
	dest->vec[i] = (dest->vec[i] & ~src->vec[i]);
    }
}

static void
clear_bit_vec(bit_vec b)
{
    memset(&b->vec[0], 0, b->len);
}

static void
build_live(drisc_ctx c)
{
    virtual_mach_info vmi = (virtual_mach_info)c->p->mach_info;
    int i, change = 1;
    bit_vec live_at_begin = new_bit_vec(c->p->vreg_count);
    for (i=0; i < vmi->bbcount; i++) {
	basic_block bb = &vmi->bblist[i];
	bb->live_at_end = new_bit_vec(c->p->vreg_count);
    }
    for (i= 0; i < vmi->bbcount; i++) {
	basic_block bb = &vmi->bblist[i];
	int j;
	for (j = 0 ; j < bb->pred_count; j++) {
	    /* foreach predecessor add regs we use to preds live_at_end */
	    basic_block pred_bb = &vmi->bblist[bb->pred_list[j]];
	    (void) add_regs(pred_bb->live_at_end, bb->regs_used);
	}
    }
    while (change) {

	/* go through the bbs until live lists stabilize */
	change = 0;
	for (i= 0; i < vmi->bbcount; i++) {
	    basic_block bb = &vmi->bblist[i];
	    int j;

	    clear_bit_vec(live_at_begin);
	    add_regs(live_at_begin, bb->live_at_end);
	    remove_regs(live_at_begin, bb->regs_defined);
	    for (j = 0 ; j < bb->pred_count; j++) {
		/* 
		 * foreach predecessor add regs live at our beginning 
		 * to preds live_at_end 
		 */
		basic_block pred_bb = &vmi->bblist[bb->pred_list[j]];
		change |= add_regs(pred_bb->live_at_end, live_at_begin);
	    }
	}
    }
    free(live_at_begin);
}

static void
free_bbs(virtual_mach_info vmi)
{
    int i;
    for (i=0 ; i < vmi->bbcount; i++) {
	basic_block bb = &vmi->bblist[i];
	if (bb->pred_list) free(bb->pred_list);
	if (bb->succ_list) free(bb->succ_list);
	free(bb->regs_used);
	free(bb->regs_defined);
	free(bb->live_at_end);
	free(bb->reg_assigns);
    }
    if (vmi->bblist) free(vmi->bblist);
    vmi->bblist = NULL;
    vmi->bbcount = 0;
}

static void
build_bbs(drisc_ctx c, void *vinsns, void *code_end)
{
    virtual_mach_info vmi = (virtual_mach_info)c->p->mach_info;
    basic_block bb;
    int i, j;
    virtual_insn *insn, *insns = vinsns;
    struct branch_table *t = &c->p->branch_table;

    vmi->bbcount = 0;
    vmi->bblist = malloc(sizeof(struct basic_block));
    i = 0;
    bb = vmi->bblist;
    bb->start = 0;
    bb->label = -1;
    bb->regs_used = new_bit_vec(c->p->vreg_count);
    bb->regs_defined = new_bit_vec(c->p->vreg_count);
    while((insn = &insns[i++]) < (virtual_insn *)code_end) {
	switch(insn->class_code) {
	case iclass_arith3:
	    bb_defines(bb,  insn->opnds.a3.dest);
	    bb_uses(bb, insn->opnds.a3.src1);
	    bb_uses(bb, insn->opnds.a3.src2);
	    break;
	case iclass_arith3i:
	    bb_defines(bb, insn->opnds.a3i.dest);
	    bb_uses(bb, insn->opnds.a3i.src);
	    break;
	case iclass_arith2:
	    bb_defines(bb, insn->opnds.a2.dest);
	    bb_uses(bb, insn->opnds.a2.src);
	    break;
	case iclass_convert:
	    bb_defines(bb, insn->opnds.a2.dest);
	    bb_uses(bb, insn->opnds.a2.src);
	    break;
	case iclass_loadstorei:
	    if (insn->insn_code >> 4) {
		/* store */
		bb_uses(bb, insn->opnds.a3i.dest);
	    } else {
		bb_defines(bb, insn->opnds.a3i.dest);
	    }
	    break;
	case iclass_set:
	    bb_defines(bb, insn->opnds.a3i.dest);
	    break;
	case iclass_setf:
	    bb_defines(bb, insn->opnds.sf.dest);
	    break;
	case iclass_mov:
	    bb_defines(bb, insn->opnds.a2.dest);
	    bb_uses(bb, insn->opnds.a2.src);
	    break;
	case iclass_reti:
	    break;
	case iclass_ret:
	    bb_uses(bb, insn->opnds.a1.src);
	    break;
	case iclass_branch:
	    bb_uses(bb, insn->opnds.br.src1);
	    bb_uses(bb, insn->opnds.br.src2);
	    end_bb(bb, insn->opnds.br.label, 1);
	    break;
	case iclass_branchi:
	    bb_uses(bb, insn->opnds.bri.src);
	    end_bb(bb, insn->opnds.bri.label, 1);
	    break;
	case iclass_jump_to_label:
	    end_bb(bb, insn->opnds.br.label, 0);
	    break;
	case iclass_jump_to_reg:
	    end_bb(bb, -1, 0);
	    break;
	case iclass_jump_to_imm:
	    end_bb(bb, -1, 0);
	    break;
	case iclass_call:
	{
	    int typ = insn->insn_code & 0xf;
	    end_bb(bb, -1, 1);
	    /* put the return register definition in the next bb */
	    if (typ != DR_V) {
		bb_defines(bb, insn->opnds.bri.src);
	    }
	    break;
	}
	case iclass_push:
	    if (insn->opnds.a1.src != 0xffff) 
		bb_uses(bb, insn->opnds.a1.src);
	    break;
	case iclass_pushi:
	    break;
	case iclass_pushf:
	    break;
	case iclass_nop:
	    break;
	}
	for (j=0; j < t->next_label; j++) {
	    if ((unsigned)t->label_locs[j] == 
		((char*)insn - (char*)insns) + sizeof(virtual_insn)) {
		if (bb->start != i) {
		    end_bb(bb, -1, 1);
		}
		bb->label = j;
	    }
	}
    }
    end_bb(bb, -1, 0);
    free(bb->regs_used);
    free(bb->regs_defined);
    (bb - 1) ->end--;
    for (i=0; i < vmi->bbcount; i++) {
	basic_block bb = &vmi->bblist[i];
	bb->pred_count = bb->succ_count = 0;
	bb->succ_list = malloc(2* sizeof(int));
	bb->pred_list = malloc(sizeof(int));
    }
    for (i=0; i < vmi->bbcount; i++) {
	basic_block bb = &vmi->bblist[i];
	if (bb->fall_through) {
	    bb->succ_list[bb->succ_count] = i+1;
	    bb->succ_count++;
	    add_pred(&vmi->bblist[i+1], i);
	}
	if (bb->end_branch_label != -1) {
	    int j;
	    for (j=0; j < vmi->bbcount; j++) {
		if (vmi->bblist[j].label == bb->end_branch_label) {
		    bb->succ_list[bb->succ_count] = j;
		    bb->succ_count++;
		    add_pred(&vmi->bblist[j], i);
		    j = vmi->bbcount;
		}
	    }
	}
    }
    build_live(c);
}


typedef void (*bv_func)(int bit, void *p1, void *p2);

static void
do_reg_assign(int bit, basic_block bb, drisc_ctx c)
{
    /* no local preg for live registers */
    int preg;
    if (bit_vec_is_set(bb->live_at_end, bit)) {
	c->p->vregs[bit].need_assign = 1;
	return;
    }
    if (dr_getreg(c, &preg, c->p->vregs[bit].typ, DR_TEMP) == 0) {
	c->p->vregs[bit].need_assign = 1;
	bb->reg_assigns[bit] = -1;
	if (c->drisc_debug)
	    printf("No more tmp regs for virtual reg %d\n", bit + 100);
    } else {
	bb->reg_assigns[bit] = preg;
	if (c->drisc_debug)
	    printf("virtual reg %d assigned to preg %d\n",
		   bit + 100, bb->reg_assigns[bit]);
    }
}

void foreach_bit(bit_vec v, bv_func func, void *p1, void *p2)
{
    int i;
    for (i=0; i< v->len; i++) {
	int j;
	for (j = 0; j < 2; j++) {
	    unsigned char nibble = (v->vec[i] >> (j * 4)) & 0xf;
	    switch(nibble) {
	    case 0xf:
		func(i * 8 + j * 4 + 3, p1, p2);
		func(i * 8 + j * 4 + 2, p1, p2);
		func(i * 8 + j * 4 + 1, p1, p2);
		func(i * 8 + j * 4 + 0, p1, p2);
		break;
	    case 0xe:
		func(i * 8 + j * 4 + 3, p1, p2);
		func(i * 8 + j * 4 + 2, p1, p2);
		func(i * 8 + j * 4 + 1, p1, p2);
		break;
	    case 0xd:
		func(i * 8 + j * 4 + 3, p1, p2);
		func(i * 8 + j * 4 + 2, p1, p2);
		func(i * 8 + j * 4 + 0, p1, p2);
		break;
	    case 0xc:
		func(i * 8 + j * 4 + 3, p1, p2);
		func(i * 8 + j * 4 + 2, p1, p2);
		break;
	    case 0xb:
		func(i * 8 + j * 4 + 3, p1, p2);
		func(i * 8 + j * 4 + 1, p1, p2);
		func(i * 8 + j * 4 + 0, p1, p2);
		break;
	    case 0xa:
		func(i * 8 + j * 4 + 3, p1, p2);
		func(i * 8 + j * 4 + 1, p1, p2);
		break;
	    case 0x9:
		func(i * 8 + j * 4 + 3, p1, p2);
		func(i * 8 + j * 4 + 0, p1, p2);
		break;
	    case 0x8:
		func(i * 8 + j * 4 + 3, p1, p2);
		break;
	    case 0x7:
		func(i * 8 + j * 4 + 2, p1, p2);
		func(i * 8 + j * 4 + 1, p1, p2);
		func(i * 8 + j * 4 + 0, p1, p2);
		break;
	    case 0x6:
		func(i * 8 + j * 4 + 2, p1, p2);
		func(i * 8 + j * 4 + 1, p1, p2);
		break;
	    case 0x5:
		func(i * 8 + j * 4 + 2, p1, p2);
		func(i * 8 + j * 4 + 0, p1, p2);
		break;
	    case 0x4:
		func(i * 8 + j * 4 + 2, p1, p2);
		break;
	    case 0x3:
		func(i * 8 + j * 4 + 1, p1, p2);
		func(i * 8 + j * 4 + 0, p1, p2);
		break;
	    case 0x2:
		func(i * 8 + j * 4 + 1, p1, p2);
		break;
	    case 0x1:
		func(i * 8 + j * 4 + 0, p1, p2);
		break;
	    case 0x0:
		break;
	    }
	}
    }
}

static void
do_register_assign(drisc_ctx c, void *insns, void *code_end, int vlp,
		   virtual_mach_info vmi)
{
    int i;
    int itmpa, itmpb, dtmpa, dtmpb;

    dr_getreg(c, &itmpa, DR_L, DR_TEMP);
    dr_getreg(c, &itmpb, DR_L, DR_TEMP);
    dr_getreg(c, &dtmpa, DR_D, DR_TEMP);
    dr_getreg(c, &dtmpb, DR_D, DR_TEMP);
    for (i=0; i< DR_B; i++) {
	switch(i) {
	case DR_D:
	case DR_F:
	    c->p->v_tmps[i][0] = dtmpa;
	    c->p->v_tmps[i][1] = dtmpb;
	    break;
	default:
	    c->p->v_tmps[i][0] = itmpa;
	    c->p->v_tmps[i][1] = itmpb;
	    break;
	}
    }
    
    for (i= 0; i < vmi->bbcount; i++) {
	basic_block bb = &vmi->bblist[i];
	int j;
	bb->reg_assigns = malloc(sizeof(short) * c->p->vreg_count);
	memset(bb->reg_assigns, 0xff, sizeof(short) * c->p->vreg_count);
	foreach_bit(bb->regs_defined, (bv_func) do_reg_assign, bb, c);
	for (j = 0 ; j < c->p->vreg_count; j++) {
	    if (bb->reg_assigns[j] != -1) {
		dr_putreg(c, bb->reg_assigns[j], c->p->vregs[j].typ);
	    }
	}
    }

    for(i=0; i< c->p->vreg_count; i++) {
	if (i == (vlp - 100) ) {
	    c->p->vregs[i].preg = c->dr_lp;
	    c->p->vregs[i].offset = 0;
	} else if (c->p->vregs[i].typ == DR_B) {
	    /* block, size stored in offset value */
	    int size = c->p->vregs[i].offset;
	    c->p->vregs[i].preg = -1;
	    c->p->vregs[i].offset = dr_localb(c, size);
	} else {
	    c->p->vregs[i].preg = -1;
	    if (c->p->vregs[i].typ != DR_V) {
		c->p->vregs[i].offset = dr_local(c, c->p->vregs[i].typ);
	    } else {
		printf("internal void register error\n");
	    }
	}
    }
}

static int
preg_of(drisc_ctx c, basic_block bb, int vreg)
{
    if (vreg >= 100) {
	if (bb->reg_assigns[vreg - 100] == -1) {
	    return c->p->vregs[vreg - 100].preg;
	} else {
	    return bb->reg_assigns[vreg - 100];
	}
    } else {
	/* parameter */;
	if (c->p->c_param_args[vreg].is_register) {
	    return c->p->c_param_args[vreg].in_reg;
	}
	return -1;
    }
}

static int
offset_of(drisc_ctx c, int vreg)
{
    if (vreg >= 100) {
	return c->p->vregs[vreg - 100].offset;
    } else {
	/* parameter */;
	return c->p->c_param_args[vreg].offset;
    }
}

extern void
dr_virtual_lea(drisc_ctx c, int dest, int src)
{
    int offset;
    if (src < 100) {
	printf("error, attempt to do dr_virtual_lea on non-virtual\n");
	return;
    }
    if (type_of(c, src) != DR_B) {
	printf("error, attempt to do dr_virtual_lea on variable of type other than V_B\n");
	return;
    }
    offset = offset_of(c, src);
    if (offset == 0) {
	dr_movp(c, dest, dr_lp(c));
    } else {
	dr_addpi(c, dest, dr_lp(c), offset);
    }
}

static int
type_of(drisc_ctx c, int vreg)
{
    if (vreg >= 100) {
	return c->p->vregs[vreg - 100].typ;
    } else {
	return c->p->c_param_args[vreg].type;
    }
}

static int
load_oprnd(drisc_ctx c, int tmp_num, int vreg)
{
    int offset = offset_of(c, vreg);
    int typ = type_of(c, vreg);
    int tmp = c->p->v_tmps[typ][tmp_num];
    c->j->loadi(c, typ, 0, tmp, c->dr_lp, offset);
    return tmp;
}    

static int
store_oprnd(drisc_ctx c, int tmp_num, int vreg)
{
    int offset = offset_of(c, vreg);
    int typ = type_of(c, vreg);
    int tmp = c->p->v_tmps[typ][tmp_num];
    c->j->storei(c, typ, 0, tmp, c->dr_lp, offset);
    return tmp;
}    

typedef struct label_translation {
    int old_location;
    int old_label;
    int new_label;
} *label_translation_table;

static int
get_new_label(int old_label, label_translation_table ltable)
{
    while (ltable->old_location != 0) {
	if (ltable->old_label == old_label) return ltable->new_label;
	ltable++;
    }
    printf("New label not found\n");
    return -1;
}

static void
emit_insns(drisc_ctx c, void *insns, label_translation_table ltable,
	   virtual_mach_info vmi)
{
    int label_xlate = 0;
    int i, j=0;
    virtual_insn *ip;

    for (i = 0; i < vmi->bbcount; i++) {
	basic_block bb = &vmi->bblist[i];
	for (j = bb->start; j <= bb->end; j++) {
	    int loc;
	    ip = &((virtual_insn *)insns)[j];
	    loc = ((char*)ip - (char*)insns);
	    if ((loc != 0) && (ltable[label_xlate].old_location == loc)) {
		dr_label(c, ltable[label_xlate].new_label);
		label_xlate++;
	    }
	    if (c->drisc_debug) {
		printf("   v    ");
		virtual_print_insn(c, NULL, ip);
		printf("\n");
	    }
	    switch(ip->class_code) {
	    case iclass_arith3: {
		/* arith 3 operand integer insns */
		int dest_vreg = ip->opnds.a3.dest;
		int src1_vreg = ip->opnds.a3.src1;
		int src2_vreg = ip->opnds.a3.src2;
		int dest_preg = preg_of(c, bb, dest_vreg);
		int src1_preg = preg_of(c, bb, src1_vreg);
		int src2_preg = preg_of(c, bb, src2_vreg);
		if (src1_preg == -1) {
		    /* load src1 */
		    src1_preg = load_oprnd(c, 0, src1_vreg);
		}
		if (src2_preg == -1) {
		    /* load src2 */
		    src2_preg = load_oprnd(c, 1, src2_vreg);
		}
		if (dest_preg == -1) {
		    dest_preg = c->p->v_tmps[type_of(c, dest_vreg)][0];
		}
		( c->j->jmp_a3)[(int)ip->insn_code](c,
					       c->j->a3_data[(int)ip->insn_code].data1,
					       c->j->a3_data[(int)ip->insn_code].data2,
					       dest_preg, src1_preg, src2_preg);
		if (preg_of(c, bb, dest_vreg) == -1) {
		    /* no dest reg, store result */
		    store_oprnd(c, 0, dest_vreg);
		}
	    }
	    break;
	    case iclass_arith2: {
		/* arith 2 operand integer insns */
		int dest_vreg = ip->opnds.a2.dest;
		int src_vreg = ip->opnds.a2.src;
		int dest_preg = preg_of(c, bb, dest_vreg);
		int src_preg = preg_of(c, bb, src_vreg);
		if (src_preg == -1) {
		    /* load src */
		    src_preg = load_oprnd(c, 0, src_vreg);
		}
		if (dest_preg == -1) {
		    dest_preg = c->p->v_tmps[type_of(c, dest_vreg)][0];
		}
		( c->j->jmp_a2)[(int)ip->insn_code](c,
					       c->j->a2_data[(int)ip->insn_code].data1,
					       c->j->a2_data[(int)ip->insn_code].data2,
					       dest_preg, src_preg);
		if (preg_of(c, bb, dest_vreg) == -1) {
		    /* no dest reg, store result */
		    store_oprnd(c, 0, dest_vreg);
		}
	    }
	    break;
	    case iclass_arith3i:
	    {
		/* arith 3 immediate operand integer insns */
		int dest_vreg = ip->opnds.a3i.dest;
		int src_vreg = ip->opnds.a3i.src;
		long imm = ip->opnds.a3i.imm;
		int dest_preg = preg_of(c, bb, dest_vreg);
		int src_preg = preg_of(c, bb, src_vreg);
		if (src_preg == -1) {
		    /* load src */
		    src_preg = load_oprnd(c, 0, src_vreg);
		}
		if (dest_preg == -1) {
		    dest_preg = c->p->v_tmps[type_of(c, dest_vreg)][0];
		}
		( c->j->jmp_a3i)[(int)ip->insn_code](c,
						c->j->a3i_data[(int)ip->insn_code].data1,
						c->j->a3i_data[(int)ip->insn_code].data2,
						dest_preg, src_preg, imm);
		if (preg_of(c, bb, dest_vreg) == -1) {
		    /* no dest reg, store result */
		    store_oprnd(c, 0, dest_vreg);
		}
	    }
	    break;
	    case iclass_ret:{
		/* arith  operand integer insns */
		int src_vreg = ip->opnds.a1.src;
		int src_preg = preg_of(c, bb, src_vreg);
		if (src_preg == -1) {
		    /* load src */
		    src_preg = load_oprnd(c, 0, src_vreg);
		}
		( c->j->ret)(c, ip->insn_code, 0, src_preg);
	    }
	    break;
	    case iclass_convert: {
		/* conversion insns */
		int dest_vreg = ip->opnds.a2.dest;
		int src_vreg = ip->opnds.a2.src;
		int dest_preg = preg_of(c, bb, dest_vreg);
		int src_preg = preg_of(c, bb, src_vreg);
		int from_type = (ip->insn_code >> 4) & 0xf;
		int to_type = ip->insn_code & 0xf;
		if (src_preg == -1) {
		    /* load src */
		    src_preg = load_oprnd(c, 0, src_vreg);
		}
		if (dest_preg == -1) {
		    dest_preg = c->p->v_tmps[type_of(c, dest_vreg)][0];
		}
		( c->j->convert)(c, from_type, to_type, dest_preg, src_preg);
		if (preg_of(c, bb, dest_vreg) == -1) {
		    /* no dest reg, store result */
		    store_oprnd(c, 0, dest_vreg);
		}
	    }
	    break;
	    case iclass_loadstore: {
		/* load/store 3 operand integer insns */
		int dest_vreg = ip->opnds.a3.dest;
		int src1_vreg = ip->opnds.a3.src1;
		int src2_vreg = ip->opnds.a3.src2;
		int dest_preg = preg_of(c, bb, dest_vreg);
		int src1_preg = preg_of(c, bb, src1_vreg);
		int src2_preg = preg_of(c, bb, src2_vreg);
		int store = ip->insn_code >> 4;
		int typ = ip->insn_code & 0xf;
		if (src1_preg == -1) {
		    /* load src1 */
		    src1_preg = load_oprnd(c, 0, src1_vreg);
		}
		if (src2_preg == -1) {
		    /* load src2 */
		    src2_preg = load_oprnd(c, 1, src2_vreg);
		}
		if (store == 0) {
		    if (dest_preg == -1) {
			dest_preg = c->p->v_tmps[type_of(c, dest_vreg)][0];
		    }
		    ( c->j->load)(c, typ, 0, dest_preg, src1_preg, src2_preg);
		    if (preg_of(c, bb, dest_vreg) == -1) {
			/* no dest reg, store result */
			    store_oprnd(c, 0, dest_vreg);
		    }
		} else {
		    if (dest_preg == -1) {
			dest_preg = load_oprnd(c, 1, dest_vreg);
		    }
		    ( c->j->store)(c, typ, 0, dest_preg, src1_preg, src2_preg);
		}
	    }
	    break;
	    case iclass_loadstorei:
	    {
		/* load store immediate operand integer insns */
		int dest_vreg = ip->opnds.a3i.dest;
		int src_vreg = ip->opnds.a3i.src;
		long imm = ip->opnds.a3i.imm;
		int dest_preg = preg_of(c, bb, dest_vreg);
		int src_preg = preg_of(c, bb, src_vreg);
		int store = ip->insn_code >> 4;
		int typ = ip->insn_code & 0xf;
		if (src_preg == -1) {
		    /* load src */
		    src_preg = load_oprnd(c, 0, src_vreg);
		}
		if (store == 0) {
		    if (dest_preg == -1) {
			dest_preg = c->p->v_tmps[type_of(c, dest_vreg)][0];
		    }
		    ( c->j->loadi)(c, typ, 0, dest_preg, src_preg, imm);
		    if (preg_of(c, bb, dest_vreg) == -1) {
			/* no dest reg, store result */
			store_oprnd(c, 0, dest_vreg);
		    }
		} else {
		    if (dest_preg == -1) {
			dest_preg = load_oprnd(c, 1, dest_vreg);
		    }
		    /* a store, dest is the source of the store */
		    ( c->j->storei)(c, typ, 0, dest_preg, src_preg, imm);
		}
	    }
	    break;
	    case iclass_set:
	    {
		/* load store immediate operand integer insns */
		int dest_vreg = ip->opnds.a3i.dest;
		long imm = ip->opnds.a3i.imm;
		int dest_preg = preg_of(c, bb, dest_vreg);
		int typ = ip->insn_code & 0xf;
		if (dest_preg == -1) {
		    dest_preg = c->p->v_tmps[type_of(c, dest_vreg)][0];
		}
		( c->j->set)(c, typ, 0, dest_preg, imm);
		if (preg_of(c, bb, dest_vreg) == -1) {
		    /* no dest reg, store result */
		    store_oprnd(c, 0, dest_vreg);
		}
	    }
	    break;
	    case iclass_setf:
	    {
		/* load store immediate operand integer insns */
		int dest_vreg = ip->opnds.sf.dest;
		double imm = ip->opnds.sf.imm;
		int dest_preg = preg_of(c, bb, dest_vreg);
		int typ = ip->insn_code & 0xf;
		if (dest_preg == -1) {
		    dest_preg = c->p->v_tmps[type_of(c, dest_vreg)][0];
		}
		( c->j->setf)(c, typ, 0, dest_preg, imm);
		if (preg_of(c, bb, dest_vreg) == -1) {
		    /* no dest reg, store result */
		    store_oprnd(c, 0, dest_vreg);
		}
	    }
	    break;
	    case iclass_mov: {
		/* mov insns */
		int dest_vreg = ip->opnds.a2.dest;
		int src_vreg = ip->opnds.a2.src;
		int dest_preg = preg_of(c, bb, dest_vreg);
		int src_preg = preg_of(c, bb, src_vreg);
		int typ = ip->insn_code & 0xf;
		if (src_preg == -1) {
		    /* load src */
		    src_preg = load_oprnd(c, 0, src_vreg);
		}
		if (dest_preg == -1) {
		    dest_preg = c->p->v_tmps[type_of(c, dest_vreg)][0];
		}
		( c->j->mov)(c, typ, 0, dest_preg, src_preg);
		if (preg_of(c, bb, dest_vreg) == -1) {
		    /* no dest reg, store result */
		    store_oprnd(c, 0, dest_vreg);
		}
	    }
	    break;
	    case iclass_reti:
	    {
		/* return immediate integer insns */
		long imm = ip->opnds.a3i.imm;
		int typ = ip->insn_code & 0xf;
		( c->j->reti)(c, typ, 0, imm);
	    }
	    break;
	    case iclass_branch:
	    {
		/* branch */
		int br_op = ip->insn_code;
		int label = get_new_label(ip->opnds.br.label, ltable);
		int src1_vreg = ip->opnds.br.src1;
		int src2_vreg = ip->opnds.br.src2;
		int src1_preg = preg_of(c, bb, src1_vreg);
		int src2_preg = preg_of(c, bb, src2_vreg);
		if (src1_preg == -1) {
		    /* load src1 */
		    src1_preg = load_oprnd(c, 0, src1_vreg);
		}
		if (src2_preg == -1) {
		    /* load src2 */
		    src2_preg = load_oprnd(c, 1, src2_vreg);
		}
		( c->j->jmp_b)[br_op](c, c->j->b_data[br_op].data1,
				      c->j->b_data[br_op].data2,
				      src1_preg, src2_preg, label);
	    }
	    break;
	    case iclass_branchi:
	    {
		/* branch immediate */
		//int typ = ip->insn_code & 0xf;
		int br_op = ip->insn_code;
		int label = get_new_label(ip->opnds.bri.label, ltable);
		int src1_vreg = ip->opnds.bri.src;
		long imm = ip->opnds.bri.imm;
		int src1_preg = preg_of(c, bb, src1_vreg);
		if (src1_preg == -1) {
		    /* load src1 */
		    src1_preg = load_oprnd(c, 0, src1_vreg);
		}
		
		( c->j->jmp_bi)[br_op](c, c->j->b_data[br_op].data1,
				       c->j->b_data[br_op].data2,
				       src1_preg, imm, label);
	    }
	    break;
	    case iclass_jump_to_label:
	    {
		/* branch immediate */
		int label = get_new_label(ip->opnds.br.label, ltable);
		dr_jv(c, label);
	    }
	    break;
	    case iclass_jump_to_reg:
	    {
		int src1_vreg = ip->opnds.br.src1;
		int src1_preg = preg_of(c, bb, src1_vreg);
		if (src1_preg == -1) {
		    /* load src1 */
		    src1_preg = load_oprnd(c, 0, src1_vreg);
		}
		
		dr_jp(c, src1_preg);
	    }
	    break;
	    case iclass_jump_to_imm:
	    {
		long imm = ip->opnds.bri.imm;
		dr_jpi(c, imm);
	    }
	    case iclass_call:
	    {
		basic_block next_bb = &vmi->bblist[i+1];
		int dest_vreg = ip->opnds.bri.src;
		int dest_preg = 0;
		
		long imm = ip->opnds.bri.imm;
		int reg = ip->insn_code & 0x10;
		int typ = ip->insn_code & 0xf;
		int rr;
		
		if (typ != DR_V) dest_preg = preg_of(c, next_bb, dest_vreg);
		pushpop_inuse_regs(c, 0, ip);
		if (reg != 0) {
		    int src1_vreg = imm;
		    int src1_preg = preg_of(c, bb, src1_vreg);
		    if (src1_preg == -1) {
			/* load src1 */
			src1_preg = load_oprnd(c, 0, src1_vreg);
		    }
		    rr = dr_pcallr(c, typ, src1_preg);
		} else {
		    rr = dr_pcall(c, typ, (void*)imm);
		}
		if (typ != DR_V) {
		    if (preg_of(c, next_bb, dest_vreg) == -1) {
			/* no dest reg, store result */
			int offset = offset_of(c, dest_vreg);
			int typ = type_of(c, dest_vreg);
			c->j->storei(c, typ, 0, rr, c->dr_lp, offset);
		    } else {
			/* move return value to result */
			c->j->mov(c, typ, 0, dest_preg, rr);
		    }
		}
		pushpop_inuse_regs(c, 1, ip);
	    }
	    break;
	    case iclass_push:
	    {
		int typ = ip->insn_code & 0xf;
		int src1_vreg = ip->opnds.a1.src;
		int src1_preg;
		if (ip->opnds.a1.src != 0xffff) {
		    /* neg 1 used to signal push init */
		    src1_preg = preg_of(c, bb, src1_vreg);
		    if (src1_preg == -1) {
			/* load src1 */
			src1_preg = load_oprnd(c, 0, src1_vreg);
		    }
		} else {
		    src1_preg = -1;
		}
		dr_push_arg(c, typ, src1_preg);
	    }
	    break;
	    case iclass_pushi:
	    {
		//int typ = ip->insn_code & 0xf;
		long imm = ip->opnds.a3i.imm;
		dr_push_argii(c, imm);
	    }
	    break;
	    case iclass_pushf:
	    {
		int typ = ip->insn_code & 0xf;
		double imm = ip->opnds.sf.imm;
		c->j->pushfi(c, typ, imm);
	    }
	    break;
	    case iclass_nop:
		break;
	    }
	}
    }
    if ((unsigned)ltable[label_xlate].old_location == j * sizeof(virtual_insn)) {
	dr_label(c, ltable[label_xlate].new_label);
	label_xlate++;
    }
    if (ltable[label_xlate].old_location != 0) {
	printf("Some labels not placed\n");
    }
}

#ifndef MODULE
static void virtual_nop(){}
#endif

static void
virtual_proc_start(drisc_ctx c, char *subr_name, int arg_count,
		   arg_info_list args, dr_reg_t *arglist)
{
    int i;
    virtual_mach_info vmi = (virtual_mach_info)c->p->mach_info;
    vmi->arg_info = args;
    for (i = 0; i < arg_count; i++) {
	c->p->c_param_args[i].in_reg = i;
    }
}

extern void dr_virtual_init(drisc_ctx c);

static int 
loc_compar(const void *va, const void *vb)
{
    label_translation_table a = (label_translation_table) va;
    label_translation_table b = (label_translation_table) vb;
    return a->old_location > b->old_location;
}

static label_translation_table
build_label_translation(drisc_ctx c)
{
    int i;
    int label_count = c->p->branch_table.next_label;
    label_translation_table l = malloc(sizeof(struct label_translation) *
				       (label_count + 1));
    for(i = 0; i < label_count; i++) {
	l[i].old_label = i;
	l[i].old_location = c->p->branch_table.label_locs[i];
	l[i].new_label = dr_genlabel(c);
    }
    /* reorder in location order */
    qsort(l, label_count, sizeof(struct label_translation), 
	  loc_compar);
    l[label_count].old_location = 0;
    return l;
}
static void
virtual_end(c)
drisc_ctx c;
{
    virtual_mach_info vmi = (virtual_mach_info)c->p->mach_info;
    void *insns = c->p->code_base;
    void *code_end = c->p->cur_ip;
    label_translation_table ltable;
    int virtual_local_pointer = c->dr_lp;

    build_bbs(c, insns, code_end);

    if (getenv ("DRISC_VERBOSE") ) {
	dump_bbs(c);
	c->drisc_debug = 1;
    }

    c->p->virtual.mach_jump = c->j;
    c->p->virtual.mach_reset = c->p->mach_reset;
    c->p->virtual.mach_info = c->p->mach_info;
    c->p->virtual.code_base = c->p->code_base;
    c->p->virtual.cur_ip = c->p->cur_ip;
    c->p->virtual.code_limit = c->p->code_limit;

    c->j = c->p->native.mach_jump;
    c->p->mach_reset = c->p->native.mach_reset;
    c->p->mach_info = c->p->native.mach_info;
    c->p->code_base = c->p->native.code_base;
    c->p->cur_ip = c->p->code_base;
    c->p->code_limit = c->p->native.code_limit;

    c->p->native_mach_reset(c);
    (c->j->proc_start)(c, "no name", c->p->c_param_count, 
		       vmi->arg_info, (void*)0);
    do_register_assign(c, insns, code_end, virtual_local_pointer, vmi);
    ltable = build_label_translation(c);
    emit_insns(c, insns, ltable, vmi);
    free_bbs(vmi);
    free(ltable);
    dr_end(c);
    c->j = c->p->native.mach_jump;
    c->p->native.mach_reset = c->p->mach_reset;
    c->p->native.mach_info = c->p->mach_info;
    c->p->native.code_base = c->p->code_base;
    c->p->native.cur_ip = c->p->cur_ip;
    c->p->native.code_limit = c->p->code_limit;

    c->p->mach_reset = dr_virtual_init;
}

static void*
gen_virtual_mach_info(c)
drisc_ctx c;
{
    virtual_mach_info vmi = (virtual_mach_info) malloc(sizeof(*vmi));
    return vmi;
}
jmp_table virtual_jump_table;
extern void dr_virtual_init(drisc_ctx c)
{
	if(virtual_jump_table == 0) {
	  virtual_jump_table = alloc_drisc_jump_table();
# line 87 "virtual.ops"
	  virtual_jump_table->jmp_a3[dr_jmp_addi] = drisc_varith3;
	  virtual_jump_table->a3_data[dr_jmp_addi].data1 = dr_jmp_addi;
	  virtual_jump_table->a3_data[dr_jmp_addi].data2 = 0;
# line 87 "virtual.ops"
	  virtual_jump_table->jmp_a3[dr_jmp_addu] = drisc_varith3;
	  virtual_jump_table->a3_data[dr_jmp_addu].data1 = dr_jmp_addu;
	  virtual_jump_table->a3_data[dr_jmp_addu].data2 = 0;
# line 87 "virtual.ops"
	  virtual_jump_table->jmp_a3[dr_jmp_addul] = drisc_varith3;
	  virtual_jump_table->a3_data[dr_jmp_addul].data1 = dr_jmp_addul;
	  virtual_jump_table->a3_data[dr_jmp_addul].data2 = 0;
# line 87 "virtual.ops"
	  virtual_jump_table->jmp_a3[dr_jmp_addl] = drisc_varith3;
	  virtual_jump_table->a3_data[dr_jmp_addl].data1 = dr_jmp_addl;
	  virtual_jump_table->a3_data[dr_jmp_addl].data2 = 0;
# line 87 "virtual.ops"
	  virtual_jump_table->jmp_a3[dr_jmp_addp] = drisc_varith3;
	  virtual_jump_table->a3_data[dr_jmp_addp].data1 = dr_jmp_addp;
	  virtual_jump_table->a3_data[dr_jmp_addp].data2 = 0;
# line 87 "virtual.ops"
	  virtual_jump_table->jmp_a3[dr_jmp_subi] = drisc_varith3;
	  virtual_jump_table->a3_data[dr_jmp_subi].data1 = dr_jmp_subi;
	  virtual_jump_table->a3_data[dr_jmp_subi].data2 = 0;
# line 87 "virtual.ops"
	  virtual_jump_table->jmp_a3[dr_jmp_subu] = drisc_varith3;
	  virtual_jump_table->a3_data[dr_jmp_subu].data1 = dr_jmp_subu;
	  virtual_jump_table->a3_data[dr_jmp_subu].data2 = 0;
# line 87 "virtual.ops"
	  virtual_jump_table->jmp_a3[dr_jmp_subul] = drisc_varith3;
	  virtual_jump_table->a3_data[dr_jmp_subul].data1 = dr_jmp_subul;
	  virtual_jump_table->a3_data[dr_jmp_subul].data2 = 0;
# line 87 "virtual.ops"
	  virtual_jump_table->jmp_a3[dr_jmp_subl] = drisc_varith3;
	  virtual_jump_table->a3_data[dr_jmp_subl].data1 = dr_jmp_subl;
	  virtual_jump_table->a3_data[dr_jmp_subl].data2 = 0;
# line 87 "virtual.ops"
	  virtual_jump_table->jmp_a3[dr_jmp_subp] = drisc_varith3;
	  virtual_jump_table->a3_data[dr_jmp_subp].data1 = dr_jmp_subp;
	  virtual_jump_table->a3_data[dr_jmp_subp].data2 = 0;
# line 87 "virtual.ops"
	  virtual_jump_table->jmp_a3[dr_jmp_mulu] = drisc_varith3;
	  virtual_jump_table->a3_data[dr_jmp_mulu].data1 = dr_jmp_mulu;
	  virtual_jump_table->a3_data[dr_jmp_mulu].data2 = 0;
# line 87 "virtual.ops"
	  virtual_jump_table->jmp_a3[dr_jmp_mulul] = drisc_varith3;
	  virtual_jump_table->a3_data[dr_jmp_mulul].data1 = dr_jmp_mulul;
	  virtual_jump_table->a3_data[dr_jmp_mulul].data2 = 0;
# line 87 "virtual.ops"
	  virtual_jump_table->jmp_a3[dr_jmp_muli] = drisc_varith3;
	  virtual_jump_table->a3_data[dr_jmp_muli].data1 = dr_jmp_muli;
	  virtual_jump_table->a3_data[dr_jmp_muli].data2 = 0;
# line 87 "virtual.ops"
	  virtual_jump_table->jmp_a3[dr_jmp_mull] = drisc_varith3;
	  virtual_jump_table->a3_data[dr_jmp_mull].data1 = dr_jmp_mull;
	  virtual_jump_table->a3_data[dr_jmp_mull].data2 = 0;
# line 87 "virtual.ops"
	  virtual_jump_table->jmp_a3[dr_jmp_divu] = drisc_varith3;
	  virtual_jump_table->a3_data[dr_jmp_divu].data1 = dr_jmp_divu;
	  virtual_jump_table->a3_data[dr_jmp_divu].data2 = 0;
# line 87 "virtual.ops"
	  virtual_jump_table->jmp_a3[dr_jmp_divul] = drisc_varith3;
	  virtual_jump_table->a3_data[dr_jmp_divul].data1 = dr_jmp_divul;
	  virtual_jump_table->a3_data[dr_jmp_divul].data2 = 0;
# line 87 "virtual.ops"
	  virtual_jump_table->jmp_a3[dr_jmp_divi] = drisc_varith3;
	  virtual_jump_table->a3_data[dr_jmp_divi].data1 = dr_jmp_divi;
	  virtual_jump_table->a3_data[dr_jmp_divi].data2 = 0;
# line 87 "virtual.ops"
	  virtual_jump_table->jmp_a3[dr_jmp_divl] = drisc_varith3;
	  virtual_jump_table->a3_data[dr_jmp_divl].data1 = dr_jmp_divl;
	  virtual_jump_table->a3_data[dr_jmp_divl].data2 = 0;
# line 87 "virtual.ops"
	  virtual_jump_table->jmp_a3[dr_jmp_modu] = drisc_varith3;
	  virtual_jump_table->a3_data[dr_jmp_modu].data1 = dr_jmp_modu;
	  virtual_jump_table->a3_data[dr_jmp_modu].data2 = 0;
# line 87 "virtual.ops"
	  virtual_jump_table->jmp_a3[dr_jmp_modul] = drisc_varith3;
	  virtual_jump_table->a3_data[dr_jmp_modul].data1 = dr_jmp_modul;
	  virtual_jump_table->a3_data[dr_jmp_modul].data2 = 0;
# line 87 "virtual.ops"
	  virtual_jump_table->jmp_a3[dr_jmp_modi] = drisc_varith3;
	  virtual_jump_table->a3_data[dr_jmp_modi].data1 = dr_jmp_modi;
	  virtual_jump_table->a3_data[dr_jmp_modi].data2 = 0;
# line 87 "virtual.ops"
	  virtual_jump_table->jmp_a3[dr_jmp_modl] = drisc_varith3;
	  virtual_jump_table->a3_data[dr_jmp_modl].data1 = dr_jmp_modl;
	  virtual_jump_table->a3_data[dr_jmp_modl].data2 = 0;
# line 87 "virtual.ops"
	  virtual_jump_table->jmp_a3[dr_jmp_andu] = drisc_varith3;
	  virtual_jump_table->a3_data[dr_jmp_andu].data1 = dr_jmp_andu;
	  virtual_jump_table->a3_data[dr_jmp_andu].data2 = 0;
# line 87 "virtual.ops"
	  virtual_jump_table->jmp_a3[dr_jmp_andul] = drisc_varith3;
	  virtual_jump_table->a3_data[dr_jmp_andul].data1 = dr_jmp_andul;
	  virtual_jump_table->a3_data[dr_jmp_andul].data2 = 0;
# line 87 "virtual.ops"
	  virtual_jump_table->jmp_a3[dr_jmp_andi] = drisc_varith3;
	  virtual_jump_table->a3_data[dr_jmp_andi].data1 = dr_jmp_andi;
	  virtual_jump_table->a3_data[dr_jmp_andi].data2 = 0;
# line 87 "virtual.ops"
	  virtual_jump_table->jmp_a3[dr_jmp_andl] = drisc_varith3;
	  virtual_jump_table->a3_data[dr_jmp_andl].data1 = dr_jmp_andl;
	  virtual_jump_table->a3_data[dr_jmp_andl].data2 = 0;
# line 87 "virtual.ops"
	  virtual_jump_table->jmp_a3[dr_jmp_oru] = drisc_varith3;
	  virtual_jump_table->a3_data[dr_jmp_oru].data1 = dr_jmp_oru;
	  virtual_jump_table->a3_data[dr_jmp_oru].data2 = 0;
# line 87 "virtual.ops"
	  virtual_jump_table->jmp_a3[dr_jmp_orul] = drisc_varith3;
	  virtual_jump_table->a3_data[dr_jmp_orul].data1 = dr_jmp_orul;
	  virtual_jump_table->a3_data[dr_jmp_orul].data2 = 0;
# line 87 "virtual.ops"
	  virtual_jump_table->jmp_a3[dr_jmp_ori] = drisc_varith3;
	  virtual_jump_table->a3_data[dr_jmp_ori].data1 = dr_jmp_ori;
	  virtual_jump_table->a3_data[dr_jmp_ori].data2 = 0;
# line 87 "virtual.ops"
	  virtual_jump_table->jmp_a3[dr_jmp_orl] = drisc_varith3;
	  virtual_jump_table->a3_data[dr_jmp_orl].data1 = dr_jmp_orl;
	  virtual_jump_table->a3_data[dr_jmp_orl].data2 = 0;
# line 87 "virtual.ops"
	  virtual_jump_table->jmp_a3[dr_jmp_xoru] = drisc_varith3;
	  virtual_jump_table->a3_data[dr_jmp_xoru].data1 = dr_jmp_xoru;
	  virtual_jump_table->a3_data[dr_jmp_xoru].data2 = 0;
# line 87 "virtual.ops"
	  virtual_jump_table->jmp_a3[dr_jmp_xorul] = drisc_varith3;
	  virtual_jump_table->a3_data[dr_jmp_xorul].data1 = dr_jmp_xorul;
	  virtual_jump_table->a3_data[dr_jmp_xorul].data2 = 0;
# line 87 "virtual.ops"
	  virtual_jump_table->jmp_a3[dr_jmp_xori] = drisc_varith3;
	  virtual_jump_table->a3_data[dr_jmp_xori].data1 = dr_jmp_xori;
	  virtual_jump_table->a3_data[dr_jmp_xori].data2 = 0;
# line 87 "virtual.ops"
	  virtual_jump_table->jmp_a3[dr_jmp_xorl] = drisc_varith3;
	  virtual_jump_table->a3_data[dr_jmp_xorl].data1 = dr_jmp_xorl;
	  virtual_jump_table->a3_data[dr_jmp_xorl].data2 = 0;
# line 87 "virtual.ops"
	  virtual_jump_table->jmp_a3[dr_jmp_lshu] = drisc_varith3;
	  virtual_jump_table->a3_data[dr_jmp_lshu].data1 = dr_jmp_lshu;
	  virtual_jump_table->a3_data[dr_jmp_lshu].data2 = 0;
# line 87 "virtual.ops"
	  virtual_jump_table->jmp_a3[dr_jmp_lshul] = drisc_varith3;
	  virtual_jump_table->a3_data[dr_jmp_lshul].data1 = dr_jmp_lshul;
	  virtual_jump_table->a3_data[dr_jmp_lshul].data2 = 0;
# line 87 "virtual.ops"
	  virtual_jump_table->jmp_a3[dr_jmp_lshi] = drisc_varith3;
	  virtual_jump_table->a3_data[dr_jmp_lshi].data1 = dr_jmp_lshi;
	  virtual_jump_table->a3_data[dr_jmp_lshi].data2 = 0;
# line 87 "virtual.ops"
	  virtual_jump_table->jmp_a3[dr_jmp_lshl] = drisc_varith3;
	  virtual_jump_table->a3_data[dr_jmp_lshl].data1 = dr_jmp_lshl;
	  virtual_jump_table->a3_data[dr_jmp_lshl].data2 = 0;
# line 87 "virtual.ops"
	  virtual_jump_table->jmp_a3[dr_jmp_rshu] = drisc_varith3;
	  virtual_jump_table->a3_data[dr_jmp_rshu].data1 = dr_jmp_rshu;
	  virtual_jump_table->a3_data[dr_jmp_rshu].data2 = 0;
# line 87 "virtual.ops"
	  virtual_jump_table->jmp_a3[dr_jmp_rshul] = drisc_varith3;
	  virtual_jump_table->a3_data[dr_jmp_rshul].data1 = dr_jmp_rshul;
	  virtual_jump_table->a3_data[dr_jmp_rshul].data2 = 0;
# line 87 "virtual.ops"
	  virtual_jump_table->jmp_a3[dr_jmp_rshi] = drisc_varith3;
	  virtual_jump_table->a3_data[dr_jmp_rshi].data1 = dr_jmp_rshi;
	  virtual_jump_table->a3_data[dr_jmp_rshi].data2 = 0;
# line 87 "virtual.ops"
	  virtual_jump_table->jmp_a3[dr_jmp_rshl] = drisc_varith3;
	  virtual_jump_table->a3_data[dr_jmp_rshl].data1 = dr_jmp_rshl;
	  virtual_jump_table->a3_data[dr_jmp_rshl].data2 = 0;
# line 87 "virtual.ops"
	  virtual_jump_table->jmp_a3[dr_jmp_addf] = drisc_varith3;
	  virtual_jump_table->a3_data[dr_jmp_addf].data1 = dr_jmp_addf;
	  virtual_jump_table->a3_data[dr_jmp_addf].data2 = 0;
# line 87 "virtual.ops"
	  virtual_jump_table->jmp_a3[dr_jmp_addd] = drisc_varith3;
	  virtual_jump_table->a3_data[dr_jmp_addd].data1 = dr_jmp_addd;
	  virtual_jump_table->a3_data[dr_jmp_addd].data2 = 0;
# line 87 "virtual.ops"
	  virtual_jump_table->jmp_a3[dr_jmp_subf] = drisc_varith3;
	  virtual_jump_table->a3_data[dr_jmp_subf].data1 = dr_jmp_subf;
	  virtual_jump_table->a3_data[dr_jmp_subf].data2 = 0;
# line 87 "virtual.ops"
	  virtual_jump_table->jmp_a3[dr_jmp_subd] = drisc_varith3;
	  virtual_jump_table->a3_data[dr_jmp_subd].data1 = dr_jmp_subd;
	  virtual_jump_table->a3_data[dr_jmp_subd].data2 = 0;
# line 87 "virtual.ops"
	  virtual_jump_table->jmp_a3[dr_jmp_mulf] = drisc_varith3;
	  virtual_jump_table->a3_data[dr_jmp_mulf].data1 = dr_jmp_mulf;
	  virtual_jump_table->a3_data[dr_jmp_mulf].data2 = 0;
# line 87 "virtual.ops"
	  virtual_jump_table->jmp_a3[dr_jmp_muld] = drisc_varith3;
	  virtual_jump_table->a3_data[dr_jmp_muld].data1 = dr_jmp_muld;
	  virtual_jump_table->a3_data[dr_jmp_muld].data2 = 0;
# line 87 "virtual.ops"
	  virtual_jump_table->jmp_a3[dr_jmp_divf] = drisc_varith3;
	  virtual_jump_table->a3_data[dr_jmp_divf].data1 = dr_jmp_divf;
	  virtual_jump_table->a3_data[dr_jmp_divf].data2 = 0;
# line 87 "virtual.ops"
	  virtual_jump_table->jmp_a3[dr_jmp_divd] = drisc_varith3;
	  virtual_jump_table->a3_data[dr_jmp_divd].data1 = dr_jmp_divd;
	  virtual_jump_table->a3_data[dr_jmp_divd].data2 = 0;
# line 87 "virtual.ops"
	  virtual_jump_table->jmp_a3[dr_jmp_negf] = drisc_varith3;
	  virtual_jump_table->a3_data[dr_jmp_negf].data1 = dr_jmp_negf;
	  virtual_jump_table->a3_data[dr_jmp_negf].data2 = 0;
# line 87 "virtual.ops"
	  virtual_jump_table->jmp_a3[dr_jmp_negd] = drisc_varith3;
	  virtual_jump_table->a3_data[dr_jmp_negd].data1 = dr_jmp_negd;
	  virtual_jump_table->a3_data[dr_jmp_negd].data2 = 0;
	  virtual_jump_table->jmp_a3i[dr_jmp_addi] = drisc_varith3i;
	  virtual_jump_table->a3i_data[dr_jmp_addi].data1 = dr_jmp_addi;
	  virtual_jump_table->a3i_data[dr_jmp_addi].data2 = 0;
	  virtual_jump_table->jmp_a3i[dr_jmp_addu] = drisc_varith3i;
	  virtual_jump_table->a3i_data[dr_jmp_addu].data1 = dr_jmp_addu;
	  virtual_jump_table->a3i_data[dr_jmp_addu].data2 = 0;
	  virtual_jump_table->jmp_a3i[dr_jmp_addul] = drisc_varith3i;
	  virtual_jump_table->a3i_data[dr_jmp_addul].data1 = dr_jmp_addul;
	  virtual_jump_table->a3i_data[dr_jmp_addul].data2 = 0;
	  virtual_jump_table->jmp_a3i[dr_jmp_addl] = drisc_varith3i;
	  virtual_jump_table->a3i_data[dr_jmp_addl].data1 = dr_jmp_addl;
	  virtual_jump_table->a3i_data[dr_jmp_addl].data2 = 0;
	  virtual_jump_table->jmp_a3i[dr_jmp_addp] = drisc_varith3i;
	  virtual_jump_table->a3i_data[dr_jmp_addp].data1 = dr_jmp_addp;
	  virtual_jump_table->a3i_data[dr_jmp_addp].data2 = 0;
	  virtual_jump_table->jmp_a3i[dr_jmp_subi] = drisc_varith3i;
	  virtual_jump_table->a3i_data[dr_jmp_subi].data1 = dr_jmp_subi;
	  virtual_jump_table->a3i_data[dr_jmp_subi].data2 = 0;
	  virtual_jump_table->jmp_a3i[dr_jmp_subu] = drisc_varith3i;
	  virtual_jump_table->a3i_data[dr_jmp_subu].data1 = dr_jmp_subu;
	  virtual_jump_table->a3i_data[dr_jmp_subu].data2 = 0;
	  virtual_jump_table->jmp_a3i[dr_jmp_subul] = drisc_varith3i;
	  virtual_jump_table->a3i_data[dr_jmp_subul].data1 = dr_jmp_subul;
	  virtual_jump_table->a3i_data[dr_jmp_subul].data2 = 0;
	  virtual_jump_table->jmp_a3i[dr_jmp_subl] = drisc_varith3i;
	  virtual_jump_table->a3i_data[dr_jmp_subl].data1 = dr_jmp_subl;
	  virtual_jump_table->a3i_data[dr_jmp_subl].data2 = 0;
	  virtual_jump_table->jmp_a3i[dr_jmp_subp] = drisc_varith3i;
	  virtual_jump_table->a3i_data[dr_jmp_subp].data1 = dr_jmp_subp;
	  virtual_jump_table->a3i_data[dr_jmp_subp].data2 = 0;
	  virtual_jump_table->jmp_a3i[dr_jmp_mulu] = drisc_varith3i;
	  virtual_jump_table->a3i_data[dr_jmp_mulu].data1 = dr_jmp_mulu;
	  virtual_jump_table->a3i_data[dr_jmp_mulu].data2 = 0;
	  virtual_jump_table->jmp_a3i[dr_jmp_mulul] = drisc_varith3i;
	  virtual_jump_table->a3i_data[dr_jmp_mulul].data1 = dr_jmp_mulul;
	  virtual_jump_table->a3i_data[dr_jmp_mulul].data2 = 0;
	  virtual_jump_table->jmp_a3i[dr_jmp_muli] = drisc_varith3i;
	  virtual_jump_table->a3i_data[dr_jmp_muli].data1 = dr_jmp_muli;
	  virtual_jump_table->a3i_data[dr_jmp_muli].data2 = 0;
	  virtual_jump_table->jmp_a3i[dr_jmp_mull] = drisc_varith3i;
	  virtual_jump_table->a3i_data[dr_jmp_mull].data1 = dr_jmp_mull;
	  virtual_jump_table->a3i_data[dr_jmp_mull].data2 = 0;
	  virtual_jump_table->jmp_a3i[dr_jmp_divu] = drisc_varith3i;
	  virtual_jump_table->a3i_data[dr_jmp_divu].data1 = dr_jmp_divu;
	  virtual_jump_table->a3i_data[dr_jmp_divu].data2 = 0;
	  virtual_jump_table->jmp_a3i[dr_jmp_divul] = drisc_varith3i;
	  virtual_jump_table->a3i_data[dr_jmp_divul].data1 = dr_jmp_divul;
	  virtual_jump_table->a3i_data[dr_jmp_divul].data2 = 0;
	  virtual_jump_table->jmp_a3i[dr_jmp_divi] = drisc_varith3i;
	  virtual_jump_table->a3i_data[dr_jmp_divi].data1 = dr_jmp_divi;
	  virtual_jump_table->a3i_data[dr_jmp_divi].data2 = 0;
	  virtual_jump_table->jmp_a3i[dr_jmp_divl] = drisc_varith3i;
	  virtual_jump_table->a3i_data[dr_jmp_divl].data1 = dr_jmp_divl;
	  virtual_jump_table->a3i_data[dr_jmp_divl].data2 = 0;
	  virtual_jump_table->jmp_a3i[dr_jmp_modu] = drisc_varith3i;
	  virtual_jump_table->a3i_data[dr_jmp_modu].data1 = dr_jmp_modu;
	  virtual_jump_table->a3i_data[dr_jmp_modu].data2 = 0;
	  virtual_jump_table->jmp_a3i[dr_jmp_modul] = drisc_varith3i;
	  virtual_jump_table->a3i_data[dr_jmp_modul].data1 = dr_jmp_modul;
	  virtual_jump_table->a3i_data[dr_jmp_modul].data2 = 0;
	  virtual_jump_table->jmp_a3i[dr_jmp_modi] = drisc_varith3i;
	  virtual_jump_table->a3i_data[dr_jmp_modi].data1 = dr_jmp_modi;
	  virtual_jump_table->a3i_data[dr_jmp_modi].data2 = 0;
	  virtual_jump_table->jmp_a3i[dr_jmp_modl] = drisc_varith3i;
	  virtual_jump_table->a3i_data[dr_jmp_modl].data1 = dr_jmp_modl;
	  virtual_jump_table->a3i_data[dr_jmp_modl].data2 = 0;
	  virtual_jump_table->jmp_a3i[dr_jmp_andi] = drisc_varith3i;
	  virtual_jump_table->a3i_data[dr_jmp_andi].data1 = dr_jmp_andi;
	  virtual_jump_table->a3i_data[dr_jmp_andi].data2 = 0;
	  virtual_jump_table->jmp_a3i[dr_jmp_andu] = drisc_varith3i;
	  virtual_jump_table->a3i_data[dr_jmp_andu].data1 = dr_jmp_andu;
	  virtual_jump_table->a3i_data[dr_jmp_andu].data2 = 0;
	  virtual_jump_table->jmp_a3i[dr_jmp_andul] = drisc_varith3i;
	  virtual_jump_table->a3i_data[dr_jmp_andul].data1 = dr_jmp_andul;
	  virtual_jump_table->a3i_data[dr_jmp_andul].data2 = 0;
	  virtual_jump_table->jmp_a3i[dr_jmp_andl] = drisc_varith3i;
	  virtual_jump_table->a3i_data[dr_jmp_andl].data1 = dr_jmp_andl;
	  virtual_jump_table->a3i_data[dr_jmp_andl].data2 = 0;
	  virtual_jump_table->jmp_a3i[dr_jmp_ori] = drisc_varith3i;
	  virtual_jump_table->a3i_data[dr_jmp_ori].data1 = dr_jmp_ori;
	  virtual_jump_table->a3i_data[dr_jmp_ori].data2 = 0;
	  virtual_jump_table->jmp_a3i[dr_jmp_oru] = drisc_varith3i;
	  virtual_jump_table->a3i_data[dr_jmp_oru].data1 = dr_jmp_oru;
	  virtual_jump_table->a3i_data[dr_jmp_oru].data2 = 0;
	  virtual_jump_table->jmp_a3i[dr_jmp_orul] = drisc_varith3i;
	  virtual_jump_table->a3i_data[dr_jmp_orul].data1 = dr_jmp_orul;
	  virtual_jump_table->a3i_data[dr_jmp_orul].data2 = 0;
	  virtual_jump_table->jmp_a3i[dr_jmp_orl] = drisc_varith3i;
	  virtual_jump_table->a3i_data[dr_jmp_orl].data1 = dr_jmp_orl;
	  virtual_jump_table->a3i_data[dr_jmp_orl].data2 = 0;
	  virtual_jump_table->jmp_a3i[dr_jmp_xori] = drisc_varith3i;
	  virtual_jump_table->a3i_data[dr_jmp_xori].data1 = dr_jmp_xori;
	  virtual_jump_table->a3i_data[dr_jmp_xori].data2 = 0;
	  virtual_jump_table->jmp_a3i[dr_jmp_xoru] = drisc_varith3i;
	  virtual_jump_table->a3i_data[dr_jmp_xoru].data1 = dr_jmp_xoru;
	  virtual_jump_table->a3i_data[dr_jmp_xoru].data2 = 0;
	  virtual_jump_table->jmp_a3i[dr_jmp_xorul] = drisc_varith3i;
	  virtual_jump_table->a3i_data[dr_jmp_xorul].data1 = dr_jmp_xorul;
	  virtual_jump_table->a3i_data[dr_jmp_xorul].data2 = 0;
	  virtual_jump_table->jmp_a3i[dr_jmp_xorl] = drisc_varith3i;
	  virtual_jump_table->a3i_data[dr_jmp_xorl].data1 = dr_jmp_xorl;
	  virtual_jump_table->a3i_data[dr_jmp_xorl].data2 = 0;
	  virtual_jump_table->jmp_a3i[dr_jmp_lshi] = drisc_varith3i;
	  virtual_jump_table->a3i_data[dr_jmp_lshi].data1 = dr_jmp_lshi;
	  virtual_jump_table->a3i_data[dr_jmp_lshi].data2 = 0;
	  virtual_jump_table->jmp_a3i[dr_jmp_lshu] = drisc_varith3i;
	  virtual_jump_table->a3i_data[dr_jmp_lshu].data1 = dr_jmp_lshu;
	  virtual_jump_table->a3i_data[dr_jmp_lshu].data2 = 0;
	  virtual_jump_table->jmp_a3i[dr_jmp_lshul] = drisc_varith3i;
	  virtual_jump_table->a3i_data[dr_jmp_lshul].data1 = dr_jmp_lshul;
	  virtual_jump_table->a3i_data[dr_jmp_lshul].data2 = 0;
	  virtual_jump_table->jmp_a3i[dr_jmp_lshl] = drisc_varith3i;
	  virtual_jump_table->a3i_data[dr_jmp_lshl].data1 = dr_jmp_lshl;
	  virtual_jump_table->a3i_data[dr_jmp_lshl].data2 = 0;
	  virtual_jump_table->jmp_a3i[dr_jmp_rshi] = drisc_varith3i;
	  virtual_jump_table->a3i_data[dr_jmp_rshi].data1 = dr_jmp_rshi;
	  virtual_jump_table->a3i_data[dr_jmp_rshi].data2 = 0;
	  virtual_jump_table->jmp_a3i[dr_jmp_rshu] = drisc_varith3i;
	  virtual_jump_table->a3i_data[dr_jmp_rshu].data1 = dr_jmp_rshu;
	  virtual_jump_table->a3i_data[dr_jmp_rshu].data2 = 0;
	  virtual_jump_table->jmp_a3i[dr_jmp_rshul] = drisc_varith3i;
	  virtual_jump_table->a3i_data[dr_jmp_rshul].data1 = dr_jmp_rshul;
	  virtual_jump_table->a3i_data[dr_jmp_rshul].data2 = 0;
	  virtual_jump_table->jmp_a3i[dr_jmp_rshl] = drisc_varith3i;
	  virtual_jump_table->a3i_data[dr_jmp_rshl].data1 = dr_jmp_rshl;
	  virtual_jump_table->a3i_data[dr_jmp_rshl].data2 = 0;
	  virtual_jump_table->jmp_a2[dr_jmp_comi] = drisc_varith2;
	  virtual_jump_table->a2_data[dr_jmp_comi].data1 = dr_jmp_comi;
	  virtual_jump_table->a2_data[dr_jmp_comi].data2 = 0;
	  virtual_jump_table->jmp_a2[dr_jmp_comu] = drisc_varith2;
	  virtual_jump_table->a2_data[dr_jmp_comu].data1 = dr_jmp_comu;
	  virtual_jump_table->a2_data[dr_jmp_comu].data2 = 0;
	  virtual_jump_table->jmp_a2[dr_jmp_comul] = drisc_varith2;
	  virtual_jump_table->a2_data[dr_jmp_comul].data1 = dr_jmp_comul;
	  virtual_jump_table->a2_data[dr_jmp_comul].data2 = 0;
	  virtual_jump_table->jmp_a2[dr_jmp_coml] = drisc_varith2;
	  virtual_jump_table->a2_data[dr_jmp_coml].data1 = dr_jmp_coml;
	  virtual_jump_table->a2_data[dr_jmp_coml].data2 = 0;
	  virtual_jump_table->jmp_a2[dr_jmp_noti] = drisc_varith2;
	  virtual_jump_table->a2_data[dr_jmp_noti].data1 = dr_jmp_noti;
	  virtual_jump_table->a2_data[dr_jmp_noti].data2 = 0;
	  virtual_jump_table->jmp_a2[dr_jmp_notu] = drisc_varith2;
	  virtual_jump_table->a2_data[dr_jmp_notu].data1 = dr_jmp_notu;
	  virtual_jump_table->a2_data[dr_jmp_notu].data2 = 0;
	  virtual_jump_table->jmp_a2[dr_jmp_notul] = drisc_varith2;
	  virtual_jump_table->a2_data[dr_jmp_notul].data1 = dr_jmp_notul;
	  virtual_jump_table->a2_data[dr_jmp_notul].data2 = 0;
	  virtual_jump_table->jmp_a2[dr_jmp_notl] = drisc_varith2;
	  virtual_jump_table->a2_data[dr_jmp_notl].data1 = dr_jmp_notl;
	  virtual_jump_table->a2_data[dr_jmp_notl].data2 = 0;
	  virtual_jump_table->jmp_a2[dr_jmp_negi] = drisc_varith2;
	  virtual_jump_table->a2_data[dr_jmp_negi].data1 = dr_jmp_negi;
	  virtual_jump_table->a2_data[dr_jmp_negi].data2 = 0;
	  virtual_jump_table->jmp_a2[dr_jmp_negu] = drisc_varith2;
	  virtual_jump_table->a2_data[dr_jmp_negu].data1 = dr_jmp_negu;
	  virtual_jump_table->a2_data[dr_jmp_negu].data2 = 0;
	  virtual_jump_table->jmp_a2[dr_jmp_negul] = drisc_varith2;
	  virtual_jump_table->a2_data[dr_jmp_negul].data1 = dr_jmp_negul;
	  virtual_jump_table->a2_data[dr_jmp_negul].data2 = 0;
	  virtual_jump_table->jmp_a2[dr_jmp_negl] = drisc_varith2;
	  virtual_jump_table->a2_data[dr_jmp_negl].data1 = dr_jmp_negl;
	  virtual_jump_table->a2_data[dr_jmp_negl].data2 = 0;
	  virtual_jump_table->jmp_a2[dr_jmp_negf] = drisc_varith2;
	  virtual_jump_table->a2_data[dr_jmp_negf].data1 = dr_jmp_negf;
	  virtual_jump_table->a2_data[dr_jmp_negf].data2 = 0;
	  virtual_jump_table->jmp_a2[dr_jmp_negd] = drisc_varith2;
	  virtual_jump_table->a2_data[dr_jmp_negd].data1 = dr_jmp_negd;
	  virtual_jump_table->a2_data[dr_jmp_negd].data2 = 0;
	  virtual_jump_table->jmp_b[dr_jmp_beqi] = virtual_branch;
	  virtual_jump_table->b_data[dr_jmp_beqi].data1 = dr_jmp_beqi;
	  virtual_jump_table->b_data[dr_jmp_beqi].data2 = DR_I;
	  virtual_jump_table->jmp_b[dr_jmp_bequ] = virtual_branch;
	  virtual_jump_table->b_data[dr_jmp_bequ].data1 = dr_jmp_bequ;
	  virtual_jump_table->b_data[dr_jmp_bequ].data2 = DR_U;
	  virtual_jump_table->jmp_b[dr_jmp_bequl] = virtual_branch;
	  virtual_jump_table->b_data[dr_jmp_bequl].data1 = dr_jmp_bequl;
	  virtual_jump_table->b_data[dr_jmp_bequl].data2 = DR_UL;
	  virtual_jump_table->jmp_b[dr_jmp_beql] = virtual_branch;
	  virtual_jump_table->b_data[dr_jmp_beql].data1 = dr_jmp_beql;
	  virtual_jump_table->b_data[dr_jmp_beql].data2 = DR_L;
	  virtual_jump_table->jmp_b[dr_jmp_beqp] = virtual_branch;
	  virtual_jump_table->b_data[dr_jmp_beqp].data1 = dr_jmp_beqp;
	  virtual_jump_table->b_data[dr_jmp_beqp].data2 = DR_P;
	  virtual_jump_table->jmp_b[dr_jmp_beqd] = virtual_branch;
	  virtual_jump_table->b_data[dr_jmp_beqd].data1 = dr_jmp_beqd;
	  virtual_jump_table->b_data[dr_jmp_beqd].data2 = DR_D;
	  virtual_jump_table->jmp_b[dr_jmp_beqf] = virtual_branch;
	  virtual_jump_table->b_data[dr_jmp_beqf].data1 = dr_jmp_beqf;
	  virtual_jump_table->b_data[dr_jmp_beqf].data2 = DR_F;
	  virtual_jump_table->jmp_b[dr_jmp_bgei] = virtual_branch;
	  virtual_jump_table->b_data[dr_jmp_bgei].data1 = dr_jmp_bgei;
	  virtual_jump_table->b_data[dr_jmp_bgei].data2 = DR_I;
	  virtual_jump_table->jmp_b[dr_jmp_bgeu] = virtual_branch;
	  virtual_jump_table->b_data[dr_jmp_bgeu].data1 = dr_jmp_bgeu;
	  virtual_jump_table->b_data[dr_jmp_bgeu].data2 = DR_U;
	  virtual_jump_table->jmp_b[dr_jmp_bgeul] = virtual_branch;
	  virtual_jump_table->b_data[dr_jmp_bgeul].data1 = dr_jmp_bgeul;
	  virtual_jump_table->b_data[dr_jmp_bgeul].data2 = DR_UL;
	  virtual_jump_table->jmp_b[dr_jmp_bgel] = virtual_branch;
	  virtual_jump_table->b_data[dr_jmp_bgel].data1 = dr_jmp_bgel;
	  virtual_jump_table->b_data[dr_jmp_bgel].data2 = DR_L;
	  virtual_jump_table->jmp_b[dr_jmp_bgep] = virtual_branch;
	  virtual_jump_table->b_data[dr_jmp_bgep].data1 = dr_jmp_bgep;
	  virtual_jump_table->b_data[dr_jmp_bgep].data2 = DR_P;
	  virtual_jump_table->jmp_b[dr_jmp_bged] = virtual_branch;
	  virtual_jump_table->b_data[dr_jmp_bged].data1 = dr_jmp_bged;
	  virtual_jump_table->b_data[dr_jmp_bged].data2 = DR_D;
	  virtual_jump_table->jmp_b[dr_jmp_bgef] = virtual_branch;
	  virtual_jump_table->b_data[dr_jmp_bgef].data1 = dr_jmp_bgef;
	  virtual_jump_table->b_data[dr_jmp_bgef].data2 = DR_F;
	  virtual_jump_table->jmp_b[dr_jmp_bgti] = virtual_branch;
	  virtual_jump_table->b_data[dr_jmp_bgti].data1 = dr_jmp_bgti;
	  virtual_jump_table->b_data[dr_jmp_bgti].data2 = DR_I;
	  virtual_jump_table->jmp_b[dr_jmp_bgtu] = virtual_branch;
	  virtual_jump_table->b_data[dr_jmp_bgtu].data1 = dr_jmp_bgtu;
	  virtual_jump_table->b_data[dr_jmp_bgtu].data2 = DR_U;
	  virtual_jump_table->jmp_b[dr_jmp_bgtul] = virtual_branch;
	  virtual_jump_table->b_data[dr_jmp_bgtul].data1 = dr_jmp_bgtul;
	  virtual_jump_table->b_data[dr_jmp_bgtul].data2 = DR_UL;
	  virtual_jump_table->jmp_b[dr_jmp_bgtl] = virtual_branch;
	  virtual_jump_table->b_data[dr_jmp_bgtl].data1 = dr_jmp_bgtl;
	  virtual_jump_table->b_data[dr_jmp_bgtl].data2 = DR_L;
	  virtual_jump_table->jmp_b[dr_jmp_bgtp] = virtual_branch;
	  virtual_jump_table->b_data[dr_jmp_bgtp].data1 = dr_jmp_bgtp;
	  virtual_jump_table->b_data[dr_jmp_bgtp].data2 = DR_P;
	  virtual_jump_table->jmp_b[dr_jmp_bgtd] = virtual_branch;
	  virtual_jump_table->b_data[dr_jmp_bgtd].data1 = dr_jmp_bgtd;
	  virtual_jump_table->b_data[dr_jmp_bgtd].data2 = DR_D;
	  virtual_jump_table->jmp_b[dr_jmp_bgtf] = virtual_branch;
	  virtual_jump_table->b_data[dr_jmp_bgtf].data1 = dr_jmp_bgtf;
	  virtual_jump_table->b_data[dr_jmp_bgtf].data2 = DR_F;
	  virtual_jump_table->jmp_b[dr_jmp_blei] = virtual_branch;
	  virtual_jump_table->b_data[dr_jmp_blei].data1 = dr_jmp_blei;
	  virtual_jump_table->b_data[dr_jmp_blei].data2 = DR_I;
	  virtual_jump_table->jmp_b[dr_jmp_bleu] = virtual_branch;
	  virtual_jump_table->b_data[dr_jmp_bleu].data1 = dr_jmp_bleu;
	  virtual_jump_table->b_data[dr_jmp_bleu].data2 = DR_U;
	  virtual_jump_table->jmp_b[dr_jmp_bleul] = virtual_branch;
	  virtual_jump_table->b_data[dr_jmp_bleul].data1 = dr_jmp_bleul;
	  virtual_jump_table->b_data[dr_jmp_bleul].data2 = DR_UL;
	  virtual_jump_table->jmp_b[dr_jmp_blel] = virtual_branch;
	  virtual_jump_table->b_data[dr_jmp_blel].data1 = dr_jmp_blel;
	  virtual_jump_table->b_data[dr_jmp_blel].data2 = DR_L;
	  virtual_jump_table->jmp_b[dr_jmp_blep] = virtual_branch;
	  virtual_jump_table->b_data[dr_jmp_blep].data1 = dr_jmp_blep;
	  virtual_jump_table->b_data[dr_jmp_blep].data2 = DR_P;
	  virtual_jump_table->jmp_b[dr_jmp_bled] = virtual_branch;
	  virtual_jump_table->b_data[dr_jmp_bled].data1 = dr_jmp_bled;
	  virtual_jump_table->b_data[dr_jmp_bled].data2 = DR_D;
	  virtual_jump_table->jmp_b[dr_jmp_blef] = virtual_branch;
	  virtual_jump_table->b_data[dr_jmp_blef].data1 = dr_jmp_blef;
	  virtual_jump_table->b_data[dr_jmp_blef].data2 = DR_F;
	  virtual_jump_table->jmp_b[dr_jmp_blti] = virtual_branch;
	  virtual_jump_table->b_data[dr_jmp_blti].data1 = dr_jmp_blti;
	  virtual_jump_table->b_data[dr_jmp_blti].data2 = DR_I;
	  virtual_jump_table->jmp_b[dr_jmp_bltu] = virtual_branch;
	  virtual_jump_table->b_data[dr_jmp_bltu].data1 = dr_jmp_bltu;
	  virtual_jump_table->b_data[dr_jmp_bltu].data2 = DR_U;
	  virtual_jump_table->jmp_b[dr_jmp_bltul] = virtual_branch;
	  virtual_jump_table->b_data[dr_jmp_bltul].data1 = dr_jmp_bltul;
	  virtual_jump_table->b_data[dr_jmp_bltul].data2 = DR_UL;
	  virtual_jump_table->jmp_b[dr_jmp_bltl] = virtual_branch;
	  virtual_jump_table->b_data[dr_jmp_bltl].data1 = dr_jmp_bltl;
	  virtual_jump_table->b_data[dr_jmp_bltl].data2 = DR_L;
	  virtual_jump_table->jmp_b[dr_jmp_bltp] = virtual_branch;
	  virtual_jump_table->b_data[dr_jmp_bltp].data1 = dr_jmp_bltp;
	  virtual_jump_table->b_data[dr_jmp_bltp].data2 = DR_P;
	  virtual_jump_table->jmp_b[dr_jmp_bltd] = virtual_branch;
	  virtual_jump_table->b_data[dr_jmp_bltd].data1 = dr_jmp_bltd;
	  virtual_jump_table->b_data[dr_jmp_bltd].data2 = DR_D;
	  virtual_jump_table->jmp_b[dr_jmp_bltf] = virtual_branch;
	  virtual_jump_table->b_data[dr_jmp_bltf].data1 = dr_jmp_bltf;
	  virtual_jump_table->b_data[dr_jmp_bltf].data2 = DR_F;
	  virtual_jump_table->jmp_b[dr_jmp_bnei] = virtual_branch;
	  virtual_jump_table->b_data[dr_jmp_bnei].data1 = dr_jmp_bnei;
	  virtual_jump_table->b_data[dr_jmp_bnei].data2 = DR_I;
	  virtual_jump_table->jmp_b[dr_jmp_bneu] = virtual_branch;
	  virtual_jump_table->b_data[dr_jmp_bneu].data1 = dr_jmp_bneu;
	  virtual_jump_table->b_data[dr_jmp_bneu].data2 = DR_U;
	  virtual_jump_table->jmp_b[dr_jmp_bneul] = virtual_branch;
	  virtual_jump_table->b_data[dr_jmp_bneul].data1 = dr_jmp_bneul;
	  virtual_jump_table->b_data[dr_jmp_bneul].data2 = DR_UL;
	  virtual_jump_table->jmp_b[dr_jmp_bnel] = virtual_branch;
	  virtual_jump_table->b_data[dr_jmp_bnel].data1 = dr_jmp_bnel;
	  virtual_jump_table->b_data[dr_jmp_bnel].data2 = DR_L;
	  virtual_jump_table->jmp_b[dr_jmp_bnep] = virtual_branch;
	  virtual_jump_table->b_data[dr_jmp_bnep].data1 = dr_jmp_bnep;
	  virtual_jump_table->b_data[dr_jmp_bnep].data2 = DR_P;
	  virtual_jump_table->jmp_b[dr_jmp_bned] = virtual_branch;
	  virtual_jump_table->b_data[dr_jmp_bned].data1 = dr_jmp_bned;
	  virtual_jump_table->b_data[dr_jmp_bned].data2 = DR_D;
	  virtual_jump_table->jmp_b[dr_jmp_bnef] = virtual_branch;
	  virtual_jump_table->b_data[dr_jmp_bnef].data1 = dr_jmp_bnef;
	  virtual_jump_table->b_data[dr_jmp_bnef].data2 = DR_F;
	  virtual_jump_table->jmp_bi[dr_jmp_beqi] = virtual_branchi;
	  virtual_jump_table->jmp_bi[dr_jmp_bequ] = virtual_branchi;
	  virtual_jump_table->jmp_bi[dr_jmp_bequl] = virtual_branchi;
	  virtual_jump_table->jmp_bi[dr_jmp_beql] = virtual_branchi;
	  virtual_jump_table->jmp_bi[dr_jmp_beqp] = virtual_branchi;
	  virtual_jump_table->jmp_bi[dr_jmp_bgei] = virtual_branchi;
	  virtual_jump_table->jmp_bi[dr_jmp_bgeu] = virtual_branchi;
	  virtual_jump_table->jmp_bi[dr_jmp_bgeul] = virtual_branchi;
	  virtual_jump_table->jmp_bi[dr_jmp_bgel] = virtual_branchi;
	  virtual_jump_table->jmp_bi[dr_jmp_bgep] = virtual_branchi;
	  virtual_jump_table->jmp_bi[dr_jmp_bgti] = virtual_branchi;
	  virtual_jump_table->jmp_bi[dr_jmp_bgtu] = virtual_branchi;
	  virtual_jump_table->jmp_bi[dr_jmp_bgtul] = virtual_branchi;
	  virtual_jump_table->jmp_bi[dr_jmp_bgtl] = virtual_branchi;
	  virtual_jump_table->jmp_bi[dr_jmp_bgtp] = virtual_branchi;
	  virtual_jump_table->jmp_bi[dr_jmp_blei] = virtual_branchi;
	  virtual_jump_table->jmp_bi[dr_jmp_bleu] = virtual_branchi;
	  virtual_jump_table->jmp_bi[dr_jmp_bleul] = virtual_branchi;
	  virtual_jump_table->jmp_bi[dr_jmp_blel] = virtual_branchi;
	  virtual_jump_table->jmp_bi[dr_jmp_blep] = virtual_branchi;
	  virtual_jump_table->jmp_bi[dr_jmp_blti] = virtual_branchi;
	  virtual_jump_table->jmp_bi[dr_jmp_bltu] = virtual_branchi;
	  virtual_jump_table->jmp_bi[dr_jmp_bltul] = virtual_branchi;
	  virtual_jump_table->jmp_bi[dr_jmp_bltl] = virtual_branchi;
	  virtual_jump_table->jmp_bi[dr_jmp_bltp] = virtual_branchi;
	  virtual_jump_table->jmp_bi[dr_jmp_bnei] = virtual_branchi;
	  virtual_jump_table->jmp_bi[dr_jmp_bneu] = virtual_branchi;
	  virtual_jump_table->jmp_bi[dr_jmp_bneul] = virtual_branchi;
	  virtual_jump_table->jmp_bi[dr_jmp_bnel] = virtual_branchi;
	  virtual_jump_table->jmp_bi[dr_jmp_bnep] = virtual_branchi;
	  virtual_jump_table->proc_start = (drisc_mach_proc_start) virtual_proc_start;
	  virtual_jump_table->end = (drisc_mach_end)virtual_end;
	  virtual_jump_table->type_align = c->p->native.mach_jump->type_align;
	  virtual_jump_table->ret = virtual_ret;
	  virtual_jump_table->reti = virtual_reti;
	  virtual_jump_table->load = virtual_load;
	  virtual_jump_table->loadi = virtual_loadi;
	  virtual_jump_table->store = virtual_store;
	  virtual_jump_table->storei = virtual_storei;
	  virtual_jump_table->convert = virtual_convert;
	  virtual_jump_table->mov = virtual_mov;
	  virtual_jump_table->set = virtual_pset;
	  virtual_jump_table->setf = virtual_setf;
	  virtual_jump_table->jv = virtual_jump_to_label;
	  virtual_jump_table->jp = virtual_jump_to_reg;
	  virtual_jump_table->jpi = virtual_jump_to_imm;
	  virtual_jump_table->push = virtual_push;
	  virtual_jump_table->pushi = virtual_pushi;
	  virtual_jump_table->pushfi = virtual_pushfi;
	  virtual_jump_table->calli = virtual_calli;
	  virtual_jump_table->callr = virtual_callr;
	  virtual_jump_table->init_disassembly = virtual_init_disassembly_info;
	  virtual_jump_table->print_insn = virtual_print_insn;
	  virtual_jump_table->do_reverse_push = c->p->native.mach_jump->do_reverse_push;
	}
# line 67 "virtual.ops"
	if (c->p->virtual.mach_info == NULL) {
	    c->p->virtual.mach_info = gen_virtual_mach_info();
	}
	c->p->mach_info = c->p->virtual.mach_info;
	c->p->mach_reset = c->p->virtual.mach_reset;
	c->p->code_base = c->p->virtual.code_base;
	c->p->cur_ip = c->p->code_base;
	c->p->code_limit = c->p->virtual.code_limit;
	c->p->vreg_count = 0;
	c->dr_lp = dr_getvreg(c, DR_P);
	c->j = virtual_jump_table;
	return;
}
