
#ifdef MODULE
#ifndef __KERNEL__
#define __KERNEL__
#endif
#endif

#ifndef MODULE
#include "config.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#ifdef HAVE_UNISTD_H
#include <unistd.h>
#endif
#include <time.h>
#include <signal.h>
#include <errno.h>
#ifdef HAVE_WINDOWS_H
#include <winsock.h>
#else
#include <netdb.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#endif

#include <gen_thread.h>
#include <atl.h>
#include <ltdl.h>
#include <cm.h>
#include <cm_internal.h>
#include <cm_transport.h>
#else
#include <linux/unistd.h>
#include <linux/time.h>
#include <linux/signal.h>
#include <linux/errno.h>
#include <linux/types.h>
#include <linux/socket.h>
#include <linux/in.h>
#include "../include/atl.h"
#include "cm.h"
#include "cm_internal.h"
#include "cm_transport.h"
#include "kcm.h"
#include "library.h"
#endif

#define MTP_ADDR  "234.235.236.237"
#define MTP_PORT  60606
#define MTP_TTL   1

#define MTP_FAILURE -1
#define MTP_SUCCESS  0

typedef void (*MTP_Handler) (void *, void *);

typedef struct _CMMultiHandler {
  MTP_Handler func;
  void * argone;
  void * argtwo;
}CMMultiHandler;

typedef struct _CMMulticast {
  int sock;
  struct sockaddr_in self;
  int count;
  int total;  
  struct sockaddr_in *group;
  CMMultiHandler * handler;
}CMMulticast;

extern int dummy_proc()
{
    return 1;
}
