/* ICODE Compatability functions/types */
#define dr_getvreg(c, type) i_local(0, type)
#define dr_genlabel(c) i_mklabel()
#define dr_param(c, type, num) i_paramn(type,num)
#define dr_push_init(c)
#define dr_do_reverse_vararg_push(c) (0)

#define DR_C I_C
#define DR_UC I_UC
#define DR_S I_S
#define DR_US I_US
#define DR_I I_I
#define DR_U I_U
#define DR_L I_L
#define DR_UL I_UL
#define DR_P I_P
#define DR_F I_F
#define DR_D I_D
#define	DR_V I_V
#define DR_B I_B
#define DR_ERR I_ERR

typedef void *drisc_ctx;

#define dr_getvblock(c, size) i_localb(size)
#define dr_label(c, label) i_label(label)
#define dr_virtual_lea(c, dest, src) i_leai(dest, src)
#define dr_jpi(c, label) i_jpi(label)
#define dr_jv(c, label) i_jpi(label)
#define dr_addi(c, dest, src1, src2) i_addi(dest, src1, src2)
#define dr_addii(c, dest, src1, imm) i_addii(dest, src1, imm)
#define dr_addu(c, dest, src1, src2) i_addu(dest, src1, src2)
#define dr_addui(c, dest, src1, imm) i_addui(dest, src1, imm)
#define dr_addul(c, dest, src1, src2) i_addul(dest, src1, src2)
#define dr_adduli(c, dest, src1, imm) i_adduli(dest, src1, imm)
#define dr_addl(c, dest, src1, src2) i_addl(dest, src1, src2)
#define dr_addli(c, dest, src1, imm) i_addli(dest, src1, imm)
#define dr_subi(c, dest, src1, src2) i_subi(dest, src1, src2)
#define dr_subii(c, dest, src1, imm) i_subii(dest, src1, imm)
#define dr_subu(c, dest, src1, src2) i_subu(dest, src1, src2)
#define dr_subui(c, dest, src1, imm) i_subui(dest, src1, imm)
#define dr_subul(c, dest, src1, src2) i_subul(dest, src1, src2)
#define dr_subuli(c, dest, src1, imm) i_subuli(dest, src1, imm)
#define dr_subl(c, dest, src1, src2) i_subl(dest, src1, src2)
#define dr_subli(c, dest, src1, imm) i_subli(dest, src1, imm)
#define dr_muli(c, dest, src1, src2) i_muli(dest, src1, src2)
#define dr_mulii(c, dest, src1, imm) i_mulii(dest, src1, imm)
#define dr_mulu(c, dest, src1, src2) i_mulu(dest, src1, src2)
#define dr_mului(c, dest, src1, imm) i_mului(dest, src1, imm)
#define dr_mulul(c, dest, src1, src2) i_mulul(dest, src1, src2)
#define dr_mululi(c, dest, src1, imm) i_mululi(dest, src1, imm)
#define dr_mull(c, dest, src1, src2) i_mull(dest, src1, src2)
#define dr_mulli(c, dest, src1, imm) i_mulli(dest, src1, imm)
#define dr_divi(c, dest, src1, src2) i_divi(dest, src1, src2)
#define dr_divii(c, dest, src1, imm) i_divii(dest, src1, imm)
#define dr_divu(c, dest, src1, src2) i_divu(dest, src1, src2)
#define dr_divui(c, dest, src1, imm) i_divui(dest, src1, imm)
#define dr_divul(c, dest, src1, src2) i_divul(dest, src1, src2)
#define dr_divuli(c, dest, src1, imm) i_divuli(dest, src1, imm)
#define dr_divl(c, dest, src1, src2) i_divl(dest, src1, src2)
#define dr_divli(c, dest, src1, imm) i_divli(dest, src1, imm)
#define dr_modi(c, dest, src1, src2) i_modi(dest, src1, src2)
#define dr_modii(c, dest, src1, imm) i_modii(dest, src1, imm)
#define dr_modu(c, dest, src1, src2) i_modu(dest, src1, src2)
#define dr_modui(c, dest, src1, imm) i_modui(dest, src1, imm)
#define dr_modul(c, dest, src1, src2) i_modul(dest, src1, src2)
#define dr_moduli(c, dest, src1, imm) i_moduli(dest, src1, imm)
#define dr_modl(c, dest, src1, src2) i_modl(dest, src1, src2)
#define dr_modli(c, dest, src1, imm) i_modli(dest, src1, imm)
#define dr_xori(c, dest, src1, src2) i_xori(dest, src1, src2)
#define dr_xorii(c, dest, src1, imm) i_xorii(dest, src1, imm)
#define dr_xoru(c, dest, src1, src2) i_xoru(dest, src1, src2)
#define dr_xorui(c, dest, src1, imm) i_xorui(dest, src1, imm)
#define dr_xorul(c, dest, src1, src2) i_xorul(dest, src1, src2)
#define dr_xoruli(c, dest, src1, imm) i_xoruli(dest, src1, imm)
#define dr_xorl(c, dest, src1, src2) i_xorl(dest, src1, src2)
#define dr_xorli(c, dest, src1, imm) i_xorli(dest, src1, imm)
#define dr_andi(c, dest, src1, src2) i_andi(dest, src1, src2)
#define dr_andii(c, dest, src1, imm) i_andii(dest, src1, imm)
#define dr_andu(c, dest, src1, src2) i_andu(dest, src1, src2)
#define dr_andui(c, dest, src1, imm) i_andui(dest, src1, imm)
#define dr_andul(c, dest, src1, src2) i_andul(dest, src1, src2)
#define dr_anduli(c, dest, src1, imm) i_anduli(dest, src1, imm)
#define dr_andl(c, dest, src1, src2) i_andl(dest, src1, src2)
#define dr_andli(c, dest, src1, imm) i_andli(dest, src1, imm)
#define dr_ori(c, dest, src1, src2) i_ori(dest, src1, src2)
#define dr_orii(c, dest, src1, imm) i_orii(dest, src1, imm)
#define dr_oru(c, dest, src1, src2) i_oru(dest, src1, src2)
#define dr_orui(c, dest, src1, imm) i_orui(dest, src1, imm)
#define dr_orul(c, dest, src1, src2) i_orul(dest, src1, src2)
#define dr_oruli(c, dest, src1, imm) i_oruli(dest, src1, imm)
#define dr_orl(c, dest, src1, src2) i_orl(dest, src1, src2)
#define dr_orli(c, dest, src1, imm) i_orli(dest, src1, imm)
#define dr_lshi(c, dest, src1, src2) i_lshi(dest, src1, src2)
#define dr_lshii(c, dest, src1, imm) i_lshii(dest, src1, imm)
#define dr_lshu(c, dest, src1, src2) i_lshu(dest, src1, src2)
#define dr_lshui(c, dest, src1, imm) i_lshui(dest, src1, imm)
#define dr_lshul(c, dest, src1, src2) i_lshul(dest, src1, src2)
#define dr_lshuli(c, dest, src1, imm) i_lshuli(dest, src1, imm)
#define dr_lshl(c, dest, src1, src2) i_lshl(dest, src1, src2)
#define dr_lshli(c, dest, src1, imm) i_lshli(dest, src1, imm)
#define dr_rshi(c, dest, src1, src2) i_rshi(dest, src1, src2)
#define dr_rshii(c, dest, src1, imm) i_rshii(dest, src1, imm)
#define dr_rshu(c, dest, src1, src2) i_rshu(dest, src1, src2)
#define dr_rshui(c, dest, src1, imm) i_rshui(dest, src1, imm)
#define dr_rshul(c, dest, src1, src2) i_rshul(dest, src1, src2)
#define dr_rshuli(c, dest, src1, imm) i_rshuli(dest, src1, imm)
#define dr_rshl(c, dest, src1, src2) i_rshl(dest, src1, src2)
#define dr_rshli(c, dest, src1, imm) i_rshli(dest, src1, imm)
#define dr_addp(c, dest, src1, src2) i_addp(dest, src1, src2)
#define dr_addpi(c, dest, src1, imm) i_addpi(dest, src1, imm)
#define dr_subp(c, dest, src1, src2) i_subp(dest, src1, src2)
#define dr_subpi(c, dest, src1, imm) i_subpi(dest, src1, imm)
#define dr_addf(c, dest, src1, src2) i_addf(dest, src1, src2)
#define dr_addfi(c, dest, src1, imm) i_addfi(dest, src1, imm)
#define dr_addd(c, dest, src1, src2) i_addd(dest, src1, src2)
#define dr_adddi(c, dest, src1, imm) i_adddi(dest, src1, imm)
#define dr_subf(c, dest, src1, src2) i_subf(dest, src1, src2)
#define dr_subfi(c, dest, src1, imm) i_subfi(dest, src1, imm)
#define dr_subd(c, dest, src1, src2) i_subd(dest, src1, src2)
#define dr_subdi(c, dest, src1, imm) i_subdi(dest, src1, imm)
#define dr_mulf(c, dest, src1, src2) i_mulf(dest, src1, src2)
#define dr_mulfi(c, dest, src1, imm) i_mulfi(dest, src1, imm)
#define dr_muld(c, dest, src1, src2) i_muld(dest, src1, src2)
#define dr_muldi(c, dest, src1, imm) i_muldi(dest, src1, imm)
#define dr_divf(c, dest, src1, src2) i_divf(dest, src1, src2)
#define dr_divfi(c, dest, src1, imm) i_divfi(dest, src1, imm)
#define dr_divd(c, dest, src1, src2) i_divd(dest, src1, src2)
#define dr_divdi(c, dest, src1, imm) i_divdi(dest, src1, imm)
#define dr_noti(c, dest, src) i_noti(dest, src)
#define dr_notii(c, dest, imm) i_notii(dest, imm)
#define dr_notu(c, dest, src) i_notu(dest, src)
#define dr_notui(c, dest, imm) i_notui(dest, imm)
#define dr_notul(c, dest, src) i_notul(dest, src)
#define dr_notuli(c, dest, imm) i_notuli(dest, imm)
#define dr_notl(c, dest, src) i_notl(dest, src)
#define dr_notli(c, dest, imm) i_notli(dest, imm)
#define dr_comi(c, dest, src) i_comi(dest, src)
#define dr_comii(c, dest, imm) i_comii(dest, imm)
#define dr_comu(c, dest, src) i_comu(dest, src)
#define dr_comui(c, dest, imm) i_comui(dest, imm)
#define dr_comul(c, dest, src) i_comul(dest, src)
#define dr_comuli(c, dest, imm) i_comuli(dest, imm)
#define dr_coml(c, dest, src) i_coml(dest, src)
#define dr_comli(c, dest, imm) i_comli(dest, imm)
#define dr_negi(c, dest, src) i_negi(dest, src)
#define dr_negii(c, dest, imm) i_negii(dest, imm)
#define dr_negu(c, dest, src) i_negu(dest, src)
#define dr_negui(c, dest, imm) i_negui(dest, imm)
#define dr_negul(c, dest, src) i_negul(dest, src)
#define dr_neguli(c, dest, imm) i_neguli(dest, imm)
#define dr_negl(c, dest, src) i_negl(dest, src)
#define dr_negli(c, dest, imm) i_negli(dest, imm)
#define dr_negf(c, dest, src) i_negf(dest, src)
#define dr_negfi(c, dest, imm) i_negfi(dest, imm)
#define dr_negd(c, dest, src) i_negd(dest, src)
#define dr_negdi(c, dest, imm) i_negdi(dest, imm)
#define dr_beqi(c, src1, src2, label) i_beqi(src1, src2, label)
#define dr_beqii(c, src, imm, label) i_beqii(src, imm, label)
#define dr_bequ(c, src1, src2, label) i_bequ(src1, src2, label)
#define dr_bequi(c, src, imm, label) i_bequi(src, imm, label)
#define dr_bequl(c, src1, src2, label) i_bequl(src1, src2, label)
#define dr_bequli(c, src, imm, label) i_bequli(src, imm, label)
#define dr_beql(c, src1, src2, label) i_beql(src1, src2, label)
#define dr_beqli(c, src, imm, label) i_beqli(src, imm, label)
#define dr_beqp(c, src1, src2, label) i_beqp(src1, src2, label)
#define dr_beqpi(c, src, imm, label) i_beqpi(src, imm, label)
#define dr_beqd(c, src1, src2, label) i_beqd(src1, src2, label)
#define dr_beqdi(c, src, imm, label) i_beqdi(src, imm, label)
#define dr_beqf(c, src1, src2, label) i_beqf(src1, src2, label)
#define dr_beqfi(c, src, imm, label) i_beqfi(src, imm, label)
#define dr_bgei(c, src1, src2, label) i_bgei(src1, src2, label)
#define dr_bgeii(c, src, imm, label) i_bgeii(src, imm, label)
#define dr_bgeu(c, src1, src2, label) i_bgeu(src1, src2, label)
#define dr_bgeui(c, src, imm, label) i_bgeui(src, imm, label)
#define dr_bgeul(c, src1, src2, label) i_bgeul(src1, src2, label)
#define dr_bgeuli(c, src, imm, label) i_bgeuli(src, imm, label)
#define dr_bgel(c, src1, src2, label) i_bgel(src1, src2, label)
#define dr_bgeli(c, src, imm, label) i_bgeli(src, imm, label)
#define dr_bgep(c, src1, src2, label) i_bgep(src1, src2, label)
#define dr_bgepi(c, src, imm, label) i_bgepi(src, imm, label)
#define dr_bged(c, src1, src2, label) i_bged(src1, src2, label)
#define dr_bgedi(c, src, imm, label) i_bgedi(src, imm, label)
#define dr_bgef(c, src1, src2, label) i_bgef(src1, src2, label)
#define dr_bgefi(c, src, imm, label) i_bgefi(src, imm, label)
#define dr_bgti(c, src1, src2, label) i_bgti(src1, src2, label)
#define dr_bgtii(c, src, imm, label) i_bgtii(src, imm, label)
#define dr_bgtu(c, src1, src2, label) i_bgtu(src1, src2, label)
#define dr_bgtui(c, src, imm, label) i_bgtui(src, imm, label)
#define dr_bgtul(c, src1, src2, label) i_bgtul(src1, src2, label)
#define dr_bgtuli(c, src, imm, label) i_bgtuli(src, imm, label)
#define dr_bgtl(c, src1, src2, label) i_bgtl(src1, src2, label)
#define dr_bgtli(c, src, imm, label) i_bgtli(src, imm, label)
#define dr_bgtp(c, src1, src2, label) i_bgtp(src1, src2, label)
#define dr_bgtpi(c, src, imm, label) i_bgtpi(src, imm, label)
#define dr_bgtd(c, src1, src2, label) i_bgtd(src1, src2, label)
#define dr_bgtdi(c, src, imm, label) i_bgtdi(src, imm, label)
#define dr_bgtf(c, src1, src2, label) i_bgtf(src1, src2, label)
#define dr_bgtfi(c, src, imm, label) i_bgtfi(src, imm, label)
#define dr_blei(c, src1, src2, label) i_blei(src1, src2, label)
#define dr_bleii(c, src, imm, label) i_bleii(src, imm, label)
#define dr_bleu(c, src1, src2, label) i_bleu(src1, src2, label)
#define dr_bleui(c, src, imm, label) i_bleui(src, imm, label)
#define dr_bleul(c, src1, src2, label) i_bleul(src1, src2, label)
#define dr_bleuli(c, src, imm, label) i_bleuli(src, imm, label)
#define dr_blel(c, src1, src2, label) i_blel(src1, src2, label)
#define dr_bleli(c, src, imm, label) i_bleli(src, imm, label)
#define dr_blep(c, src1, src2, label) i_blep(src1, src2, label)
#define dr_blepi(c, src, imm, label) i_blepi(src, imm, label)
#define dr_bled(c, src1, src2, label) i_bled(src1, src2, label)
#define dr_bledi(c, src, imm, label) i_bledi(src, imm, label)
#define dr_blef(c, src1, src2, label) i_blef(src1, src2, label)
#define dr_blefi(c, src, imm, label) i_blefi(src, imm, label)
#define dr_blti(c, src1, src2, label) i_blti(src1, src2, label)
#define dr_bltii(c, src, imm, label) i_bltii(src, imm, label)
#define dr_bltu(c, src1, src2, label) i_bltu(src1, src2, label)
#define dr_bltui(c, src, imm, label) i_bltui(src, imm, label)
#define dr_bltul(c, src1, src2, label) i_bltul(src1, src2, label)
#define dr_bltuli(c, src, imm, label) i_bltuli(src, imm, label)
#define dr_bltl(c, src1, src2, label) i_bltl(src1, src2, label)
#define dr_bltli(c, src, imm, label) i_bltli(src, imm, label)
#define dr_bltp(c, src1, src2, label) i_bltp(src1, src2, label)
#define dr_bltpi(c, src, imm, label) i_bltpi(src, imm, label)
#define dr_bltd(c, src1, src2, label) i_bltd(src1, src2, label)
#define dr_bltdi(c, src, imm, label) i_bltdi(src, imm, label)
#define dr_bltf(c, src1, src2, label) i_bltf(src1, src2, label)
#define dr_bltfi(c, src, imm, label) i_bltfi(src, imm, label)
#define dr_bnei(c, src1, src2, label) i_bnei(src1, src2, label)
#define dr_bneii(c, src, imm, label) i_bneii(src, imm, label)
#define dr_bneu(c, src1, src2, label) i_bneu(src1, src2, label)
#define dr_bneui(c, src, imm, label) i_bneui(src, imm, label)
#define dr_bneul(c, src1, src2, label) i_bneul(src1, src2, label)
#define dr_bneuli(c, src, imm, label) i_bneuli(src, imm, label)
#define dr_bnel(c, src1, src2, label) i_bnel(src1, src2, label)
#define dr_bneli(c, src, imm, label) i_bneli(src, imm, label)
#define dr_bnep(c, src1, src2, label) i_bnep(src1, src2, label)
#define dr_bnepi(c, src, imm, label) i_bnepi(src, imm, label)
#define dr_bned(c, src1, src2, label) i_bned(src1, src2, label)
#define dr_bnedi(c, src, imm, label) i_bnedi(src, imm, label)
#define dr_bnef(c, src1, src2, label) i_bnef(src1, src2, label)
#define dr_bnefi(c, src, imm, label) i_bnefi(src, imm, label)
#define dr_cvc2i(c, dest, src) i_cvc2i(dest, src)
#define dr_cvc2ii(c, src, imm) i_cvc2ii(src, imm)
#define dr_cvc2u(c, dest, src) i_cvc2u(dest, src)
#define dr_cvc2ui(c, src, imm) i_cvc2ui(src, imm)
#define dr_cvc2ul(c, dest, src) i_cvc2ul(dest, src)
#define dr_cvc2uli(c, src, imm) i_cvc2uli(src, imm)
#define dr_cvc2l(c, dest, src) i_cvc2l(dest, src)
#define dr_cvc2li(c, src, imm) i_cvc2li(src, imm)
#define dr_cvd2i(c, dest, src) i_cvd2i(dest, src)
#define dr_cvd2ii(c, src, imm) i_cvd2ii(src, imm)
#define dr_cvd2u(c, dest, src) i_cvd2u(dest, src)
#define dr_cvd2ui(c, src, imm) i_cvd2ui(src, imm)
#define dr_cvd2ul(c, dest, src) i_cvd2ul(dest, src)
#define dr_cvd2uli(c, src, imm) i_cvd2uli(src, imm)
#define dr_cvd2l(c, dest, src) i_cvd2l(dest, src)
#define dr_cvd2li(c, src, imm) i_cvd2li(src, imm)
#define dr_cvf2i(c, dest, src) i_cvf2i(dest, src)
#define dr_cvf2ii(c, src, imm) i_cvf2ii(src, imm)
#define dr_cvf2u(c, dest, src) i_cvf2u(dest, src)
#define dr_cvf2ui(c, src, imm) i_cvf2ui(src, imm)
#define dr_cvf2ul(c, dest, src) i_cvf2ul(dest, src)
#define dr_cvf2uli(c, src, imm) i_cvf2uli(src, imm)
#define dr_cvf2l(c, dest, src) i_cvf2l(dest, src)
#define dr_cvf2li(c, src, imm) i_cvf2li(src, imm)
#define dr_cvi2u(c, dest, src) i_cvi2u(dest, src)
#define dr_cvi2ui(c, src, imm) i_cvi2ui(src, imm)
#define dr_cvi2ul(c, dest, src) i_cvi2ul(dest, src)
#define dr_cvi2uli(c, src, imm) i_cvi2uli(src, imm)
#define dr_cvi2l(c, dest, src) i_cvi2l(dest, src)
#define dr_cvi2li(c, src, imm) i_cvi2li(src, imm)
#define dr_cvl2i(c, dest, src) i_cvl2i(dest, src)
#define dr_cvl2ii(c, src, imm) i_cvl2ii(src, imm)
#define dr_cvl2u(c, dest, src) i_cvl2u(dest, src)
#define dr_cvl2ui(c, src, imm) i_cvl2ui(src, imm)
#define dr_cvl2ul(c, dest, src) i_cvl2ul(dest, src)
#define dr_cvl2uli(c, src, imm) i_cvl2uli(src, imm)
#define dr_cvs2i(c, dest, src) i_cvs2i(dest, src)
#define dr_cvs2ii(c, src, imm) i_cvs2ii(src, imm)
#define dr_cvs2u(c, dest, src) i_cvs2u(dest, src)
#define dr_cvs2ui(c, src, imm) i_cvs2ui(src, imm)
#define dr_cvs2ul(c, dest, src) i_cvs2ul(dest, src)
#define dr_cvs2uli(c, src, imm) i_cvs2uli(src, imm)
#define dr_cvs2l(c, dest, src) i_cvs2l(dest, src)
#define dr_cvs2li(c, src, imm) i_cvs2li(src, imm)
#define dr_cvu2i(c, dest, src) i_cvu2i(dest, src)
#define dr_cvu2ii(c, src, imm) i_cvu2ii(src, imm)
#define dr_cvu2ul(c, dest, src) i_cvu2ul(dest, src)
#define dr_cvu2uli(c, src, imm) i_cvu2uli(src, imm)
#define dr_cvu2l(c, dest, src) i_cvu2l(dest, src)
#define dr_cvu2li(c, src, imm) i_cvu2li(src, imm)
#define dr_cvul2i(c, dest, src) i_cvul2i(dest, src)
#define dr_cvul2ii(c, src, imm) i_cvul2ii(src, imm)
#define dr_cvul2u(c, dest, src) i_cvul2u(dest, src)
#define dr_cvul2ui(c, src, imm) i_cvul2ui(src, imm)
#define dr_cvul2l(c, dest, src) i_cvul2l(dest, src)
#define dr_cvul2li(c, src, imm) i_cvul2li(src, imm)
#define dr_cvus2i(c, dest, src) i_cvus2i(dest, src)
#define dr_cvus2ii(c, src, imm) i_cvus2ii(src, imm)
#define dr_cvus2u(c, dest, src) i_cvus2u(dest, src)
#define dr_cvus2ui(c, src, imm) i_cvus2ui(src, imm)
#define dr_cvus2ul(c, dest, src) i_cvus2ul(dest, src)
#define dr_cvus2uli(c, src, imm) i_cvus2uli(src, imm)
#define dr_cvus2l(c, dest, src) i_cvus2l(dest, src)
#define dr_cvus2li(c, src, imm) i_cvus2li(src, imm)
#define dr_cvd2f(c, dest, src) i_cvd2f(dest, src)
#define dr_cvd2fi(c, src, imm) i_cvd2fi(src, imm)
#define dr_cvf2d(c, dest, src) i_cvf2d(dest, src)
#define dr_cvf2di(c, src, imm) i_cvf2di(src, imm)
#define dr_cvi2f(c, dest, src) i_cvi2f(dest, src)
#define dr_cvi2fi(c, src, imm) i_cvi2fi(src, imm)
#define dr_cvi2d(c, dest, src) i_cvi2d(dest, src)
#define dr_cvi2di(c, src, imm) i_cvi2di(src, imm)
#define dr_cvl2f(c, dest, src) i_cvl2f(dest, src)
#define dr_cvl2fi(c, src, imm) i_cvl2fi(src, imm)
#define dr_cvl2d(c, dest, src) i_cvl2d(dest, src)
#define dr_cvl2di(c, src, imm) i_cvl2di(src, imm)
#define dr_cvu2f(c, dest, src) i_cvu2f(dest, src)
#define dr_cvu2fi(c, src, imm) i_cvu2fi(src, imm)
#define dr_cvu2d(c, dest, src) i_cvu2d(dest, src)
#define dr_cvu2di(c, src, imm) i_cvu2di(src, imm)
#define dr_cvul2f(c, dest, src) i_cvul2f(dest, src)
#define dr_cvul2fi(c, src, imm) i_cvul2fi(src, imm)
#define dr_cvul2d(c, dest, src) i_cvul2d(dest, src)
#define dr_cvul2di(c, src, imm) i_cvul2di(src, imm)
#define dr_cvi2c(c, dest, src) i_cvi2c(dest, src)
#define dr_cvi2ci(c, src, imm) i_cvi2ci(src, imm)
#define dr_cvi2s(c, dest, src) i_cvi2s(dest, src)
#define dr_cvi2si(c, src, imm) i_cvi2si(src, imm)
#define dr_cvl2c(c, dest, src) i_cvl2c(dest, src)
#define dr_cvl2ci(c, src, imm) i_cvl2ci(src, imm)
#define dr_cvl2s(c, dest, src) i_cvl2s(dest, src)
#define dr_cvl2si(c, src, imm) i_cvl2si(src, imm)
#define dr_cvu2c(c, dest, src) i_cvu2c(dest, src)
#define dr_cvu2ci(c, src, imm) i_cvu2ci(src, imm)
#define dr_cvu2s(c, dest, src) i_cvu2s(dest, src)
#define dr_cvu2si(c, src, imm) i_cvu2si(src, imm)
#define dr_cvul2c(c, dest, src) i_cvul2c(dest, src)
#define dr_cvul2ci(c, src, imm) i_cvul2ci(src, imm)
#define dr_cvul2s(c, dest, src) i_cvul2s(dest, src)
#define dr_cvul2si(c, src, imm) i_cvul2si(src, imm)
#define dr_cvp2ul(c, dest, src) i_cvp2ul(dest, src)
#define dr_cvp2uli(c, src, imm) i_cvp2uli(src, imm)
#define dr_cvul2p(c, dest, src) i_cvul2p(dest, src)
#define dr_cvul2pi(c, src, imm) i_cvul2pi(src, imm)
#define dr_ldc(c, dest, src1, src2) i_ldc(dest, src1, src2)
#define dr_ldci(c, dest, src1, imm) i_ldci(dest, src1, imm)
#define dr_stc(c, dest, src1, src2) i_stc(dest, src1, src2)
#define dr_stci(c, dest, src1, imm) i_stci(dest, src1, imm)
#define dr_has_ldbs(c) 1
#define dr_ldbsc(c, dest, src1, src2) i_ldbsc(dest, src1, src2)
#define dr_ldbsci(c, dest, src1, imm) i_ldbsci(dest, src1, imm)
#define dr_ldd(c, dest, src1, src2) i_ldd(dest, src1, src2)
#define dr_lddi(c, dest, src1, imm) i_lddi(dest, src1, imm)
#define dr_std(c, dest, src1, src2) i_std(dest, src1, src2)
#define dr_stdi(c, dest, src1, imm) i_stdi(dest, src1, imm)
#define dr_has_ldbs(c) 1
#define dr_ldbsd(c, dest, src1, src2) i_ldbsd(dest, src1, src2)
#define dr_ldbsdi(c, dest, src1, imm) i_ldbsdi(dest, src1, imm)
#define dr_ldf(c, dest, src1, src2) i_ldf(dest, src1, src2)
#define dr_ldfi(c, dest, src1, imm) i_ldfi(dest, src1, imm)
#define dr_stf(c, dest, src1, src2) i_stf(dest, src1, src2)
#define dr_stfi(c, dest, src1, imm) i_stfi(dest, src1, imm)
#define dr_has_ldbs(c) 1
#define dr_ldbsf(c, dest, src1, src2) i_ldbsf(dest, src1, src2)
#define dr_ldbsfi(c, dest, src1, imm) i_ldbsfi(dest, src1, imm)
#define dr_ldi(c, dest, src1, src2) i_ldi(dest, src1, src2)
#define dr_ldii(c, dest, src1, imm) i_ldii(dest, src1, imm)
#define dr_sti(c, dest, src1, src2) i_sti(dest, src1, src2)
#define dr_stii(c, dest, src1, imm) i_stii(dest, src1, imm)
#define dr_has_ldbs(c) 1
#define dr_ldbsi(c, dest, src1, src2) i_ldbsi(dest, src1, src2)
#define dr_ldbsii(c, dest, src1, imm) i_ldbsii(dest, src1, imm)
#define dr_ldl(c, dest, src1, src2) i_ldl(dest, src1, src2)
#define dr_ldli(c, dest, src1, imm) i_ldli(dest, src1, imm)
#define dr_stl(c, dest, src1, src2) i_stl(dest, src1, src2)
#define dr_stli(c, dest, src1, imm) i_stli(dest, src1, imm)
#define dr_has_ldbs(c) 1
#define dr_ldbsl(c, dest, src1, src2) i_ldbsl(dest, src1, src2)
#define dr_ldbsli(c, dest, src1, imm) i_ldbsli(dest, src1, imm)
#define dr_ldp(c, dest, src1, src2) i_ldp(dest, src1, src2)
#define dr_ldpi(c, dest, src1, imm) i_ldpi(dest, src1, imm)
#define dr_stp(c, dest, src1, src2) i_stp(dest, src1, src2)
#define dr_stpi(c, dest, src1, imm) i_stpi(dest, src1, imm)
#define dr_has_ldbs(c) 1
#define dr_ldbsp(c, dest, src1, src2) i_ldbsp(dest, src1, src2)
#define dr_ldbspi(c, dest, src1, imm) i_ldbspi(dest, src1, imm)
#define dr_lds(c, dest, src1, src2) i_lds(dest, src1, src2)
#define dr_ldsi(c, dest, src1, imm) i_ldsi(dest, src1, imm)
#define dr_sts(c, dest, src1, src2) i_sts(dest, src1, src2)
#define dr_stsi(c, dest, src1, imm) i_stsi(dest, src1, imm)
#define dr_has_ldbs(c) 1
#define dr_ldbss(c, dest, src1, src2) i_ldbss(dest, src1, src2)
#define dr_ldbssi(c, dest, src1, imm) i_ldbssi(dest, src1, imm)
#define dr_ldu(c, dest, src1, src2) i_ldu(dest, src1, src2)
#define dr_ldui(c, dest, src1, imm) i_ldui(dest, src1, imm)
#define dr_stu(c, dest, src1, src2) i_stu(dest, src1, src2)
#define dr_stui(c, dest, src1, imm) i_stui(dest, src1, imm)
#define dr_has_ldbs(c) 1
#define dr_ldbsu(c, dest, src1, src2) i_ldbsu(dest, src1, src2)
#define dr_ldbsui(c, dest, src1, imm) i_ldbsui(dest, src1, imm)
#define dr_lduc(c, dest, src1, src2) i_lduc(dest, src1, src2)
#define dr_lduci(c, dest, src1, imm) i_lduci(dest, src1, imm)
#define dr_stuc(c, dest, src1, src2) i_stuc(dest, src1, src2)
#define dr_stuci(c, dest, src1, imm) i_stuci(dest, src1, imm)
#define dr_has_ldbs(c) 1
#define dr_ldbsuc(c, dest, src1, src2) i_ldbsuc(dest, src1, src2)
#define dr_ldbsuci(c, dest, src1, imm) i_ldbsuci(dest, src1, imm)
#define dr_ldu(c, dest, src1, src2) i_ldu(dest, src1, src2)
#define dr_ldui(c, dest, src1, imm) i_ldui(dest, src1, imm)
#define dr_stu(c, dest, src1, src2) i_stu(dest, src1, src2)
#define dr_stui(c, dest, src1, imm) i_stui(dest, src1, imm)
#define dr_has_ldbs(c) 1
#define dr_ldbsu(c, dest, src1, src2) i_ldbsu(dest, src1, src2)
#define dr_ldbsui(c, dest, src1, imm) i_ldbsui(dest, src1, imm)
#define dr_ldul(c, dest, src1, src2) i_ldul(dest, src1, src2)
#define dr_lduli(c, dest, src1, imm) i_lduli(dest, src1, imm)
#define dr_stul(c, dest, src1, src2) i_stul(dest, src1, src2)
#define dr_stuli(c, dest, src1, imm) i_stuli(dest, src1, imm)
#define dr_has_ldbs(c) 1
#define dr_ldbsul(c, dest, src1, src2) i_ldbsul(dest, src1, src2)
#define dr_ldbsuli(c, dest, src1, imm) i_ldbsuli(dest, src1, imm)
#define dr_ldus(c, dest, src1, src2) i_ldus(dest, src1, src2)
#define dr_ldusi(c, dest, src1, imm) i_ldusi(dest, src1, imm)
#define dr_stus(c, dest, src1, src2) i_stus(dest, src1, src2)
#define dr_stusi(c, dest, src1, imm) i_stusi(dest, src1, imm)
#define dr_has_ldbs(c) 1
#define dr_ldbsus(c, dest, src1, src2) i_ldbsus(dest, src1, src2)
#define dr_ldbsusi(c, dest, src1, imm) i_ldbsusi(dest, src1, imm)
#define dr_retc(c, src) i_retc(src)
#define dr_retci(c, imm) i_retci(imm)
#define dr_retuc(c, src) i_retuc(src)
#define dr_retuci(c, imm) i_retuci(imm)
#define dr_rets(c, src) i_rets(src)
#define dr_retsi(c, imm) i_retsi(imm)
#define dr_retus(c, src) i_retus(src)
#define dr_retusi(c, imm) i_retusi(imm)
#define dr_reti(c, src) i_reti(src)
#define dr_retii(c, imm) i_retii(imm)
#define dr_retu(c, src) i_retu(src)
#define dr_retui(c, imm) i_retui(imm)
#define dr_retl(c, src) i_retl(src)
#define dr_retli(c, imm) i_retli(imm)
#define dr_retul(c, src) i_retul(src)
#define dr_retuli(c, imm) i_retuli(imm)
#define dr_retp(c, src) i_retp(src)
#define dr_retpi(c, imm) i_retpi(imm)
#define dr_retd(c, src) i_retd(src)
#define dr_retdi(c, imm) i_retdi(imm)
#define dr_retf(c, src) i_retf(src)
#define dr_retfi(c, imm) i_retfi(imm)
#define dr_movc(c, dest, src) i_movc(dest, src)
#define dr_movuc(c, dest, src) i_movuc(dest, src)
#define dr_movs(c, dest, src) i_movs(dest, src)
#define dr_movus(c, dest, src) i_movus(dest, src)
#define dr_movi(c, dest, src) i_movi(dest, src)
#define dr_movu(c, dest, src) i_movu(dest, src)
#define dr_movl(c, dest, src) i_movl(dest, src)
#define dr_movul(c, dest, src) i_movul(dest, src)
#define dr_movp(c, dest, src) i_movp(dest, src)
#define dr_movd(c, dest, src) i_movd(dest, src)
#define dr_movf(c, dest, src) i_movf(dest, src)
#define dr_setc(c, dest, imm) i_setc(dest, imm)
#define dr_setuc(c, dest, imm) i_setuc(dest, imm)
#define dr_sets(c, dest, imm) i_sets(dest, imm)
#define dr_setus(c, dest, imm) i_setus(dest, imm)
#define dr_seti(c, dest, imm) i_seti(dest, imm)
#define dr_setu(c, dest, imm) i_setu(dest, imm)
#define dr_setl(c, dest, imm) i_setl(dest, imm)
#define dr_setul(c, dest, imm) i_setul(dest, imm)
#define dr_setp(c, dest, imm) i_setp(dest, imm)
#define dr_setd(c, dest, imm) i_setd(dest, imm)
#define dr_setf(c, dest, imm) i_setf(dest, imm)
#define dr_push_argii(c, imm) i_argii(imm)
#define dr_push_argi(c, reg) i_argi(reg)
#define dr_push_argui(c, imm) i_argui(imm)
#define dr_push_argu(c, reg) i_argu(reg)
#define dr_push_argli(c, imm) i_argli(imm)
#define dr_push_argl(c, reg) i_argl(reg)
#define dr_push_arguli(c, imm) i_arguli(imm)
#define dr_push_argul(c, reg) i_argul(reg)
#define dr_push_argpi(c, imm) i_argpi(imm)
#define dr_push_argp(c, reg) i_argp(reg)
#define dr_push_argfi(c, imm) i_argfi(imm)
#define dr_push_argf(c, reg) i_argf(reg)
#define dr_push_argdi(c, imm) i_argdi(imm)
#define dr_push_argd(c, reg) i_argd(reg)
#define dr_calli(c, ptr) i_callii(ptr)
#define dr_callu(c, ptr) i_callui(ptr)
#define dr_calll(c, ptr) i_callli(ptr)
#define dr_callul(c, ptr) i_calluli(ptr)
#define dr_callf(c, ptr) i_callfi(ptr)
#define dr_calld(c, ptr) i_calldi(ptr)
#define dr_callv(c, ptr) i_callvi(ptr)
