/* VCODE Compatability functions/types */

#define drisc_parameter_type v_parameter_type
#define dr_param_alloc(c, argno, type, param) v_param_alloc(argno, type, param)
#define dr_param_struct_alloc(static_ctx, argno, type, param) v_param_struct_alloc(argno, type, param)
#define dr_proc(static_ctx, name) v_clambda(name)
#define dr_proc_params(static_ctx, name, arg_str, arg_list) v_lambda(name, arg_str, arg_list, V_LEAF, insns, sizeof(insns))
#define dr_end(static_ctx) v_end(0).v
#define dr_dump(static_ctx) v_dump(x)
#define dr_dmark(static_ctx, addr, label) v_dmark(addr, label)
#define dr_getreg(static_ctx, reg_p, type, class) v_getreg(reg_p, type, class)
#define dr_mk_unavail(static_ctx, type, reg); v_mk_unavail(type, reg)
#define dr_mk_avail(static_ctx, type, reg); v_mk_avail(type, reg)
#define dr_putreg(static_ctx, reg, type) v_putreg(reg, type)
#define dr_genlabel(static_ctx) v_genlabel()
#define dr_label(static_ctx, label) v_label(label)
#define v_fatal(str) do {fprintf(stderr, "%s\n", str); exit(0);} while (0)
#define dr_jv(static_ctx, label) v_jv(label)
#define dr_jp(static_ctx, dest_reg) v_jp(dest_reg)
#define dr_jpi(static_ctx, imm_dest) v_jpi(imm_dest)
#define dr_jalp(static_ctx, return_addr_reg, target) v_jalp(return_addr_reg, target)
#define dr_lp(static_ctx)  v_lp
#define dr_pp(static_ctx)  v_lp
#define dr_local(static_ctx, type) v_local(type)
#define dr_localb(static_ctx, bytes) v_localb(bytes) 
#define dr_push_init(c)
#define dr_do_reverse_vararg_push(c) (0)

#define dr_reg_t v_reg_t
#define DR_TEMP V_TEMP
#define DR_VAR V_VAR

#define DR_C V_C
#define DR_UC V_UC
#define DR_S V_S
#define DR_US V_US
#define DR_I V_I
#define DR_U V_U
#define DR_L V_L
#define DR_UL V_UL
#define DR_P V_P
#define DR_F V_F
#define DR_D V_D
#define	DR_V V_V
#define DR_B V_B

#define dr_addi(c, dest, src1, src2) v_addi(dest, src1, src2)
#define dr_addii(c, dest, src1, imm) v_addii(dest, src1, imm)
#define dr_addu(c, dest, src1, src2) v_addu(dest, src1, src2)
#define dr_addui(c, dest, src1, imm) v_addui(dest, src1, imm)
#define dr_addul(c, dest, src1, src2) v_addul(dest, src1, src2)
#define dr_adduli(c, dest, src1, imm) v_adduli(dest, src1, imm)
#define dr_addl(c, dest, src1, src2) v_addl(dest, src1, src2)
#define dr_addli(c, dest, src1, imm) v_addli(dest, src1, imm)
#define dr_subi(c, dest, src1, src2) v_subi(dest, src1, src2)
#define dr_subii(c, dest, src1, imm) v_subii(dest, src1, imm)
#define dr_subu(c, dest, src1, src2) v_subu(dest, src1, src2)
#define dr_subui(c, dest, src1, imm) v_subui(dest, src1, imm)
#define dr_subul(c, dest, src1, src2) v_subul(dest, src1, src2)
#define dr_subuli(c, dest, src1, imm) v_subuli(dest, src1, imm)
#define dr_subl(c, dest, src1, src2) v_subl(dest, src1, src2)
#define dr_subli(c, dest, src1, imm) v_subli(dest, src1, imm)
#define dr_muli(c, dest, src1, src2) v_muli(dest, src1, src2)
#define dr_mulii(c, dest, src1, imm) v_mulii(dest, src1, imm)
#define dr_mulu(c, dest, src1, src2) v_mulu(dest, src1, src2)
#define dr_mului(c, dest, src1, imm) v_mului(dest, src1, imm)
#define dr_mulul(c, dest, src1, src2) v_mulul(dest, src1, src2)
#define dr_mululi(c, dest, src1, imm) v_mululi(dest, src1, imm)
#define dr_mull(c, dest, src1, src2) v_mull(dest, src1, src2)
#define dr_mulli(c, dest, src1, imm) v_mulli(dest, src1, imm)
#define dr_divi(c, dest, src1, src2) v_divi(dest, src1, src2)
#define dr_divii(c, dest, src1, imm) v_divii(dest, src1, imm)
#define dr_divu(c, dest, src1, src2) v_divu(dest, src1, src2)
#define dr_divui(c, dest, src1, imm) v_divui(dest, src1, imm)
#define dr_divul(c, dest, src1, src2) v_divul(dest, src1, src2)
#define dr_divuli(c, dest, src1, imm) v_divuli(dest, src1, imm)
#define dr_divl(c, dest, src1, src2) v_divl(dest, src1, src2)
#define dr_divli(c, dest, src1, imm) v_divli(dest, src1, imm)
#define dr_modi(c, dest, src1, src2) v_modi(dest, src1, src2)
#define dr_modii(c, dest, src1, imm) v_modii(dest, src1, imm)
#define dr_modu(c, dest, src1, src2) v_modu(dest, src1, src2)
#define dr_modui(c, dest, src1, imm) v_modui(dest, src1, imm)
#define dr_modul(c, dest, src1, src2) v_modul(dest, src1, src2)
#define dr_moduli(c, dest, src1, imm) v_moduli(dest, src1, imm)
#define dr_modl(c, dest, src1, src2) v_modl(dest, src1, src2)
#define dr_modli(c, dest, src1, imm) v_modli(dest, src1, imm)
#define dr_xori(c, dest, src1, src2) v_xori(dest, src1, src2)
#define dr_xorii(c, dest, src1, imm) v_xorii(dest, src1, imm)
#define dr_xoru(c, dest, src1, src2) v_xoru(dest, src1, src2)
#define dr_xorui(c, dest, src1, imm) v_xorui(dest, src1, imm)
#define dr_xorul(c, dest, src1, src2) v_xorul(dest, src1, src2)
#define dr_xoruli(c, dest, src1, imm) v_xoruli(dest, src1, imm)
#define dr_xorl(c, dest, src1, src2) v_xorl(dest, src1, src2)
#define dr_xorli(c, dest, src1, imm) v_xorli(dest, src1, imm)
#define dr_andi(c, dest, src1, src2) v_andi(dest, src1, src2)
#define dr_andii(c, dest, src1, imm) v_andii(dest, src1, imm)
#define dr_andu(c, dest, src1, src2) v_andu(dest, src1, src2)
#define dr_andui(c, dest, src1, imm) v_andui(dest, src1, imm)
#define dr_andul(c, dest, src1, src2) v_andul(dest, src1, src2)
#define dr_anduli(c, dest, src1, imm) v_anduli(dest, src1, imm)
#define dr_andl(c, dest, src1, src2) v_andl(dest, src1, src2)
#define dr_andli(c, dest, src1, imm) v_andli(dest, src1, imm)
#define dr_ori(c, dest, src1, src2) v_ori(dest, src1, src2)
#define dr_orii(c, dest, src1, imm) v_orii(dest, src1, imm)
#define dr_oru(c, dest, src1, src2) v_oru(dest, src1, src2)
#define dr_orui(c, dest, src1, imm) v_orui(dest, src1, imm)
#define dr_orul(c, dest, src1, src2) v_orul(dest, src1, src2)
#define dr_oruli(c, dest, src1, imm) v_oruli(dest, src1, imm)
#define dr_orl(c, dest, src1, src2) v_orl(dest, src1, src2)
#define dr_orli(c, dest, src1, imm) v_orli(dest, src1, imm)
#define dr_lshi(c, dest, src1, src2) v_lshi(dest, src1, src2)
#define dr_lshii(c, dest, src1, imm) v_lshii(dest, src1, imm)
#define dr_lshu(c, dest, src1, src2) v_lshu(dest, src1, src2)
#define dr_lshui(c, dest, src1, imm) v_lshui(dest, src1, imm)
#define dr_lshul(c, dest, src1, src2) v_lshul(dest, src1, src2)
#define dr_lshuli(c, dest, src1, imm) v_lshuli(dest, src1, imm)
#define dr_lshl(c, dest, src1, src2) v_lshl(dest, src1, src2)
#define dr_lshli(c, dest, src1, imm) v_lshli(dest, src1, imm)
#define dr_rshi(c, dest, src1, src2) v_rshi(dest, src1, src2)
#define dr_rshii(c, dest, src1, imm) v_rshii(dest, src1, imm)
#define dr_rshu(c, dest, src1, src2) v_rshu(dest, src1, src2)
#define dr_rshui(c, dest, src1, imm) v_rshui(dest, src1, imm)
#define dr_rshul(c, dest, src1, src2) v_rshul(dest, src1, src2)
#define dr_rshuli(c, dest, src1, imm) v_rshuli(dest, src1, imm)
#define dr_rshl(c, dest, src1, src2) v_rshl(dest, src1, src2)
#define dr_rshli(c, dest, src1, imm) v_rshli(dest, src1, imm)
#define dr_addp(c, dest, src1, src2) v_addp(dest, src1, src2)
#define dr_addpi(c, dest, src1, imm) v_addpi(dest, src1, imm)
#define dr_subp(c, dest, src1, src2) v_subp(dest, src1, src2)
#define dr_subpi(c, dest, src1, imm) v_subpi(dest, src1, imm)
#define dr_addf(c, dest, src1, src2) v_addf(dest, src1, src2)
#define dr_addfi(c, dest, src1, imm) v_addfi(dest, src1, imm)
#define dr_addd(c, dest, src1, src2) v_addd(dest, src1, src2)
#define dr_adddi(c, dest, src1, imm) v_adddi(dest, src1, imm)
#define dr_subf(c, dest, src1, src2) v_subf(dest, src1, src2)
#define dr_subfi(c, dest, src1, imm) v_subfi(dest, src1, imm)
#define dr_subd(c, dest, src1, src2) v_subd(dest, src1, src2)
#define dr_subdi(c, dest, src1, imm) v_subdi(dest, src1, imm)
#define dr_mulf(c, dest, src1, src2) v_mulf(dest, src1, src2)
#define dr_mulfi(c, dest, src1, imm) v_mulfi(dest, src1, imm)
#define dr_muld(c, dest, src1, src2) v_muld(dest, src1, src2)
#define dr_muldi(c, dest, src1, imm) v_muldi(dest, src1, imm)
#define dr_divf(c, dest, src1, src2) v_divf(dest, src1, src2)
#define dr_divfi(c, dest, src1, imm) v_divfi(dest, src1, imm)
#define dr_divd(c, dest, src1, src2) v_divd(dest, src1, src2)
#define dr_divdi(c, dest, src1, imm) v_divdi(dest, src1, imm)
#define dr_noti(c, dest, src) v_noti(dest, src)
#define dr_notii(c, dest, imm) v_notii(dest, imm)
#define dr_notu(c, dest, src) v_notu(dest, src)
#define dr_notui(c, dest, imm) v_notui(dest, imm)
#define dr_notul(c, dest, src) v_notul(dest, src)
#define dr_notuli(c, dest, imm) v_notuli(dest, imm)
#define dr_notl(c, dest, src) v_notl(dest, src)
#define dr_notli(c, dest, imm) v_notli(dest, imm)
#define dr_comi(c, dest, src) v_comi(dest, src)
#define dr_comii(c, dest, imm) v_comii(dest, imm)
#define dr_comu(c, dest, src) v_comu(dest, src)
#define dr_comui(c, dest, imm) v_comui(dest, imm)
#define dr_comul(c, dest, src) v_comul(dest, src)
#define dr_comuli(c, dest, imm) v_comuli(dest, imm)
#define dr_coml(c, dest, src) v_coml(dest, src)
#define dr_comli(c, dest, imm) v_comli(dest, imm)
#define dr_negi(c, dest, src) v_negi(dest, src)
#define dr_negii(c, dest, imm) v_negii(dest, imm)
#define dr_negu(c, dest, src) v_negu(dest, src)
#define dr_negui(c, dest, imm) v_negui(dest, imm)
#define dr_negul(c, dest, src) v_negul(dest, src)
#define dr_neguli(c, dest, imm) v_neguli(dest, imm)
#define dr_negl(c, dest, src) v_negl(dest, src)
#define dr_negli(c, dest, imm) v_negli(dest, imm)
#define dr_negf(c, dest, src) v_negf(dest, src)
#define dr_negfi(c, dest, imm) v_negfi(dest, imm)
#define dr_negd(c, dest, src) v_negd(dest, src)
#define dr_negdi(c, dest, imm) v_negdi(dest, imm)
#define dr_beqi(c, src1, src2, label) v_beqi(src1, src2, label)
#define dr_beqii(c, src, imm, label) v_beqii(src, imm, label)
#define dr_bequ(c, src1, src2, label) v_bequ(src1, src2, label)
#define dr_bequi(c, src, imm, label) v_bequi(src, imm, label)
#define dr_bequl(c, src1, src2, label) v_bequl(src1, src2, label)
#define dr_bequli(c, src, imm, label) v_bequli(src, imm, label)
#define dr_beql(c, src1, src2, label) v_beql(src1, src2, label)
#define dr_beqli(c, src, imm, label) v_beqli(src, imm, label)
#define dr_beqp(c, src1, src2, label) v_beqp(src1, src2, label)
#define dr_beqpi(c, src, imm, label) v_beqpi(src, imm, label)
#define dr_beqd(c, src1, src2, label) v_beqd(src1, src2, label)
#define dr_beqdi(c, src, imm, label) v_beqdi(src, imm, label)
#define dr_beqf(c, src1, src2, label) v_beqf(src1, src2, label)
#define dr_beqfi(c, src, imm, label) v_beqfi(src, imm, label)
#define dr_bgei(c, src1, src2, label) v_bgei(src1, src2, label)
#define dr_bgeii(c, src, imm, label) v_bgeii(src, imm, label)
#define dr_bgeu(c, src1, src2, label) v_bgeu(src1, src2, label)
#define dr_bgeui(c, src, imm, label) v_bgeui(src, imm, label)
#define dr_bgeul(c, src1, src2, label) v_bgeul(src1, src2, label)
#define dr_bgeuli(c, src, imm, label) v_bgeuli(src, imm, label)
#define dr_bgel(c, src1, src2, label) v_bgel(src1, src2, label)
#define dr_bgeli(c, src, imm, label) v_bgeli(src, imm, label)
#define dr_bgep(c, src1, src2, label) v_bgep(src1, src2, label)
#define dr_bgepi(c, src, imm, label) v_bgepi(src, imm, label)
#define dr_bged(c, src1, src2, label) v_bged(src1, src2, label)
#define dr_bgedi(c, src, imm, label) v_bgedi(src, imm, label)
#define dr_bgef(c, src1, src2, label) v_bgef(src1, src2, label)
#define dr_bgefi(c, src, imm, label) v_bgefi(src, imm, label)
#define dr_bgti(c, src1, src2, label) v_bgti(src1, src2, label)
#define dr_bgtii(c, src, imm, label) v_bgtii(src, imm, label)
#define dr_bgtu(c, src1, src2, label) v_bgtu(src1, src2, label)
#define dr_bgtui(c, src, imm, label) v_bgtui(src, imm, label)
#define dr_bgtul(c, src1, src2, label) v_bgtul(src1, src2, label)
#define dr_bgtuli(c, src, imm, label) v_bgtuli(src, imm, label)
#define dr_bgtl(c, src1, src2, label) v_bgtl(src1, src2, label)
#define dr_bgtli(c, src, imm, label) v_bgtli(src, imm, label)
#define dr_bgtp(c, src1, src2, label) v_bgtp(src1, src2, label)
#define dr_bgtpi(c, src, imm, label) v_bgtpi(src, imm, label)
#define dr_bgtd(c, src1, src2, label) v_bgtd(src1, src2, label)
#define dr_bgtdi(c, src, imm, label) v_bgtdi(src, imm, label)
#define dr_bgtf(c, src1, src2, label) v_bgtf(src1, src2, label)
#define dr_bgtfi(c, src, imm, label) v_bgtfi(src, imm, label)
#define dr_blei(c, src1, src2, label) v_blei(src1, src2, label)
#define dr_bleii(c, src, imm, label) v_bleii(src, imm, label)
#define dr_bleu(c, src1, src2, label) v_bleu(src1, src2, label)
#define dr_bleui(c, src, imm, label) v_bleui(src, imm, label)
#define dr_bleul(c, src1, src2, label) v_bleul(src1, src2, label)
#define dr_bleuli(c, src, imm, label) v_bleuli(src, imm, label)
#define dr_blel(c, src1, src2, label) v_blel(src1, src2, label)
#define dr_bleli(c, src, imm, label) v_bleli(src, imm, label)
#define dr_blep(c, src1, src2, label) v_blep(src1, src2, label)
#define dr_blepi(c, src, imm, label) v_blepi(src, imm, label)
#define dr_bled(c, src1, src2, label) v_bled(src1, src2, label)
#define dr_bledi(c, src, imm, label) v_bledi(src, imm, label)
#define dr_blef(c, src1, src2, label) v_blef(src1, src2, label)
#define dr_blefi(c, src, imm, label) v_blefi(src, imm, label)
#define dr_blti(c, src1, src2, label) v_blti(src1, src2, label)
#define dr_bltii(c, src, imm, label) v_bltii(src, imm, label)
#define dr_bltu(c, src1, src2, label) v_bltu(src1, src2, label)
#define dr_bltui(c, src, imm, label) v_bltui(src, imm, label)
#define dr_bltul(c, src1, src2, label) v_bltul(src1, src2, label)
#define dr_bltuli(c, src, imm, label) v_bltuli(src, imm, label)
#define dr_bltl(c, src1, src2, label) v_bltl(src1, src2, label)
#define dr_bltli(c, src, imm, label) v_bltli(src, imm, label)
#define dr_bltp(c, src1, src2, label) v_bltp(src1, src2, label)
#define dr_bltpi(c, src, imm, label) v_bltpi(src, imm, label)
#define dr_bltd(c, src1, src2, label) v_bltd(src1, src2, label)
#define dr_bltdi(c, src, imm, label) v_bltdi(src, imm, label)
#define dr_bltf(c, src1, src2, label) v_bltf(src1, src2, label)
#define dr_bltfi(c, src, imm, label) v_bltfi(src, imm, label)
#define dr_bnei(c, src1, src2, label) v_bnei(src1, src2, label)
#define dr_bneii(c, src, imm, label) v_bneii(src, imm, label)
#define dr_bneu(c, src1, src2, label) v_bneu(src1, src2, label)
#define dr_bneui(c, src, imm, label) v_bneui(src, imm, label)
#define dr_bneul(c, src1, src2, label) v_bneul(src1, src2, label)
#define dr_bneuli(c, src, imm, label) v_bneuli(src, imm, label)
#define dr_bnel(c, src1, src2, label) v_bnel(src1, src2, label)
#define dr_bneli(c, src, imm, label) v_bneli(src, imm, label)
#define dr_bnep(c, src1, src2, label) v_bnep(src1, src2, label)
#define dr_bnepi(c, src, imm, label) v_bnepi(src, imm, label)
#define dr_bned(c, src1, src2, label) v_bned(src1, src2, label)
#define dr_bnedi(c, src, imm, label) v_bnedi(src, imm, label)
#define dr_bnef(c, src1, src2, label) v_bnef(src1, src2, label)
#define dr_bnefi(c, src, imm, label) v_bnefi(src, imm, label)
#define dr_cvc2i(c, dest, src) v_cvc2i(dest, src)
#define dr_cvc2ii(c, src, imm) v_cvc2ii(src, imm)
#define dr_cvc2u(c, dest, src) v_cvc2u(dest, src)
#define dr_cvc2ui(c, src, imm) v_cvc2ui(src, imm)
#define dr_cvc2ul(c, dest, src) v_cvc2ul(dest, src)
#define dr_cvc2uli(c, src, imm) v_cvc2uli(src, imm)
#define dr_cvc2l(c, dest, src) v_cvc2l(dest, src)
#define dr_cvc2li(c, src, imm) v_cvc2li(src, imm)
#define dr_cvd2i(c, dest, src) v_cvd2i(dest, src)
#define dr_cvd2ii(c, src, imm) v_cvd2ii(src, imm)
#define dr_cvd2u(c, dest, src) v_cvd2u(dest, src)
#define dr_cvd2ui(c, src, imm) v_cvd2ui(src, imm)
#define dr_cvd2ul(c, dest, src) v_cvd2ul(dest, src)
#define dr_cvd2uli(c, src, imm) v_cvd2uli(src, imm)
#define dr_cvd2l(c, dest, src) v_cvd2l(dest, src)
#define dr_cvd2li(c, src, imm) v_cvd2li(src, imm)
#define dr_cvf2i(c, dest, src) v_cvf2i(dest, src)
#define dr_cvf2ii(c, src, imm) v_cvf2ii(src, imm)
#define dr_cvf2u(c, dest, src) v_cvf2u(dest, src)
#define dr_cvf2ui(c, src, imm) v_cvf2ui(src, imm)
#define dr_cvf2ul(c, dest, src) v_cvf2ul(dest, src)
#define dr_cvf2uli(c, src, imm) v_cvf2uli(src, imm)
#define dr_cvf2l(c, dest, src) v_cvf2l(dest, src)
#define dr_cvf2li(c, src, imm) v_cvf2li(src, imm)
#define dr_cvi2u(c, dest, src) v_cvi2u(dest, src)
#define dr_cvi2ui(c, src, imm) v_cvi2ui(src, imm)
#define dr_cvi2ul(c, dest, src) v_cvi2ul(dest, src)
#define dr_cvi2uli(c, src, imm) v_cvi2uli(src, imm)
#define dr_cvi2l(c, dest, src) v_cvi2l(dest, src)
#define dr_cvi2li(c, src, imm) v_cvi2li(src, imm)
#define dr_cvl2i(c, dest, src) v_cvl2i(dest, src)
#define dr_cvl2ii(c, src, imm) v_cvl2ii(src, imm)
#define dr_cvl2u(c, dest, src) v_cvl2u(dest, src)
#define dr_cvl2ui(c, src, imm) v_cvl2ui(src, imm)
#define dr_cvl2ul(c, dest, src) v_cvl2ul(dest, src)
#define dr_cvl2uli(c, src, imm) v_cvl2uli(src, imm)
#define dr_cvs2i(c, dest, src) v_cvs2i(dest, src)
#define dr_cvs2ii(c, src, imm) v_cvs2ii(src, imm)
#define dr_cvs2u(c, dest, src) v_cvs2u(dest, src)
#define dr_cvs2ui(c, src, imm) v_cvs2ui(src, imm)
#define dr_cvs2ul(c, dest, src) v_cvs2ul(dest, src)
#define dr_cvs2uli(c, src, imm) v_cvs2uli(src, imm)
#define dr_cvs2l(c, dest, src) v_cvs2l(dest, src)
#define dr_cvs2li(c, src, imm) v_cvs2li(src, imm)
#define dr_cvu2i(c, dest, src) v_cvu2i(dest, src)
#define dr_cvu2ii(c, src, imm) v_cvu2ii(src, imm)
#define dr_cvu2ul(c, dest, src) v_cvu2ul(dest, src)
#define dr_cvu2uli(c, src, imm) v_cvu2uli(src, imm)
#define dr_cvu2l(c, dest, src) v_cvu2l(dest, src)
#define dr_cvu2li(c, src, imm) v_cvu2li(src, imm)
#define dr_cvul2i(c, dest, src) v_cvul2i(dest, src)
#define dr_cvul2ii(c, src, imm) v_cvul2ii(src, imm)
#define dr_cvul2u(c, dest, src) v_cvul2u(dest, src)
#define dr_cvul2ui(c, src, imm) v_cvul2ui(src, imm)
#define dr_cvul2l(c, dest, src) v_cvul2l(dest, src)
#define dr_cvul2li(c, src, imm) v_cvul2li(src, imm)
#define dr_cvus2i(c, dest, src) v_cvus2i(dest, src)
#define dr_cvus2ii(c, src, imm) v_cvus2ii(src, imm)
#define dr_cvus2u(c, dest, src) v_cvus2u(dest, src)
#define dr_cvus2ui(c, src, imm) v_cvus2ui(src, imm)
#define dr_cvus2ul(c, dest, src) v_cvus2ul(dest, src)
#define dr_cvus2uli(c, src, imm) v_cvus2uli(src, imm)
#define dr_cvus2l(c, dest, src) v_cvus2l(dest, src)
#define dr_cvus2li(c, src, imm) v_cvus2li(src, imm)
#define dr_cvd2f(c, dest, src) v_cvd2f(dest, src)
#define dr_cvd2fi(c, src, imm) v_cvd2fi(src, imm)
#define dr_cvf2d(c, dest, src) v_cvf2d(dest, src)
#define dr_cvf2di(c, src, imm) v_cvf2di(src, imm)
#define dr_cvi2f(c, dest, src) v_cvi2f(dest, src)
#define dr_cvi2fi(c, src, imm) v_cvi2fi(src, imm)
#define dr_cvi2d(c, dest, src) v_cvi2d(dest, src)
#define dr_cvi2di(c, src, imm) v_cvi2di(src, imm)
#define dr_cvl2f(c, dest, src) v_cvl2f(dest, src)
#define dr_cvl2fi(c, src, imm) v_cvl2fi(src, imm)
#define dr_cvl2d(c, dest, src) v_cvl2d(dest, src)
#define dr_cvl2di(c, src, imm) v_cvl2di(src, imm)
#define dr_cvu2f(c, dest, src) v_cvu2f(dest, src)
#define dr_cvu2fi(c, src, imm) v_cvu2fi(src, imm)
#define dr_cvu2d(c, dest, src) v_cvu2d(dest, src)
#define dr_cvu2di(c, src, imm) v_cvu2di(src, imm)
#define dr_cvul2f(c, dest, src) v_cvul2f(dest, src)
#define dr_cvul2fi(c, src, imm) v_cvul2fi(src, imm)
#define dr_cvul2d(c, dest, src) v_cvul2d(dest, src)
#define dr_cvul2di(c, src, imm) v_cvul2di(src, imm)
#define dr_cvi2c(c, dest, src) v_cvi2c(dest, src)
#define dr_cvi2ci(c, src, imm) v_cvi2ci(src, imm)
#define dr_cvi2s(c, dest, src) v_cvi2s(dest, src)
#define dr_cvi2si(c, src, imm) v_cvi2si(src, imm)
#define dr_cvl2c(c, dest, src) v_cvl2c(dest, src)
#define dr_cvl2ci(c, src, imm) v_cvl2ci(src, imm)
#define dr_cvl2s(c, dest, src) v_cvl2s(dest, src)
#define dr_cvl2si(c, src, imm) v_cvl2si(src, imm)
#define dr_cvu2c(c, dest, src) v_cvu2c(dest, src)
#define dr_cvu2ci(c, src, imm) v_cvu2ci(src, imm)
#define dr_cvu2s(c, dest, src) v_cvu2s(dest, src)
#define dr_cvu2si(c, src, imm) v_cvu2si(src, imm)
#define dr_cvul2c(c, dest, src) v_cvul2c(dest, src)
#define dr_cvul2ci(c, src, imm) v_cvul2ci(src, imm)
#define dr_cvul2s(c, dest, src) v_cvul2s(dest, src)
#define dr_cvul2si(c, src, imm) v_cvul2si(src, imm)
#define dr_cvp2ul(c, dest, src) v_cvp2ul(dest, src)
#define dr_cvp2uli(c, src, imm) v_cvp2uli(src, imm)
#define dr_cvul2p(c, dest, src) v_cvul2p(dest, src)
#define dr_cvul2pi(c, src, imm) v_cvul2pi(src, imm)
#define dr_ldc(c, dest, src1, src2) v_ldc(dest, src1, src2)
#define dr_ldci(c, dest, src1, imm) v_ldci(dest, src1, imm)
#define dr_stc(c, dest, src1, src2) v_stc(dest, src1, src2)
#define dr_stci(c, dest, src1, imm) v_stci(dest, src1, imm)
#define dr_has_ldbs(c) 1
#define dr_ldbsc(c, dest, src1, src2) v_ldbsc(dest, src1, src2)
#define dr_ldbsci(c, dest, src1, imm) v_ldbsci(dest, src1, imm)
#define dr_ldd(c, dest, src1, src2) v_ldd(dest, src1, src2)
#define dr_lddi(c, dest, src1, imm) v_lddi(dest, src1, imm)
#define dr_std(c, dest, src1, src2) v_std(dest, src1, src2)
#define dr_stdi(c, dest, src1, imm) v_stdi(dest, src1, imm)
#define dr_has_ldbs(c) 1
#define dr_ldbsd(c, dest, src1, src2) v_ldbsd(dest, src1, src2)
#define dr_ldbsdi(c, dest, src1, imm) v_ldbsdi(dest, src1, imm)
#define dr_ldf(c, dest, src1, src2) v_ldf(dest, src1, src2)
#define dr_ldfi(c, dest, src1, imm) v_ldfi(dest, src1, imm)
#define dr_stf(c, dest, src1, src2) v_stf(dest, src1, src2)
#define dr_stfi(c, dest, src1, imm) v_stfi(dest, src1, imm)
#define dr_has_ldbs(c) 1
#define dr_ldbsf(c, dest, src1, src2) v_ldbsf(dest, src1, src2)
#define dr_ldbsfi(c, dest, src1, imm) v_ldbsfi(dest, src1, imm)
#define dr_ldi(c, dest, src1, src2) v_ldi(dest, src1, src2)
#define dr_ldii(c, dest, src1, imm) v_ldii(dest, src1, imm)
#define dr_sti(c, dest, src1, src2) v_sti(dest, src1, src2)
#define dr_stii(c, dest, src1, imm) v_stii(dest, src1, imm)
#define dr_has_ldbs(c) 1
#define dr_ldbsi(c, dest, src1, src2) v_ldbsi(dest, src1, src2)
#define dr_ldbsii(c, dest, src1, imm) v_ldbsii(dest, src1, imm)
#define dr_ldl(c, dest, src1, src2) v_ldl(dest, src1, src2)
#define dr_ldli(c, dest, src1, imm) v_ldli(dest, src1, imm)
#define dr_stl(c, dest, src1, src2) v_stl(dest, src1, src2)
#define dr_stli(c, dest, src1, imm) v_stli(dest, src1, imm)
#define dr_has_ldbs(c) 1
#define dr_ldbsl(c, dest, src1, src2) v_ldbsl(dest, src1, src2)
#define dr_ldbsli(c, dest, src1, imm) v_ldbsli(dest, src1, imm)
#define dr_ldp(c, dest, src1, src2) v_ldp(dest, src1, src2)
#define dr_ldpi(c, dest, src1, imm) v_ldpi(dest, src1, imm)
#define dr_stp(c, dest, src1, src2) v_stp(dest, src1, src2)
#define dr_stpi(c, dest, src1, imm) v_stpi(dest, src1, imm)
#define dr_has_ldbs(c) 1
#define dr_ldbsp(c, dest, src1, src2) v_ldbsp(dest, src1, src2)
#define dr_ldbspi(c, dest, src1, imm) v_ldbspi(dest, src1, imm)
#define dr_lds(c, dest, src1, src2) v_lds(dest, src1, src2)
#define dr_ldsi(c, dest, src1, imm) v_ldsi(dest, src1, imm)
#define dr_sts(c, dest, src1, src2) v_sts(dest, src1, src2)
#define dr_stsi(c, dest, src1, imm) v_stsi(dest, src1, imm)
#define dr_has_ldbs(c) 1
#define dr_ldbss(c, dest, src1, src2) v_ldbss(dest, src1, src2)
#define dr_ldbssi(c, dest, src1, imm) v_ldbssi(dest, src1, imm)
#define dr_ldu(c, dest, src1, src2) v_ldu(dest, src1, src2)
#define dr_ldui(c, dest, src1, imm) v_ldui(dest, src1, imm)
#define dr_stu(c, dest, src1, src2) v_stu(dest, src1, src2)
#define dr_stui(c, dest, src1, imm) v_stui(dest, src1, imm)
#define dr_has_ldbs(c) 1
#define dr_ldbsu(c, dest, src1, src2) v_ldbsu(dest, src1, src2)
#define dr_ldbsui(c, dest, src1, imm) v_ldbsui(dest, src1, imm)
#define dr_lduc(c, dest, src1, src2) v_lduc(dest, src1, src2)
#define dr_lduci(c, dest, src1, imm) v_lduci(dest, src1, imm)
#define dr_stuc(c, dest, src1, src2) v_stuc(dest, src1, src2)
#define dr_stuci(c, dest, src1, imm) v_stuci(dest, src1, imm)
#define dr_has_ldbs(c) 1
#define dr_ldbsuc(c, dest, src1, src2) v_ldbsuc(dest, src1, src2)
#define dr_ldbsuci(c, dest, src1, imm) v_ldbsuci(dest, src1, imm)
#define dr_ldu(c, dest, src1, src2) v_ldu(dest, src1, src2)
#define dr_ldui(c, dest, src1, imm) v_ldui(dest, src1, imm)
#define dr_stu(c, dest, src1, src2) v_stu(dest, src1, src2)
#define dr_stui(c, dest, src1, imm) v_stui(dest, src1, imm)
#define dr_has_ldbs(c) 1
#define dr_ldbsu(c, dest, src1, src2) v_ldbsu(dest, src1, src2)
#define dr_ldbsui(c, dest, src1, imm) v_ldbsui(dest, src1, imm)
#define dr_ldul(c, dest, src1, src2) v_ldul(dest, src1, src2)
#define dr_lduli(c, dest, src1, imm) v_lduli(dest, src1, imm)
#define dr_stul(c, dest, src1, src2) v_stul(dest, src1, src2)
#define dr_stuli(c, dest, src1, imm) v_stuli(dest, src1, imm)
#define dr_has_ldbs(c) 1
#define dr_ldbsul(c, dest, src1, src2) v_ldbsul(dest, src1, src2)
#define dr_ldbsuli(c, dest, src1, imm) v_ldbsuli(dest, src1, imm)
#define dr_ldus(c, dest, src1, src2) v_ldus(dest, src1, src2)
#define dr_ldusi(c, dest, src1, imm) v_ldusi(dest, src1, imm)
#define dr_stus(c, dest, src1, src2) v_stus(dest, src1, src2)
#define dr_stusi(c, dest, src1, imm) v_stusi(dest, src1, imm)
#define dr_has_ldbs(c) 1
#define dr_ldbsus(c, dest, src1, src2) v_ldbsus(dest, src1, src2)
#define dr_ldbsusi(c, dest, src1, imm) v_ldbsusi(dest, src1, imm)
#define dr_retc(c, src) v_retc(src)
#define dr_retci(c, imm) v_retci(imm)
#define dr_retuc(c, src) v_retuc(src)
#define dr_retuci(c, imm) v_retuci(imm)
#define dr_rets(c, src) v_rets(src)
#define dr_retsi(c, imm) v_retsi(imm)
#define dr_retus(c, src) v_retus(src)
#define dr_retusi(c, imm) v_retusi(imm)
#define dr_reti(c, src) v_reti(src)
#define dr_retii(c, imm) v_retii(imm)
#define dr_retu(c, src) v_retu(src)
#define dr_retui(c, imm) v_retui(imm)
#define dr_retl(c, src) v_retl(src)
#define dr_retli(c, imm) v_retli(imm)
#define dr_retul(c, src) v_retul(src)
#define dr_retuli(c, imm) v_retuli(imm)
#define dr_retp(c, src) v_retp(src)
#define dr_retpi(c, imm) v_retpi(imm)
#define dr_retd(c, src) v_retd(src)
#define dr_retdi(c, imm) v_retdi(imm)
#define dr_retf(c, src) v_retf(src)
#define dr_retfi(c, imm) v_retfi(imm)
#define dr_movc(c, dest, src) v_movc(dest, src)
#define dr_movuc(c, dest, src) v_movuc(dest, src)
#define dr_movs(c, dest, src) v_movs(dest, src)
#define dr_movus(c, dest, src) v_movus(dest, src)
#define dr_movi(c, dest, src) v_movi(dest, src)
#define dr_movu(c, dest, src) v_movu(dest, src)
#define dr_movl(c, dest, src) v_movl(dest, src)
#define dr_movul(c, dest, src) v_movul(dest, src)
#define dr_movp(c, dest, src) v_movp(dest, src)
#define dr_movd(c, dest, src) v_movd(dest, src)
#define dr_movf(c, dest, src) v_movf(dest, src)
#define dr_setc(c, dest, imm) v_setc(dest, imm)
#define dr_setuc(c, dest, imm) v_setuc(dest, imm)
#define dr_sets(c, dest, imm) v_sets(dest, imm)
#define dr_setus(c, dest, imm) v_setus(dest, imm)
#define dr_seti(c, dest, imm) v_seti(dest, imm)
#define dr_setu(c, dest, imm) v_setu(dest, imm)
#define dr_setl(c, dest, imm) v_setl(dest, imm)
#define dr_setul(c, dest, imm) v_setul(dest, imm)
#define dr_setp(c, dest, imm) v_setp(dest, imm)
#define dr_setd(c, dest, imm) v_setd(dest, imm)
#define dr_setf(c, dest, imm) v_setf(dest, imm)
#define dr_push_argii(c, imm) v_push_argii(imm)
#define dr_push_argi(c, reg) v_push_argi(reg)
#define dr_push_argui(c, imm) v_push_argui(imm)
#define dr_push_argu(c, reg) v_push_argu(reg)
#define dr_push_argli(c, imm) v_push_argli(imm)
#define dr_push_argl(c, reg) v_push_argl(reg)
#define dr_push_arguli(c, imm) v_push_arguli(imm)
#define dr_push_argul(c, reg) v_push_argul(reg)
#define dr_push_argpi(c, imm) v_push_argpi(imm)
#define dr_push_argp(c, reg) v_push_argp(reg)
#define dr_push_argfi(c, imm) v_push_argfi(imm)
#define dr_push_argf(c, reg) v_push_argf(reg)
#define dr_push_argdi(c, imm) v_push_argdi(imm)
#define dr_push_argd(c, reg) v_push_argd(reg)
#define dr_calli(c, ptr) v_ccalli(ptr)
#define dr_callu(c, ptr) v_ccallu(ptr)
#define dr_calll(c, ptr) v_ccalll(ptr)
#define dr_callul(c, ptr) v_ccallul(ptr)
#define dr_callf(c, ptr) v_ccallf(ptr)
#define dr_calld(c, ptr) v_ccalld(ptr)
#define dr_callv(c, ptr) v_ccallv(ptr)
#define dr_savei(c, reg) v_savei(reg)
#define dr_restorei(c, reg) v_restorei(reg)
#define dr_saveu(c, reg) v_saveu(reg)
#define dr_restoreu(c, reg) v_restoreu(reg)
#define dr_savel(c, reg) v_savel(reg)
#define dr_restorel(c, reg) v_restorel(reg)
#define dr_saveul(c, reg) v_saveul(reg)
#define dr_restoreul(c, reg) v_restoreul(reg)
#define dr_savep(c, reg) v_savep(reg)
#define dr_restorep(c, reg) v_restorep(reg)
#define dr_saved(c, reg) v_saved(reg)
#define dr_restored(c, reg) v_restored(reg)
#define dr_savef(c, reg) v_savef(reg)
#define dr_restoref(c, reg) v_restoref(reg)
