/* This file is generated from base.ops.  Do not edit directly. */

struct drisc_private_ctx;

typedef struct drisc_private_ctx *private_ctx;

struct jmp_table_s;

typedef struct jmp_table_s *jmp_table;

typedef struct drisc_ctx_s {
    jmp_table j;
    private_ctx p;
    int dr_local_pointer;
    int dr_param_pointer;
    int drisc_debug;
}*drisc_ctx;

typedef int dr_reg_t;

typedef void (*drisc_mach_init_routine)(drisc_ctx c);
typedef void (*drisc_mach_proc_start)(drisc_ctx c, char *name, int param_count, void *params, dr_reg_t *arg_reg_list);
typedef void (*drisc_mach_end)(drisc_ctx c);
typedef void (*arith_op3)(drisc_ctx c, int data1, int data2, int dest, int src1, int src2);
typedef void (*arith_op3i)(drisc_ctx c, int data1, int data2, int dest, int src1, long imm);
typedef void (*arith_op3fi)(drisc_ctx c, int data1, int data2, int dest, int src1, double imm);
typedef void (*arith_op2)(drisc_ctx c, int data1, int data2, int dest, int src);
typedef void (*arith_op2i)(drisc_ctx c, int data1, int data2, int dest, long imm);
typedef void (*branch_op)(drisc_ctx c, int data1, int data2, int src1, int src2, int label);
typedef void (*branch_opi)(drisc_ctx c, int data1, int data2, int src, long imm, int label);
typedef void (*cvt_op)(drisc_ctx c, int data1, int data2, int dest, int src);
typedef void (*cvt_opi)(drisc_ctx c, int data1, int data2, int dest, long imm);
typedef void (*ldst_op)(drisc_ctx c, int data1, int data2, int dest, int src1, int src2);
typedef void (*ldst_opi)(drisc_ctx c, int data1, int data2, int dest, int src1, long imm);
typedef void (*ret_op)(drisc_ctx c, int data1, int data2, int src);
typedef void (*ret_opi)(drisc_ctx c, int data1, int data2, long imm);
typedef void (*jmp_op)(drisc_ctx c, unsigned long arg);
typedef void (*jal_op)(drisc_ctx c, int dest, int target);
typedef int (*call_opi)(drisc_ctx c, int type, void *xfer_address);
typedef int (*call_opr)(drisc_ctx c, int type, int src);
typedef void (*setf_opi)(drisc_ctx c, int data1, int data2, int dest, double imm);
typedef void (*push_op)(drisc_ctx c, int type, int reg);
typedef void (*push_opi)(drisc_ctx c, int type, long value);
typedef void (*push_opfi)(drisc_ctx c, int type, double value);
typedef int (*local_op)(drisc_ctx c, int flag, int val);
typedef void (*save_restore_op)(drisc_ctx c, int save_restore_flag, int type, int reg);
typedef int (*init_disassembly_op)(drisc_ctx c, void *dis_info);
typedef int (*print_insn_op)(drisc_ctx c, void *dis_info, void *insn);
typedef void (*print_reg_op)(drisc_ctx c, int typ, int reg);
typedef int (*count_insn_op)(drisc_ctx c, int start, int end);

typedef struct jmp_data_s {
    short data1;
    short data2;
} jmp_data;

struct jmp_table_s {
    drisc_mach_init_routine init;
    drisc_mach_proc_start proc_start;
    drisc_mach_end end;
    int *type_align;
    arith_op3 *jmp_a3;
    jmp_data *a3_data;
    arith_op3i *jmp_a3i;
    jmp_data *a3i_data;
    arith_op3fi *jmp_f3i;
    jmp_data *f3i_data;
    arith_op2 *jmp_a2;
    arith_op2i *jmp_a2i;
    jmp_data *a2_data;
    branch_op *jmp_b;
    branch_opi *jmp_bi;
    jmp_data *b_data;
    cvt_op convert;
    ldst_op load;
    ldst_op bsload;
    ldst_opi loadi;
    ldst_opi bsloadi;
    ldst_op store;
    ldst_opi storei;
    ret_op ret;
    ret_opi reti;
    arith_op2 mov;
    arith_op2i set;
    setf_opi setf;
    jmp_op jv;
    jmp_op jp;
    jmp_op jpi;
    jal_op jal;
    call_opi calli;
    call_opr callr;
    push_op push;
    push_opi pushi;
    push_opfi pushfi;
    local_op local;
    save_restore_op save_restore;
    
    init_disassembly_op init_disassembly;
    print_insn_op print_insn;
    print_reg_op print_reg;
    count_insn_op count_insn;
    int do_reverse_push;
};

typedef struct { 
    int is_register;		/* true if parameter is in register */
    unsigned reg;		/* register it's in */
    int offset;			/* otherwise at this offset from stack */
} drisc_parameter_type;
#if defined(_MSC_VER)
#ifdef DRISC_DLL_EXPORTS
#define EXTERN extern __declspec(dllexport)
#else
#define EXTERN extern __declspec(dllimport)
#endif
#else
#define EXTERN extern
#endif

extern jmp_table sparc_jump_table;
EXTERN drisc_ctx dr_init();
EXTERN drisc_ctx dr_vinit();
EXTERN void dr_free_context(drisc_ctx c);
EXTERN void* dr_take_code(drisc_ctx c);
EXTERN int dr_genlabel(drisc_ctx c);
EXTERN void dr_label(drisc_ctx c, int label);
EXTERN void dr_dmark(drisc_ctx c, void *addr, int label);
EXTERN int dr_getreg(drisc_ctx c, dr_reg_t *reg_p, int type, int class);
EXTERN int dr_getvreg(drisc_ctx c, int typ);
EXTERN void dr_putreg(drisc_ctx c, dr_reg_t reg_p, int type);
EXTERN void dr_mk_unavail(drisc_ctx c, int type, dr_reg_t reg);
EXTERN void dr_mk_avail(drisc_ctx c, int type, dr_reg_t reg);
EXTERN void dr_rawput(drisc_ctx c, dr_reg_t reg_p, int type, int class);
EXTERN void dr_rawget(drisc_ctx c, dr_reg_t reg_p, int type, int class);
EXTERN void dr_proc(drisc_ctx c, char *name);
EXTERN void dr_param_alloc(drisc_ctx c, int argno, int type, 
			  dr_reg_t *regp);
EXTERN void dr_param_struct_alloc(drisc_ctx c, int argno, int type, 
				 drisc_parameter_type *paramp);
EXTERN dr_reg_t dr_param(drisc_ctx c, int argno);
EXTERN dr_reg_t dr_vparam(drisc_ctx c, int argno);
EXTERN void dr_proc_params(drisc_ctx c, char *name, char *arg_str);
EXTERN void dr_dump(drisc_ctx c);
EXTERN void *dr_end(drisc_ctx c);
EXTERN int dr_do_reverse_vararg_push(drisc_ctx c);
EXTERN int dr_getvblock(drisc_ctx c, int size);
EXTERN void dr_virtual_lea(drisc_ctx c, int dest, int src);
EXTERN void dr_pbr(drisc_ctx c, int op_type, int data_type, dr_reg_t src1, 
		   dr_reg_t src2, int label);

#define dr_type_align(t) c->j->type_align[t]
#define dr_lp(c) c->dr_local_pointer
#define dr_pp(c) c->dr_param_pointer
#define dr_local(c, type) c->j->local(c, 0, type)
#define dr_localb(c, bytes) c->j->local(c, 1, bytes)


/* atomic types */
enum {
    DR_C,    /* char */
    DR_UC,   /* unsigned char */
    DR_S,    /* short */
    DR_US,   /* unsigned short */
    DR_I,    /* int */
    DR_U,    /* unsigned */
    DR_L,    /* long */
    DR_UL,   /* unsigned long */
    DR_P,    /* pointer */
    DR_F,    /* floating */
    DR_D,    /* double */
    DR_V,    /* void */
    DR_B,    /* block structure */
    DR_ERR   /* no type */
};

enum {DR_VAR, DR_TEMP};

#define dr_jmp_addi 0
#define dr_jmp_addu 1
#define dr_jmp_addul 2
#define dr_jmp_addl 3
#define dr_jmp_subi 4
#define dr_jmp_subu 5
#define dr_jmp_subul 6
#define dr_jmp_subl 7
#define dr_jmp_muli 8
#define dr_jmp_mulu 9
#define dr_jmp_mulul 10
#define dr_jmp_mull 11
#define dr_jmp_divi 12
#define dr_jmp_divu 13
#define dr_jmp_divul 14
#define dr_jmp_divl 15
#define dr_jmp_modi 16
#define dr_jmp_modu 17
#define dr_jmp_modul 18
#define dr_jmp_modl 19
#define dr_jmp_xori 20
#define dr_jmp_xoru 21
#define dr_jmp_xorul 22
#define dr_jmp_xorl 23
#define dr_jmp_andi 24
#define dr_jmp_andu 25
#define dr_jmp_andul 26
#define dr_jmp_andl 27
#define dr_jmp_ori 28
#define dr_jmp_oru 29
#define dr_jmp_orul 30
#define dr_jmp_orl 31
#define dr_jmp_lshi 32
#define dr_jmp_lshu 33
#define dr_jmp_lshul 34
#define dr_jmp_lshl 35
#define dr_jmp_rshi 36
#define dr_jmp_rshu 37
#define dr_jmp_rshul 38
#define dr_jmp_rshl 39
#define dr_addi(c, dest, src1, src2) (c->j->jmp_a3)[dr_jmp_addi](c, c->j->a3_data[dr_jmp_addi].data1, c->j->a3_data[dr_jmp_addi].data2, dest, src1, src2)
#define dr_addii(c, dest, src1, imm) (c->j->jmp_a3i)[dr_jmp_addi](c, c->j->a3i_data[dr_jmp_addi].data1, c->j->a3i_data[dr_jmp_addi].data2, dest, src1, imm)
#define dr_addu(c, dest, src1, src2) (c->j->jmp_a3)[dr_jmp_addu](c, c->j->a3_data[dr_jmp_addu].data1, c->j->a3_data[dr_jmp_addu].data2, dest, src1, src2)
#define dr_addui(c, dest, src1, imm) (c->j->jmp_a3i)[dr_jmp_addu](c, c->j->a3i_data[dr_jmp_addu].data1, c->j->a3i_data[dr_jmp_addu].data2, dest, src1, imm)
#define dr_addul(c, dest, src1, src2) (c->j->jmp_a3)[dr_jmp_addul](c, c->j->a3_data[dr_jmp_addul].data1, c->j->a3_data[dr_jmp_addul].data2, dest, src1, src2)
#define dr_adduli(c, dest, src1, imm) (c->j->jmp_a3i)[dr_jmp_addul](c, c->j->a3i_data[dr_jmp_addul].data1, c->j->a3i_data[dr_jmp_addul].data2, dest, src1, imm)
#define dr_addl(c, dest, src1, src2) (c->j->jmp_a3)[dr_jmp_addl](c, c->j->a3_data[dr_jmp_addl].data1, c->j->a3_data[dr_jmp_addl].data2, dest, src1, src2)
#define dr_addli(c, dest, src1, imm) (c->j->jmp_a3i)[dr_jmp_addl](c, c->j->a3i_data[dr_jmp_addl].data1, c->j->a3i_data[dr_jmp_addl].data2, dest, src1, imm)
#define dr_subi(c, dest, src1, src2) (c->j->jmp_a3)[dr_jmp_subi](c, c->j->a3_data[dr_jmp_subi].data1, c->j->a3_data[dr_jmp_subi].data2, dest, src1, src2)
#define dr_subii(c, dest, src1, imm) (c->j->jmp_a3i)[dr_jmp_subi](c, c->j->a3i_data[dr_jmp_subi].data1, c->j->a3i_data[dr_jmp_subi].data2, dest, src1, imm)
#define dr_subu(c, dest, src1, src2) (c->j->jmp_a3)[dr_jmp_subu](c, c->j->a3_data[dr_jmp_subu].data1, c->j->a3_data[dr_jmp_subu].data2, dest, src1, src2)
#define dr_subui(c, dest, src1, imm) (c->j->jmp_a3i)[dr_jmp_subu](c, c->j->a3i_data[dr_jmp_subu].data1, c->j->a3i_data[dr_jmp_subu].data2, dest, src1, imm)
#define dr_subul(c, dest, src1, src2) (c->j->jmp_a3)[dr_jmp_subul](c, c->j->a3_data[dr_jmp_subul].data1, c->j->a3_data[dr_jmp_subul].data2, dest, src1, src2)
#define dr_subuli(c, dest, src1, imm) (c->j->jmp_a3i)[dr_jmp_subul](c, c->j->a3i_data[dr_jmp_subul].data1, c->j->a3i_data[dr_jmp_subul].data2, dest, src1, imm)
#define dr_subl(c, dest, src1, src2) (c->j->jmp_a3)[dr_jmp_subl](c, c->j->a3_data[dr_jmp_subl].data1, c->j->a3_data[dr_jmp_subl].data2, dest, src1, src2)
#define dr_subli(c, dest, src1, imm) (c->j->jmp_a3i)[dr_jmp_subl](c, c->j->a3i_data[dr_jmp_subl].data1, c->j->a3i_data[dr_jmp_subl].data2, dest, src1, imm)
#define dr_muli(c, dest, src1, src2) (c->j->jmp_a3)[dr_jmp_muli](c, c->j->a3_data[dr_jmp_muli].data1, c->j->a3_data[dr_jmp_muli].data2, dest, src1, src2)
#define dr_mulii(c, dest, src1, imm) (c->j->jmp_a3i)[dr_jmp_muli](c, c->j->a3i_data[dr_jmp_muli].data1, c->j->a3i_data[dr_jmp_muli].data2, dest, src1, imm)
#define dr_mulu(c, dest, src1, src2) (c->j->jmp_a3)[dr_jmp_mulu](c, c->j->a3_data[dr_jmp_mulu].data1, c->j->a3_data[dr_jmp_mulu].data2, dest, src1, src2)
#define dr_mului(c, dest, src1, imm) (c->j->jmp_a3i)[dr_jmp_mulu](c, c->j->a3i_data[dr_jmp_mulu].data1, c->j->a3i_data[dr_jmp_mulu].data2, dest, src1, imm)
#define dr_mulul(c, dest, src1, src2) (c->j->jmp_a3)[dr_jmp_mulul](c, c->j->a3_data[dr_jmp_mulul].data1, c->j->a3_data[dr_jmp_mulul].data2, dest, src1, src2)
#define dr_mululi(c, dest, src1, imm) (c->j->jmp_a3i)[dr_jmp_mulul](c, c->j->a3i_data[dr_jmp_mulul].data1, c->j->a3i_data[dr_jmp_mulul].data2, dest, src1, imm)
#define dr_mull(c, dest, src1, src2) (c->j->jmp_a3)[dr_jmp_mull](c, c->j->a3_data[dr_jmp_mull].data1, c->j->a3_data[dr_jmp_mull].data2, dest, src1, src2)
#define dr_mulli(c, dest, src1, imm) (c->j->jmp_a3i)[dr_jmp_mull](c, c->j->a3i_data[dr_jmp_mull].data1, c->j->a3i_data[dr_jmp_mull].data2, dest, src1, imm)
#define dr_divi(c, dest, src1, src2) (c->j->jmp_a3)[dr_jmp_divi](c, c->j->a3_data[dr_jmp_divi].data1, c->j->a3_data[dr_jmp_divi].data2, dest, src1, src2)
#define dr_divii(c, dest, src1, imm) (c->j->jmp_a3i)[dr_jmp_divi](c, c->j->a3i_data[dr_jmp_divi].data1, c->j->a3i_data[dr_jmp_divi].data2, dest, src1, imm)
#define dr_divu(c, dest, src1, src2) (c->j->jmp_a3)[dr_jmp_divu](c, c->j->a3_data[dr_jmp_divu].data1, c->j->a3_data[dr_jmp_divu].data2, dest, src1, src2)
#define dr_divui(c, dest, src1, imm) (c->j->jmp_a3i)[dr_jmp_divu](c, c->j->a3i_data[dr_jmp_divu].data1, c->j->a3i_data[dr_jmp_divu].data2, dest, src1, imm)
#define dr_divul(c, dest, src1, src2) (c->j->jmp_a3)[dr_jmp_divul](c, c->j->a3_data[dr_jmp_divul].data1, c->j->a3_data[dr_jmp_divul].data2, dest, src1, src2)
#define dr_divuli(c, dest, src1, imm) (c->j->jmp_a3i)[dr_jmp_divul](c, c->j->a3i_data[dr_jmp_divul].data1, c->j->a3i_data[dr_jmp_divul].data2, dest, src1, imm)
#define dr_divl(c, dest, src1, src2) (c->j->jmp_a3)[dr_jmp_divl](c, c->j->a3_data[dr_jmp_divl].data1, c->j->a3_data[dr_jmp_divl].data2, dest, src1, src2)
#define dr_divli(c, dest, src1, imm) (c->j->jmp_a3i)[dr_jmp_divl](c, c->j->a3i_data[dr_jmp_divl].data1, c->j->a3i_data[dr_jmp_divl].data2, dest, src1, imm)
#define dr_modi(c, dest, src1, src2) (c->j->jmp_a3)[dr_jmp_modi](c, c->j->a3_data[dr_jmp_modi].data1, c->j->a3_data[dr_jmp_modi].data2, dest, src1, src2)
#define dr_modii(c, dest, src1, imm) (c->j->jmp_a3i)[dr_jmp_modi](c, c->j->a3i_data[dr_jmp_modi].data1, c->j->a3i_data[dr_jmp_modi].data2, dest, src1, imm)
#define dr_modu(c, dest, src1, src2) (c->j->jmp_a3)[dr_jmp_modu](c, c->j->a3_data[dr_jmp_modu].data1, c->j->a3_data[dr_jmp_modu].data2, dest, src1, src2)
#define dr_modui(c, dest, src1, imm) (c->j->jmp_a3i)[dr_jmp_modu](c, c->j->a3i_data[dr_jmp_modu].data1, c->j->a3i_data[dr_jmp_modu].data2, dest, src1, imm)
#define dr_modul(c, dest, src1, src2) (c->j->jmp_a3)[dr_jmp_modul](c, c->j->a3_data[dr_jmp_modul].data1, c->j->a3_data[dr_jmp_modul].data2, dest, src1, src2)
#define dr_moduli(c, dest, src1, imm) (c->j->jmp_a3i)[dr_jmp_modul](c, c->j->a3i_data[dr_jmp_modul].data1, c->j->a3i_data[dr_jmp_modul].data2, dest, src1, imm)
#define dr_modl(c, dest, src1, src2) (c->j->jmp_a3)[dr_jmp_modl](c, c->j->a3_data[dr_jmp_modl].data1, c->j->a3_data[dr_jmp_modl].data2, dest, src1, src2)
#define dr_modli(c, dest, src1, imm) (c->j->jmp_a3i)[dr_jmp_modl](c, c->j->a3i_data[dr_jmp_modl].data1, c->j->a3i_data[dr_jmp_modl].data2, dest, src1, imm)
#define dr_xori(c, dest, src1, src2) (c->j->jmp_a3)[dr_jmp_xori](c, c->j->a3_data[dr_jmp_xori].data1, c->j->a3_data[dr_jmp_xori].data2, dest, src1, src2)
#define dr_xorii(c, dest, src1, imm) (c->j->jmp_a3i)[dr_jmp_xori](c, c->j->a3i_data[dr_jmp_xori].data1, c->j->a3i_data[dr_jmp_xori].data2, dest, src1, imm)
#define dr_xoru(c, dest, src1, src2) (c->j->jmp_a3)[dr_jmp_xoru](c, c->j->a3_data[dr_jmp_xoru].data1, c->j->a3_data[dr_jmp_xoru].data2, dest, src1, src2)
#define dr_xorui(c, dest, src1, imm) (c->j->jmp_a3i)[dr_jmp_xoru](c, c->j->a3i_data[dr_jmp_xoru].data1, c->j->a3i_data[dr_jmp_xoru].data2, dest, src1, imm)
#define dr_xorul(c, dest, src1, src2) (c->j->jmp_a3)[dr_jmp_xorul](c, c->j->a3_data[dr_jmp_xorul].data1, c->j->a3_data[dr_jmp_xorul].data2, dest, src1, src2)
#define dr_xoruli(c, dest, src1, imm) (c->j->jmp_a3i)[dr_jmp_xorul](c, c->j->a3i_data[dr_jmp_xorul].data1, c->j->a3i_data[dr_jmp_xorul].data2, dest, src1, imm)
#define dr_xorl(c, dest, src1, src2) (c->j->jmp_a3)[dr_jmp_xorl](c, c->j->a3_data[dr_jmp_xorl].data1, c->j->a3_data[dr_jmp_xorl].data2, dest, src1, src2)
#define dr_xorli(c, dest, src1, imm) (c->j->jmp_a3i)[dr_jmp_xorl](c, c->j->a3i_data[dr_jmp_xorl].data1, c->j->a3i_data[dr_jmp_xorl].data2, dest, src1, imm)
#define dr_andi(c, dest, src1, src2) (c->j->jmp_a3)[dr_jmp_andi](c, c->j->a3_data[dr_jmp_andi].data1, c->j->a3_data[dr_jmp_andi].data2, dest, src1, src2)
#define dr_andii(c, dest, src1, imm) (c->j->jmp_a3i)[dr_jmp_andi](c, c->j->a3i_data[dr_jmp_andi].data1, c->j->a3i_data[dr_jmp_andi].data2, dest, src1, imm)
#define dr_andu(c, dest, src1, src2) (c->j->jmp_a3)[dr_jmp_andu](c, c->j->a3_data[dr_jmp_andu].data1, c->j->a3_data[dr_jmp_andu].data2, dest, src1, src2)
#define dr_andui(c, dest, src1, imm) (c->j->jmp_a3i)[dr_jmp_andu](c, c->j->a3i_data[dr_jmp_andu].data1, c->j->a3i_data[dr_jmp_andu].data2, dest, src1, imm)
#define dr_andul(c, dest, src1, src2) (c->j->jmp_a3)[dr_jmp_andul](c, c->j->a3_data[dr_jmp_andul].data1, c->j->a3_data[dr_jmp_andul].data2, dest, src1, src2)
#define dr_anduli(c, dest, src1, imm) (c->j->jmp_a3i)[dr_jmp_andul](c, c->j->a3i_data[dr_jmp_andul].data1, c->j->a3i_data[dr_jmp_andul].data2, dest, src1, imm)
#define dr_andl(c, dest, src1, src2) (c->j->jmp_a3)[dr_jmp_andl](c, c->j->a3_data[dr_jmp_andl].data1, c->j->a3_data[dr_jmp_andl].data2, dest, src1, src2)
#define dr_andli(c, dest, src1, imm) (c->j->jmp_a3i)[dr_jmp_andl](c, c->j->a3i_data[dr_jmp_andl].data1, c->j->a3i_data[dr_jmp_andl].data2, dest, src1, imm)
#define dr_ori(c, dest, src1, src2) (c->j->jmp_a3)[dr_jmp_ori](c, c->j->a3_data[dr_jmp_ori].data1, c->j->a3_data[dr_jmp_ori].data2, dest, src1, src2)
#define dr_orii(c, dest, src1, imm) (c->j->jmp_a3i)[dr_jmp_ori](c, c->j->a3i_data[dr_jmp_ori].data1, c->j->a3i_data[dr_jmp_ori].data2, dest, src1, imm)
#define dr_oru(c, dest, src1, src2) (c->j->jmp_a3)[dr_jmp_oru](c, c->j->a3_data[dr_jmp_oru].data1, c->j->a3_data[dr_jmp_oru].data2, dest, src1, src2)
#define dr_orui(c, dest, src1, imm) (c->j->jmp_a3i)[dr_jmp_oru](c, c->j->a3i_data[dr_jmp_oru].data1, c->j->a3i_data[dr_jmp_oru].data2, dest, src1, imm)
#define dr_orul(c, dest, src1, src2) (c->j->jmp_a3)[dr_jmp_orul](c, c->j->a3_data[dr_jmp_orul].data1, c->j->a3_data[dr_jmp_orul].data2, dest, src1, src2)
#define dr_oruli(c, dest, src1, imm) (c->j->jmp_a3i)[dr_jmp_orul](c, c->j->a3i_data[dr_jmp_orul].data1, c->j->a3i_data[dr_jmp_orul].data2, dest, src1, imm)
#define dr_orl(c, dest, src1, src2) (c->j->jmp_a3)[dr_jmp_orl](c, c->j->a3_data[dr_jmp_orl].data1, c->j->a3_data[dr_jmp_orl].data2, dest, src1, src2)
#define dr_orli(c, dest, src1, imm) (c->j->jmp_a3i)[dr_jmp_orl](c, c->j->a3i_data[dr_jmp_orl].data1, c->j->a3i_data[dr_jmp_orl].data2, dest, src1, imm)
#define dr_lshi(c, dest, src1, src2) (c->j->jmp_a3)[dr_jmp_lshi](c, c->j->a3_data[dr_jmp_lshi].data1, c->j->a3_data[dr_jmp_lshi].data2, dest, src1, src2)
#define dr_lshii(c, dest, src1, imm) (c->j->jmp_a3i)[dr_jmp_lshi](c, c->j->a3i_data[dr_jmp_lshi].data1, c->j->a3i_data[dr_jmp_lshi].data2, dest, src1, imm)
#define dr_lshu(c, dest, src1, src2) (c->j->jmp_a3)[dr_jmp_lshu](c, c->j->a3_data[dr_jmp_lshu].data1, c->j->a3_data[dr_jmp_lshu].data2, dest, src1, src2)
#define dr_lshui(c, dest, src1, imm) (c->j->jmp_a3i)[dr_jmp_lshu](c, c->j->a3i_data[dr_jmp_lshu].data1, c->j->a3i_data[dr_jmp_lshu].data2, dest, src1, imm)
#define dr_lshul(c, dest, src1, src2) (c->j->jmp_a3)[dr_jmp_lshul](c, c->j->a3_data[dr_jmp_lshul].data1, c->j->a3_data[dr_jmp_lshul].data2, dest, src1, src2)
#define dr_lshuli(c, dest, src1, imm) (c->j->jmp_a3i)[dr_jmp_lshul](c, c->j->a3i_data[dr_jmp_lshul].data1, c->j->a3i_data[dr_jmp_lshul].data2, dest, src1, imm)
#define dr_lshl(c, dest, src1, src2) (c->j->jmp_a3)[dr_jmp_lshl](c, c->j->a3_data[dr_jmp_lshl].data1, c->j->a3_data[dr_jmp_lshl].data2, dest, src1, src2)
#define dr_lshli(c, dest, src1, imm) (c->j->jmp_a3i)[dr_jmp_lshl](c, c->j->a3i_data[dr_jmp_lshl].data1, c->j->a3i_data[dr_jmp_lshl].data2, dest, src1, imm)
#define dr_rshi(c, dest, src1, src2) (c->j->jmp_a3)[dr_jmp_rshi](c, c->j->a3_data[dr_jmp_rshi].data1, c->j->a3_data[dr_jmp_rshi].data2, dest, src1, src2)
#define dr_rshii(c, dest, src1, imm) (c->j->jmp_a3i)[dr_jmp_rshi](c, c->j->a3i_data[dr_jmp_rshi].data1, c->j->a3i_data[dr_jmp_rshi].data2, dest, src1, imm)
#define dr_rshu(c, dest, src1, src2) (c->j->jmp_a3)[dr_jmp_rshu](c, c->j->a3_data[dr_jmp_rshu].data1, c->j->a3_data[dr_jmp_rshu].data2, dest, src1, src2)
#define dr_rshui(c, dest, src1, imm) (c->j->jmp_a3i)[dr_jmp_rshu](c, c->j->a3i_data[dr_jmp_rshu].data1, c->j->a3i_data[dr_jmp_rshu].data2, dest, src1, imm)
#define dr_rshul(c, dest, src1, src2) (c->j->jmp_a3)[dr_jmp_rshul](c, c->j->a3_data[dr_jmp_rshul].data1, c->j->a3_data[dr_jmp_rshul].data2, dest, src1, src2)
#define dr_rshuli(c, dest, src1, imm) (c->j->jmp_a3i)[dr_jmp_rshul](c, c->j->a3i_data[dr_jmp_rshul].data1, c->j->a3i_data[dr_jmp_rshul].data2, dest, src1, imm)
#define dr_rshl(c, dest, src1, src2) (c->j->jmp_a3)[dr_jmp_rshl](c, c->j->a3_data[dr_jmp_rshl].data1, c->j->a3_data[dr_jmp_rshl].data2, dest, src1, src2)
#define dr_rshli(c, dest, src1, imm) (c->j->jmp_a3i)[dr_jmp_rshl](c, c->j->a3i_data[dr_jmp_rshl].data1, c->j->a3i_data[dr_jmp_rshl].data2, dest, src1, imm)
#define dr_jmp_addp 40
#define dr_jmp_subp 41
#define dr_addp(c, dest, src1, src2) (c->j->jmp_a3)[dr_jmp_addp](c, c->j->a3_data[dr_jmp_addp].data1, c->j->a3_data[dr_jmp_addp].data2, dest, src1, src2)
#define dr_addpi(c, dest, src1, imm) (c->j->jmp_a3i)[dr_jmp_addp](c, c->j->a3i_data[dr_jmp_addp].data1, c->j->a3i_data[dr_jmp_addp].data2, dest, src1, imm)
#define dr_subp(c, dest, src1, src2) (c->j->jmp_a3)[dr_jmp_subp](c, c->j->a3_data[dr_jmp_subp].data1, c->j->a3_data[dr_jmp_subp].data2, dest, src1, src2)
#define dr_subpi(c, dest, src1, imm) (c->j->jmp_a3i)[dr_jmp_subp](c, c->j->a3i_data[dr_jmp_subp].data1, c->j->a3i_data[dr_jmp_subp].data2, dest, src1, imm)
#define dr_jmp_addf 42
#define dr_jmp_addd 43
#define dr_jmp_subf 44
#define dr_jmp_subd 45
#define dr_jmp_mulf 46
#define dr_jmp_muld 47
#define dr_jmp_divf 48
#define dr_jmp_divd 49
#define dr_addf(c, dest, src1, src2) (c->j->jmp_a3)[dr_jmp_addf](c, c->j->a3_data[dr_jmp_addf].data1, c->j->a3_data[dr_jmp_addf].data2, dest, src1, src2)
#define dr_addfi(c, dest, src1, imm) (c->j->jmp_f3i)[dr_jmp_addf](c, c->j->a3f_data[dr_jmp_addf].data1, c->j->a3f_data[dr_jmp_addf].data2, dest, src1, imm)
#define dr_addd(c, dest, src1, src2) (c->j->jmp_a3)[dr_jmp_addd](c, c->j->a3_data[dr_jmp_addd].data1, c->j->a3_data[dr_jmp_addd].data2, dest, src1, src2)
#define dr_adddi(c, dest, src1, imm) (c->j->jmp_f3i)[dr_jmp_addd](c, c->j->a3f_data[dr_jmp_addd].data1, c->j->a3f_data[dr_jmp_addd].data2, dest, src1, imm)
#define dr_subf(c, dest, src1, src2) (c->j->jmp_a3)[dr_jmp_subf](c, c->j->a3_data[dr_jmp_subf].data1, c->j->a3_data[dr_jmp_subf].data2, dest, src1, src2)
#define dr_subfi(c, dest, src1, imm) (c->j->jmp_f3i)[dr_jmp_subf](c, c->j->a3f_data[dr_jmp_subf].data1, c->j->a3f_data[dr_jmp_subf].data2, dest, src1, imm)
#define dr_subd(c, dest, src1, src2) (c->j->jmp_a3)[dr_jmp_subd](c, c->j->a3_data[dr_jmp_subd].data1, c->j->a3_data[dr_jmp_subd].data2, dest, src1, src2)
#define dr_subdi(c, dest, src1, imm) (c->j->jmp_f3i)[dr_jmp_subd](c, c->j->a3f_data[dr_jmp_subd].data1, c->j->a3f_data[dr_jmp_subd].data2, dest, src1, imm)
#define dr_mulf(c, dest, src1, src2) (c->j->jmp_a3)[dr_jmp_mulf](c, c->j->a3_data[dr_jmp_mulf].data1, c->j->a3_data[dr_jmp_mulf].data2, dest, src1, src2)
#define dr_mulfi(c, dest, src1, imm) (c->j->jmp_f3i)[dr_jmp_mulf](c, c->j->a3f_data[dr_jmp_mulf].data1, c->j->a3f_data[dr_jmp_mulf].data2, dest, src1, imm)
#define dr_muld(c, dest, src1, src2) (c->j->jmp_a3)[dr_jmp_muld](c, c->j->a3_data[dr_jmp_muld].data1, c->j->a3_data[dr_jmp_muld].data2, dest, src1, src2)
#define dr_muldi(c, dest, src1, imm) (c->j->jmp_f3i)[dr_jmp_muld](c, c->j->a3f_data[dr_jmp_muld].data1, c->j->a3f_data[dr_jmp_muld].data2, dest, src1, imm)
#define dr_divf(c, dest, src1, src2) (c->j->jmp_a3)[dr_jmp_divf](c, c->j->a3_data[dr_jmp_divf].data1, c->j->a3_data[dr_jmp_divf].data2, dest, src1, src2)
#define dr_divfi(c, dest, src1, imm) (c->j->jmp_f3i)[dr_jmp_divf](c, c->j->a3f_data[dr_jmp_divf].data1, c->j->a3f_data[dr_jmp_divf].data2, dest, src1, imm)
#define dr_divd(c, dest, src1, src2) (c->j->jmp_a3)[dr_jmp_divd](c, c->j->a3_data[dr_jmp_divd].data1, c->j->a3_data[dr_jmp_divd].data2, dest, src1, src2)
#define dr_divdi(c, dest, src1, imm) (c->j->jmp_f3i)[dr_jmp_divd](c, c->j->a3f_data[dr_jmp_divd].data1, c->j->a3f_data[dr_jmp_divd].data2, dest, src1, imm)
#define dr_jmp_noti 0
#define dr_jmp_notu 1
#define dr_jmp_notul 2
#define dr_jmp_notl 3
#define dr_jmp_comi 4
#define dr_jmp_comu 5
#define dr_jmp_comul 6
#define dr_jmp_coml 7
#define dr_jmp_negi 8
#define dr_jmp_negu 9
#define dr_jmp_negul 10
#define dr_jmp_negl 11
#define dr_noti(c, dest, src) (c->j->jmp_a2)[dr_jmp_noti](c, c->j->a2_data[dr_jmp_noti].data1, c->j->a2_data[dr_jmp_noti].data2, dest, src)
#define dr_notii(c, dest, imm) (c->j->jmp_a2i)[dr_jmp_noti](c, c->j->a2_data[dr_jmp_noti].data1, c->j->a2_data[dr_jmp_noti].data2, dest, imm)
#define dr_notu(c, dest, src) (c->j->jmp_a2)[dr_jmp_notu](c, c->j->a2_data[dr_jmp_notu].data1, c->j->a2_data[dr_jmp_notu].data2, dest, src)
#define dr_notui(c, dest, imm) (c->j->jmp_a2i)[dr_jmp_notu](c, c->j->a2_data[dr_jmp_notu].data1, c->j->a2_data[dr_jmp_notu].data2, dest, imm)
#define dr_notul(c, dest, src) (c->j->jmp_a2)[dr_jmp_notul](c, c->j->a2_data[dr_jmp_notul].data1, c->j->a2_data[dr_jmp_notul].data2, dest, src)
#define dr_notuli(c, dest, imm) (c->j->jmp_a2i)[dr_jmp_notul](c, c->j->a2_data[dr_jmp_notul].data1, c->j->a2_data[dr_jmp_notul].data2, dest, imm)
#define dr_notl(c, dest, src) (c->j->jmp_a2)[dr_jmp_notl](c, c->j->a2_data[dr_jmp_notl].data1, c->j->a2_data[dr_jmp_notl].data2, dest, src)
#define dr_notli(c, dest, imm) (c->j->jmp_a2i)[dr_jmp_notl](c, c->j->a2_data[dr_jmp_notl].data1, c->j->a2_data[dr_jmp_notl].data2, dest, imm)
#define dr_comi(c, dest, src) (c->j->jmp_a2)[dr_jmp_comi](c, c->j->a2_data[dr_jmp_comi].data1, c->j->a2_data[dr_jmp_comi].data2, dest, src)
#define dr_comii(c, dest, imm) (c->j->jmp_a2i)[dr_jmp_comi](c, c->j->a2_data[dr_jmp_comi].data1, c->j->a2_data[dr_jmp_comi].data2, dest, imm)
#define dr_comu(c, dest, src) (c->j->jmp_a2)[dr_jmp_comu](c, c->j->a2_data[dr_jmp_comu].data1, c->j->a2_data[dr_jmp_comu].data2, dest, src)
#define dr_comui(c, dest, imm) (c->j->jmp_a2i)[dr_jmp_comu](c, c->j->a2_data[dr_jmp_comu].data1, c->j->a2_data[dr_jmp_comu].data2, dest, imm)
#define dr_comul(c, dest, src) (c->j->jmp_a2)[dr_jmp_comul](c, c->j->a2_data[dr_jmp_comul].data1, c->j->a2_data[dr_jmp_comul].data2, dest, src)
#define dr_comuli(c, dest, imm) (c->j->jmp_a2i)[dr_jmp_comul](c, c->j->a2_data[dr_jmp_comul].data1, c->j->a2_data[dr_jmp_comul].data2, dest, imm)
#define dr_coml(c, dest, src) (c->j->jmp_a2)[dr_jmp_coml](c, c->j->a2_data[dr_jmp_coml].data1, c->j->a2_data[dr_jmp_coml].data2, dest, src)
#define dr_comli(c, dest, imm) (c->j->jmp_a2i)[dr_jmp_coml](c, c->j->a2_data[dr_jmp_coml].data1, c->j->a2_data[dr_jmp_coml].data2, dest, imm)
#define dr_negi(c, dest, src) (c->j->jmp_a2)[dr_jmp_negi](c, c->j->a2_data[dr_jmp_negi].data1, c->j->a2_data[dr_jmp_negi].data2, dest, src)
#define dr_negii(c, dest, imm) (c->j->jmp_a2i)[dr_jmp_negi](c, c->j->a2_data[dr_jmp_negi].data1, c->j->a2_data[dr_jmp_negi].data2, dest, imm)
#define dr_negu(c, dest, src) (c->j->jmp_a2)[dr_jmp_negu](c, c->j->a2_data[dr_jmp_negu].data1, c->j->a2_data[dr_jmp_negu].data2, dest, src)
#define dr_negui(c, dest, imm) (c->j->jmp_a2i)[dr_jmp_negu](c, c->j->a2_data[dr_jmp_negu].data1, c->j->a2_data[dr_jmp_negu].data2, dest, imm)
#define dr_negul(c, dest, src) (c->j->jmp_a2)[dr_jmp_negul](c, c->j->a2_data[dr_jmp_negul].data1, c->j->a2_data[dr_jmp_negul].data2, dest, src)
#define dr_neguli(c, dest, imm) (c->j->jmp_a2i)[dr_jmp_negul](c, c->j->a2_data[dr_jmp_negul].data1, c->j->a2_data[dr_jmp_negul].data2, dest, imm)
#define dr_negl(c, dest, src) (c->j->jmp_a2)[dr_jmp_negl](c, c->j->a2_data[dr_jmp_negl].data1, c->j->a2_data[dr_jmp_negl].data2, dest, src)
#define dr_negli(c, dest, imm) (c->j->jmp_a2i)[dr_jmp_negl](c, c->j->a2_data[dr_jmp_negl].data1, c->j->a2_data[dr_jmp_negl].data2, dest, imm)
#define dr_jmp_negf 12
#define dr_jmp_negd 13
#define dr_negf(c, dest, src) (c->j->jmp_a2)[dr_jmp_negf](c, c->j->a2_data[dr_jmp_negf].data1, c->j->a2_data[dr_jmp_negf].data2, dest, src)
#define dr_negfi(c, dest, imm) (c->j->jmp_f2i)[dr_jmp_negf](c, c->j->a2f_data[dr_jmp_negf].data1, c->j->a2f_data[dr_jmp_negf].data2, dest, imm)
#define dr_negd(c, dest, src) (c->j->jmp_a2)[dr_jmp_negd](c, c->j->a2_data[dr_jmp_negd].data1, c->j->a2_data[dr_jmp_negd].data2, dest, src)
#define dr_negdi(c, dest, imm) (c->j->jmp_f2i)[dr_jmp_negd](c, c->j->a2f_data[dr_jmp_negd].data1, c->j->a2f_data[dr_jmp_negd].data2, dest, imm)
#define dr_beq_code 0
#define dr_bge_code 1
#define dr_bgt_code 2
#define dr_ble_code 3
#define dr_blt_code 4
#define dr_bne_code 5
#define dr_jmp_beqi 0
#define dr_jmp_bequ 1
#define dr_jmp_bequl 2
#define dr_jmp_beql 3
#define dr_jmp_beqp 4
#define dr_jmp_beqd 5
#define dr_jmp_beqf 6
#define dr_jmp_bgei 7
#define dr_jmp_bgeu 8
#define dr_jmp_bgeul 9
#define dr_jmp_bgel 10
#define dr_jmp_bgep 11
#define dr_jmp_bged 12
#define dr_jmp_bgef 13
#define dr_jmp_bgti 14
#define dr_jmp_bgtu 15
#define dr_jmp_bgtul 16
#define dr_jmp_bgtl 17
#define dr_jmp_bgtp 18
#define dr_jmp_bgtd 19
#define dr_jmp_bgtf 20
#define dr_jmp_blei 21
#define dr_jmp_bleu 22
#define dr_jmp_bleul 23
#define dr_jmp_blel 24
#define dr_jmp_blep 25
#define dr_jmp_bled 26
#define dr_jmp_blef 27
#define dr_jmp_blti 28
#define dr_jmp_bltu 29
#define dr_jmp_bltul 30
#define dr_jmp_bltl 31
#define dr_jmp_bltp 32
#define dr_jmp_bltd 33
#define dr_jmp_bltf 34
#define dr_jmp_bnei 35
#define dr_jmp_bneu 36
#define dr_jmp_bneul 37
#define dr_jmp_bnel 38
#define dr_jmp_bnep 39
#define dr_jmp_bned 40
#define dr_jmp_bnef 41
#define dr_beqi(c, src1, src2, label) (c->j->jmp_b)[dr_jmp_beqi](c, c->j->b_data[dr_jmp_beqi].data1, c->j->b_data[dr_jmp_beqi].data2, src1, src2, label)
#define dr_beqii(c, src, imm, label) (c->j->jmp_bi)[dr_jmp_beqi](c, c->j->b_data[dr_jmp_beqi].data1, c->j->b_data[dr_jmp_beqi].data2, src, imm, label)
#define dr_bequ(c, src1, src2, label) (c->j->jmp_b)[dr_jmp_bequ](c, c->j->b_data[dr_jmp_bequ].data1, c->j->b_data[dr_jmp_bequ].data2, src1, src2, label)
#define dr_bequi(c, src, imm, label) (c->j->jmp_bi)[dr_jmp_bequ](c, c->j->b_data[dr_jmp_bequ].data1, c->j->b_data[dr_jmp_bequ].data2, src, imm, label)
#define dr_bequl(c, src1, src2, label) (c->j->jmp_b)[dr_jmp_bequl](c, c->j->b_data[dr_jmp_bequl].data1, c->j->b_data[dr_jmp_bequl].data2, src1, src2, label)
#define dr_bequli(c, src, imm, label) (c->j->jmp_bi)[dr_jmp_bequl](c, c->j->b_data[dr_jmp_bequl].data1, c->j->b_data[dr_jmp_bequl].data2, src, imm, label)
#define dr_beql(c, src1, src2, label) (c->j->jmp_b)[dr_jmp_beql](c, c->j->b_data[dr_jmp_beql].data1, c->j->b_data[dr_jmp_beql].data2, src1, src2, label)
#define dr_beqli(c, src, imm, label) (c->j->jmp_bi)[dr_jmp_beql](c, c->j->b_data[dr_jmp_beql].data1, c->j->b_data[dr_jmp_beql].data2, src, imm, label)
#define dr_beqp(c, src1, src2, label) (c->j->jmp_b)[dr_jmp_beqp](c, c->j->b_data[dr_jmp_beqp].data1, c->j->b_data[dr_jmp_beqp].data2, src1, src2, label)
#define dr_beqpi(c, src, imm, label) (c->j->jmp_bi)[dr_jmp_beqp](c, c->j->b_data[dr_jmp_beqp].data1, c->j->b_data[dr_jmp_beqp].data2, src, imm, label)
#define dr_beqd(c, src1, src2, label) (c->j->jmp_b)[dr_jmp_beqd](c, c->j->b_data[dr_jmp_beqd].data1, c->j->b_data[dr_jmp_beqd].data2, src1, src2, label)
#define dr_beqf(c, src1, src2, label) (c->j->jmp_b)[dr_jmp_beqf](c, c->j->b_data[dr_jmp_beqf].data1, c->j->b_data[dr_jmp_beqf].data2, src1, src2, label)
#define dr_bgei(c, src1, src2, label) (c->j->jmp_b)[dr_jmp_bgei](c, c->j->b_data[dr_jmp_bgei].data1, c->j->b_data[dr_jmp_bgei].data2, src1, src2, label)
#define dr_bgeii(c, src, imm, label) (c->j->jmp_bi)[dr_jmp_bgei](c, c->j->b_data[dr_jmp_bgei].data1, c->j->b_data[dr_jmp_bgei].data2, src, imm, label)
#define dr_bgeu(c, src1, src2, label) (c->j->jmp_b)[dr_jmp_bgeu](c, c->j->b_data[dr_jmp_bgeu].data1, c->j->b_data[dr_jmp_bgeu].data2, src1, src2, label)
#define dr_bgeui(c, src, imm, label) (c->j->jmp_bi)[dr_jmp_bgeu](c, c->j->b_data[dr_jmp_bgeu].data1, c->j->b_data[dr_jmp_bgeu].data2, src, imm, label)
#define dr_bgeul(c, src1, src2, label) (c->j->jmp_b)[dr_jmp_bgeul](c, c->j->b_data[dr_jmp_bgeul].data1, c->j->b_data[dr_jmp_bgeul].data2, src1, src2, label)
#define dr_bgeuli(c, src, imm, label) (c->j->jmp_bi)[dr_jmp_bgeul](c, c->j->b_data[dr_jmp_bgeul].data1, c->j->b_data[dr_jmp_bgeul].data2, src, imm, label)
#define dr_bgel(c, src1, src2, label) (c->j->jmp_b)[dr_jmp_bgel](c, c->j->b_data[dr_jmp_bgel].data1, c->j->b_data[dr_jmp_bgel].data2, src1, src2, label)
#define dr_bgeli(c, src, imm, label) (c->j->jmp_bi)[dr_jmp_bgel](c, c->j->b_data[dr_jmp_bgel].data1, c->j->b_data[dr_jmp_bgel].data2, src, imm, label)
#define dr_bgep(c, src1, src2, label) (c->j->jmp_b)[dr_jmp_bgep](c, c->j->b_data[dr_jmp_bgep].data1, c->j->b_data[dr_jmp_bgep].data2, src1, src2, label)
#define dr_bgepi(c, src, imm, label) (c->j->jmp_bi)[dr_jmp_bgep](c, c->j->b_data[dr_jmp_bgep].data1, c->j->b_data[dr_jmp_bgep].data2, src, imm, label)
#define dr_bged(c, src1, src2, label) (c->j->jmp_b)[dr_jmp_bged](c, c->j->b_data[dr_jmp_bged].data1, c->j->b_data[dr_jmp_bged].data2, src1, src2, label)
#define dr_bgef(c, src1, src2, label) (c->j->jmp_b)[dr_jmp_bgef](c, c->j->b_data[dr_jmp_bgef].data1, c->j->b_data[dr_jmp_bgef].data2, src1, src2, label)
#define dr_bgti(c, src1, src2, label) (c->j->jmp_b)[dr_jmp_bgti](c, c->j->b_data[dr_jmp_bgti].data1, c->j->b_data[dr_jmp_bgti].data2, src1, src2, label)
#define dr_bgtii(c, src, imm, label) (c->j->jmp_bi)[dr_jmp_bgti](c, c->j->b_data[dr_jmp_bgti].data1, c->j->b_data[dr_jmp_bgti].data2, src, imm, label)
#define dr_bgtu(c, src1, src2, label) (c->j->jmp_b)[dr_jmp_bgtu](c, c->j->b_data[dr_jmp_bgtu].data1, c->j->b_data[dr_jmp_bgtu].data2, src1, src2, label)
#define dr_bgtui(c, src, imm, label) (c->j->jmp_bi)[dr_jmp_bgtu](c, c->j->b_data[dr_jmp_bgtu].data1, c->j->b_data[dr_jmp_bgtu].data2, src, imm, label)
#define dr_bgtul(c, src1, src2, label) (c->j->jmp_b)[dr_jmp_bgtul](c, c->j->b_data[dr_jmp_bgtul].data1, c->j->b_data[dr_jmp_bgtul].data2, src1, src2, label)
#define dr_bgtuli(c, src, imm, label) (c->j->jmp_bi)[dr_jmp_bgtul](c, c->j->b_data[dr_jmp_bgtul].data1, c->j->b_data[dr_jmp_bgtul].data2, src, imm, label)
#define dr_bgtl(c, src1, src2, label) (c->j->jmp_b)[dr_jmp_bgtl](c, c->j->b_data[dr_jmp_bgtl].data1, c->j->b_data[dr_jmp_bgtl].data2, src1, src2, label)
#define dr_bgtli(c, src, imm, label) (c->j->jmp_bi)[dr_jmp_bgtl](c, c->j->b_data[dr_jmp_bgtl].data1, c->j->b_data[dr_jmp_bgtl].data2, src, imm, label)
#define dr_bgtp(c, src1, src2, label) (c->j->jmp_b)[dr_jmp_bgtp](c, c->j->b_data[dr_jmp_bgtp].data1, c->j->b_data[dr_jmp_bgtp].data2, src1, src2, label)
#define dr_bgtpi(c, src, imm, label) (c->j->jmp_bi)[dr_jmp_bgtp](c, c->j->b_data[dr_jmp_bgtp].data1, c->j->b_data[dr_jmp_bgtp].data2, src, imm, label)
#define dr_bgtd(c, src1, src2, label) (c->j->jmp_b)[dr_jmp_bgtd](c, c->j->b_data[dr_jmp_bgtd].data1, c->j->b_data[dr_jmp_bgtd].data2, src1, src2, label)
#define dr_bgtf(c, src1, src2, label) (c->j->jmp_b)[dr_jmp_bgtf](c, c->j->b_data[dr_jmp_bgtf].data1, c->j->b_data[dr_jmp_bgtf].data2, src1, src2, label)
#define dr_blei(c, src1, src2, label) (c->j->jmp_b)[dr_jmp_blei](c, c->j->b_data[dr_jmp_blei].data1, c->j->b_data[dr_jmp_blei].data2, src1, src2, label)
#define dr_bleii(c, src, imm, label) (c->j->jmp_bi)[dr_jmp_blei](c, c->j->b_data[dr_jmp_blei].data1, c->j->b_data[dr_jmp_blei].data2, src, imm, label)
#define dr_bleu(c, src1, src2, label) (c->j->jmp_b)[dr_jmp_bleu](c, c->j->b_data[dr_jmp_bleu].data1, c->j->b_data[dr_jmp_bleu].data2, src1, src2, label)
#define dr_bleui(c, src, imm, label) (c->j->jmp_bi)[dr_jmp_bleu](c, c->j->b_data[dr_jmp_bleu].data1, c->j->b_data[dr_jmp_bleu].data2, src, imm, label)
#define dr_bleul(c, src1, src2, label) (c->j->jmp_b)[dr_jmp_bleul](c, c->j->b_data[dr_jmp_bleul].data1, c->j->b_data[dr_jmp_bleul].data2, src1, src2, label)
#define dr_bleuli(c, src, imm, label) (c->j->jmp_bi)[dr_jmp_bleul](c, c->j->b_data[dr_jmp_bleul].data1, c->j->b_data[dr_jmp_bleul].data2, src, imm, label)
#define dr_blel(c, src1, src2, label) (c->j->jmp_b)[dr_jmp_blel](c, c->j->b_data[dr_jmp_blel].data1, c->j->b_data[dr_jmp_blel].data2, src1, src2, label)
#define dr_bleli(c, src, imm, label) (c->j->jmp_bi)[dr_jmp_blel](c, c->j->b_data[dr_jmp_blel].data1, c->j->b_data[dr_jmp_blel].data2, src, imm, label)
#define dr_blep(c, src1, src2, label) (c->j->jmp_b)[dr_jmp_blep](c, c->j->b_data[dr_jmp_blep].data1, c->j->b_data[dr_jmp_blep].data2, src1, src2, label)
#define dr_blepi(c, src, imm, label) (c->j->jmp_bi)[dr_jmp_blep](c, c->j->b_data[dr_jmp_blep].data1, c->j->b_data[dr_jmp_blep].data2, src, imm, label)
#define dr_bled(c, src1, src2, label) (c->j->jmp_b)[dr_jmp_bled](c, c->j->b_data[dr_jmp_bled].data1, c->j->b_data[dr_jmp_bled].data2, src1, src2, label)
#define dr_blef(c, src1, src2, label) (c->j->jmp_b)[dr_jmp_blef](c, c->j->b_data[dr_jmp_blef].data1, c->j->b_data[dr_jmp_blef].data2, src1, src2, label)
#define dr_blti(c, src1, src2, label) (c->j->jmp_b)[dr_jmp_blti](c, c->j->b_data[dr_jmp_blti].data1, c->j->b_data[dr_jmp_blti].data2, src1, src2, label)
#define dr_bltii(c, src, imm, label) (c->j->jmp_bi)[dr_jmp_blti](c, c->j->b_data[dr_jmp_blti].data1, c->j->b_data[dr_jmp_blti].data2, src, imm, label)
#define dr_bltu(c, src1, src2, label) (c->j->jmp_b)[dr_jmp_bltu](c, c->j->b_data[dr_jmp_bltu].data1, c->j->b_data[dr_jmp_bltu].data2, src1, src2, label)
#define dr_bltui(c, src, imm, label) (c->j->jmp_bi)[dr_jmp_bltu](c, c->j->b_data[dr_jmp_bltu].data1, c->j->b_data[dr_jmp_bltu].data2, src, imm, label)
#define dr_bltul(c, src1, src2, label) (c->j->jmp_b)[dr_jmp_bltul](c, c->j->b_data[dr_jmp_bltul].data1, c->j->b_data[dr_jmp_bltul].data2, src1, src2, label)
#define dr_bltuli(c, src, imm, label) (c->j->jmp_bi)[dr_jmp_bltul](c, c->j->b_data[dr_jmp_bltul].data1, c->j->b_data[dr_jmp_bltul].data2, src, imm, label)
#define dr_bltl(c, src1, src2, label) (c->j->jmp_b)[dr_jmp_bltl](c, c->j->b_data[dr_jmp_bltl].data1, c->j->b_data[dr_jmp_bltl].data2, src1, src2, label)
#define dr_bltli(c, src, imm, label) (c->j->jmp_bi)[dr_jmp_bltl](c, c->j->b_data[dr_jmp_bltl].data1, c->j->b_data[dr_jmp_bltl].data2, src, imm, label)
#define dr_bltp(c, src1, src2, label) (c->j->jmp_b)[dr_jmp_bltp](c, c->j->b_data[dr_jmp_bltp].data1, c->j->b_data[dr_jmp_bltp].data2, src1, src2, label)
#define dr_bltpi(c, src, imm, label) (c->j->jmp_bi)[dr_jmp_bltp](c, c->j->b_data[dr_jmp_bltp].data1, c->j->b_data[dr_jmp_bltp].data2, src, imm, label)
#define dr_bltd(c, src1, src2, label) (c->j->jmp_b)[dr_jmp_bltd](c, c->j->b_data[dr_jmp_bltd].data1, c->j->b_data[dr_jmp_bltd].data2, src1, src2, label)
#define dr_bltf(c, src1, src2, label) (c->j->jmp_b)[dr_jmp_bltf](c, c->j->b_data[dr_jmp_bltf].data1, c->j->b_data[dr_jmp_bltf].data2, src1, src2, label)
#define dr_bnei(c, src1, src2, label) (c->j->jmp_b)[dr_jmp_bnei](c, c->j->b_data[dr_jmp_bnei].data1, c->j->b_data[dr_jmp_bnei].data2, src1, src2, label)
#define dr_bneii(c, src, imm, label) (c->j->jmp_bi)[dr_jmp_bnei](c, c->j->b_data[dr_jmp_bnei].data1, c->j->b_data[dr_jmp_bnei].data2, src, imm, label)
#define dr_bneu(c, src1, src2, label) (c->j->jmp_b)[dr_jmp_bneu](c, c->j->b_data[dr_jmp_bneu].data1, c->j->b_data[dr_jmp_bneu].data2, src1, src2, label)
#define dr_bneui(c, src, imm, label) (c->j->jmp_bi)[dr_jmp_bneu](c, c->j->b_data[dr_jmp_bneu].data1, c->j->b_data[dr_jmp_bneu].data2, src, imm, label)
#define dr_bneul(c, src1, src2, label) (c->j->jmp_b)[dr_jmp_bneul](c, c->j->b_data[dr_jmp_bneul].data1, c->j->b_data[dr_jmp_bneul].data2, src1, src2, label)
#define dr_bneuli(c, src, imm, label) (c->j->jmp_bi)[dr_jmp_bneul](c, c->j->b_data[dr_jmp_bneul].data1, c->j->b_data[dr_jmp_bneul].data2, src, imm, label)
#define dr_bnel(c, src1, src2, label) (c->j->jmp_b)[dr_jmp_bnel](c, c->j->b_data[dr_jmp_bnel].data1, c->j->b_data[dr_jmp_bnel].data2, src1, src2, label)
#define dr_bneli(c, src, imm, label) (c->j->jmp_bi)[dr_jmp_bnel](c, c->j->b_data[dr_jmp_bnel].data1, c->j->b_data[dr_jmp_bnel].data2, src, imm, label)
#define dr_bnep(c, src1, src2, label) (c->j->jmp_b)[dr_jmp_bnep](c, c->j->b_data[dr_jmp_bnep].data1, c->j->b_data[dr_jmp_bnep].data2, src1, src2, label)
#define dr_bnepi(c, src, imm, label) (c->j->jmp_bi)[dr_jmp_bnep](c, c->j->b_data[dr_jmp_bnep].data1, c->j->b_data[dr_jmp_bnep].data2, src, imm, label)
#define dr_bned(c, src1, src2, label) (c->j->jmp_b)[dr_jmp_bned](c, c->j->b_data[dr_jmp_bned].data1, c->j->b_data[dr_jmp_bned].data2, src1, src2, label)
#define dr_bnef(c, src1, src2, label) (c->j->jmp_b)[dr_jmp_bnef](c, c->j->b_data[dr_jmp_bnef].data1, c->j->b_data[dr_jmp_bnef].data2, src1, src2, label)
#define dr_cvc2i(c, dest, src) (c->j->convert)(c, DR_C, DR_I, dest, src)
#define dr_cvc2u(c, dest, src) (c->j->convert)(c, DR_C, DR_U, dest, src)
#define dr_cvc2ul(c, dest, src) (c->j->convert)(c, DR_C, DR_UL, dest, src)
#define dr_cvc2l(c, dest, src) (c->j->convert)(c, DR_C, DR_L, dest, src)
#define dr_cvd2i(c, dest, src) (c->j->convert)(c, DR_D, DR_I, dest, src)
#define dr_cvd2u(c, dest, src) (c->j->convert)(c, DR_D, DR_U, dest, src)
#define dr_cvd2ul(c, dest, src) (c->j->convert)(c, DR_D, DR_UL, dest, src)
#define dr_cvd2l(c, dest, src) (c->j->convert)(c, DR_D, DR_L, dest, src)
#define dr_cvf2i(c, dest, src) (c->j->convert)(c, DR_F, DR_I, dest, src)
#define dr_cvf2u(c, dest, src) (c->j->convert)(c, DR_F, DR_U, dest, src)
#define dr_cvf2ul(c, dest, src) (c->j->convert)(c, DR_F, DR_UL, dest, src)
#define dr_cvf2l(c, dest, src) (c->j->convert)(c, DR_F, DR_L, dest, src)
#define dr_cvi2u(c, dest, src) (c->j->convert)(c, DR_I, DR_U, dest, src)
#define dr_cvi2ul(c, dest, src) (c->j->convert)(c, DR_I, DR_UL, dest, src)
#define dr_cvi2l(c, dest, src) (c->j->convert)(c, DR_I, DR_L, dest, src)
#define dr_cvl2i(c, dest, src) (c->j->convert)(c, DR_L, DR_I, dest, src)
#define dr_cvl2u(c, dest, src) (c->j->convert)(c, DR_L, DR_U, dest, src)
#define dr_cvl2ul(c, dest, src) (c->j->convert)(c, DR_L, DR_UL, dest, src)
#define dr_cvs2i(c, dest, src) (c->j->convert)(c, DR_S, DR_I, dest, src)
#define dr_cvs2u(c, dest, src) (c->j->convert)(c, DR_S, DR_U, dest, src)
#define dr_cvs2ul(c, dest, src) (c->j->convert)(c, DR_S, DR_UL, dest, src)
#define dr_cvs2l(c, dest, src) (c->j->convert)(c, DR_S, DR_L, dest, src)
#define dr_cvu2i(c, dest, src) (c->j->convert)(c, DR_U, DR_I, dest, src)
#define dr_cvu2ul(c, dest, src) (c->j->convert)(c, DR_U, DR_UL, dest, src)
#define dr_cvu2l(c, dest, src) (c->j->convert)(c, DR_U, DR_L, dest, src)
#define dr_cvul2i(c, dest, src) (c->j->convert)(c, DR_UL, DR_I, dest, src)
#define dr_cvul2u(c, dest, src) (c->j->convert)(c, DR_UL, DR_U, dest, src)
#define dr_cvul2l(c, dest, src) (c->j->convert)(c, DR_UL, DR_L, dest, src)
#define dr_cvus2i(c, dest, src) (c->j->convert)(c, DR_US, DR_I, dest, src)
#define dr_cvus2u(c, dest, src) (c->j->convert)(c, DR_US, DR_U, dest, src)
#define dr_cvus2ul(c, dest, src) (c->j->convert)(c, DR_US, DR_UL, dest, src)
#define dr_cvus2l(c, dest, src) (c->j->convert)(c, DR_US, DR_L, dest, src)
#define dr_cvd2f(c, dest, src) (c->j->convert)(c, DR_D, DR_F, dest, src)
#define dr_cvf2d(c, dest, src) (c->j->convert)(c, DR_F, DR_D, dest, src)
#define dr_cvi2f(c, dest, src) (c->j->convert)(c, DR_I, DR_F, dest, src)
#define dr_cvi2d(c, dest, src) (c->j->convert)(c, DR_I, DR_D, dest, src)
#define dr_cvl2f(c, dest, src) (c->j->convert)(c, DR_L, DR_F, dest, src)
#define dr_cvl2d(c, dest, src) (c->j->convert)(c, DR_L, DR_D, dest, src)
#define dr_cvu2f(c, dest, src) (c->j->convert)(c, DR_U, DR_F, dest, src)
#define dr_cvu2d(c, dest, src) (c->j->convert)(c, DR_U, DR_D, dest, src)
#define dr_cvul2f(c, dest, src) (c->j->convert)(c, DR_UL, DR_F, dest, src)
#define dr_cvul2d(c, dest, src) (c->j->convert)(c, DR_UL, DR_D, dest, src)
#define dr_cvi2c(c, dest, src) (c->j->convert)(c, DR_I, DR_C, dest, src)
#define dr_cvi2s(c, dest, src) (c->j->convert)(c, DR_I, DR_S, dest, src)
#define dr_cvl2c(c, dest, src) (c->j->convert)(c, DR_L, DR_C, dest, src)
#define dr_cvl2s(c, dest, src) (c->j->convert)(c, DR_L, DR_S, dest, src)
#define dr_cvu2c(c, dest, src) (c->j->convert)(c, DR_U, DR_C, dest, src)
#define dr_cvu2s(c, dest, src) (c->j->convert)(c, DR_U, DR_S, dest, src)
#define dr_cvul2c(c, dest, src) (c->j->convert)(c, DR_UL, DR_C, dest, src)
#define dr_cvul2s(c, dest, src) (c->j->convert)(c, DR_UL, DR_S, dest, src)
#define dr_cvp2ul(c, dest, src) (c->j->convert)(c, DR_P, DR_UL, dest, src)
#define dr_cvul2p(c, dest, src) (c->j->convert)(c, DR_UL, DR_P, dest, src)
#define dr_ldc(c, dest, src1, src2) (c->j->load)(c, DR_C, 0, dest, src1, src2)
#define dr_ldci(c, dest, src, imm) (c->j->loadi)(c, DR_C, 0, dest, src, imm)
#define dr_stc(c, dest, src1, src2) (c->j->store)(c, DR_C, 0, dest, src1, src2)
#define dr_stci(c, dest, src, imm) (c->j->storei)(c, DR_C, 0, dest, src, imm)
#define dr_has_ldbs(c) (c->j->bsload != 0)
#define dr_ldbsc(c, dest, src1, src2) (c->j->bsload)(c, DR_C, 0, dest, src1, src2)
#define dr_ldbsci(c, dest, src, imm) (c->j->bsloadi)(c, DR_C, 0, dest, src, imm)
#define dr_ldd(c, dest, src1, src2) (c->j->load)(c, DR_D, 0, dest, src1, src2)
#define dr_lddi(c, dest, src, imm) (c->j->loadi)(c, DR_D, 0, dest, src, imm)
#define dr_std(c, dest, src1, src2) (c->j->store)(c, DR_D, 0, dest, src1, src2)
#define dr_stdi(c, dest, src, imm) (c->j->storei)(c, DR_D, 0, dest, src, imm)
#define dr_has_ldbs(c) (c->j->bsload != 0)
#define dr_ldbsd(c, dest, src1, src2) (c->j->bsload)(c, DR_D, 0, dest, src1, src2)
#define dr_ldbsdi(c, dest, src, imm) (c->j->bsloadi)(c, DR_D, 0, dest, src, imm)
#define dr_ldf(c, dest, src1, src2) (c->j->load)(c, DR_F, 0, dest, src1, src2)
#define dr_ldfi(c, dest, src, imm) (c->j->loadi)(c, DR_F, 0, dest, src, imm)
#define dr_stf(c, dest, src1, src2) (c->j->store)(c, DR_F, 0, dest, src1, src2)
#define dr_stfi(c, dest, src, imm) (c->j->storei)(c, DR_F, 0, dest, src, imm)
#define dr_has_ldbs(c) (c->j->bsload != 0)
#define dr_ldbsf(c, dest, src1, src2) (c->j->bsload)(c, DR_F, 0, dest, src1, src2)
#define dr_ldbsfi(c, dest, src, imm) (c->j->bsloadi)(c, DR_F, 0, dest, src, imm)
#define dr_ldi(c, dest, src1, src2) (c->j->load)(c, DR_I, 0, dest, src1, src2)
#define dr_ldii(c, dest, src, imm) (c->j->loadi)(c, DR_I, 0, dest, src, imm)
#define dr_sti(c, dest, src1, src2) (c->j->store)(c, DR_I, 0, dest, src1, src2)
#define dr_stii(c, dest, src, imm) (c->j->storei)(c, DR_I, 0, dest, src, imm)
#define dr_has_ldbs(c) (c->j->bsload != 0)
#define dr_ldbsi(c, dest, src1, src2) (c->j->bsload)(c, DR_I, 0, dest, src1, src2)
#define dr_ldbsii(c, dest, src, imm) (c->j->bsloadi)(c, DR_I, 0, dest, src, imm)
#define dr_ldl(c, dest, src1, src2) (c->j->load)(c, DR_L, 0, dest, src1, src2)
#define dr_ldli(c, dest, src, imm) (c->j->loadi)(c, DR_L, 0, dest, src, imm)
#define dr_stl(c, dest, src1, src2) (c->j->store)(c, DR_L, 0, dest, src1, src2)
#define dr_stli(c, dest, src, imm) (c->j->storei)(c, DR_L, 0, dest, src, imm)
#define dr_has_ldbs(c) (c->j->bsload != 0)
#define dr_ldbsl(c, dest, src1, src2) (c->j->bsload)(c, DR_L, 0, dest, src1, src2)
#define dr_ldbsli(c, dest, src, imm) (c->j->bsloadi)(c, DR_L, 0, dest, src, imm)
#define dr_ldp(c, dest, src1, src2) (c->j->load)(c, DR_P, 0, dest, src1, src2)
#define dr_ldpi(c, dest, src, imm) (c->j->loadi)(c, DR_P, 0, dest, src, imm)
#define dr_stp(c, dest, src1, src2) (c->j->store)(c, DR_P, 0, dest, src1, src2)
#define dr_stpi(c, dest, src, imm) (c->j->storei)(c, DR_P, 0, dest, src, imm)
#define dr_has_ldbs(c) (c->j->bsload != 0)
#define dr_ldbsp(c, dest, src1, src2) (c->j->bsload)(c, DR_P, 0, dest, src1, src2)
#define dr_ldbspi(c, dest, src, imm) (c->j->bsloadi)(c, DR_P, 0, dest, src, imm)
#define dr_lds(c, dest, src1, src2) (c->j->load)(c, DR_S, 0, dest, src1, src2)
#define dr_ldsi(c, dest, src, imm) (c->j->loadi)(c, DR_S, 0, dest, src, imm)
#define dr_sts(c, dest, src1, src2) (c->j->store)(c, DR_S, 0, dest, src1, src2)
#define dr_stsi(c, dest, src, imm) (c->j->storei)(c, DR_S, 0, dest, src, imm)
#define dr_has_ldbs(c) (c->j->bsload != 0)
#define dr_ldbss(c, dest, src1, src2) (c->j->bsload)(c, DR_S, 0, dest, src1, src2)
#define dr_ldbssi(c, dest, src, imm) (c->j->bsloadi)(c, DR_S, 0, dest, src, imm)
#define dr_ldu(c, dest, src1, src2) (c->j->load)(c, DR_U, 0, dest, src1, src2)
#define dr_ldui(c, dest, src, imm) (c->j->loadi)(c, DR_U, 0, dest, src, imm)
#define dr_stu(c, dest, src1, src2) (c->j->store)(c, DR_U, 0, dest, src1, src2)
#define dr_stui(c, dest, src, imm) (c->j->storei)(c, DR_U, 0, dest, src, imm)
#define dr_has_ldbs(c) (c->j->bsload != 0)
#define dr_ldbsu(c, dest, src1, src2) (c->j->bsload)(c, DR_U, 0, dest, src1, src2)
#define dr_ldbsui(c, dest, src, imm) (c->j->bsloadi)(c, DR_U, 0, dest, src, imm)
#define dr_lduc(c, dest, src1, src2) (c->j->load)(c, DR_UC, 0, dest, src1, src2)
#define dr_lduci(c, dest, src, imm) (c->j->loadi)(c, DR_UC, 0, dest, src, imm)
#define dr_stuc(c, dest, src1, src2) (c->j->store)(c, DR_UC, 0, dest, src1, src2)
#define dr_stuci(c, dest, src, imm) (c->j->storei)(c, DR_UC, 0, dest, src, imm)
#define dr_has_ldbs(c) (c->j->bsload != 0)
#define dr_ldbsuc(c, dest, src1, src2) (c->j->bsload)(c, DR_UC, 0, dest, src1, src2)
#define dr_ldbsuci(c, dest, src, imm) (c->j->bsloadi)(c, DR_UC, 0, dest, src, imm)
#define dr_ldu(c, dest, src1, src2) (c->j->load)(c, DR_U, 0, dest, src1, src2)
#define dr_ldui(c, dest, src, imm) (c->j->loadi)(c, DR_U, 0, dest, src, imm)
#define dr_stu(c, dest, src1, src2) (c->j->store)(c, DR_U, 0, dest, src1, src2)
#define dr_stui(c, dest, src, imm) (c->j->storei)(c, DR_U, 0, dest, src, imm)
#define dr_has_ldbs(c) (c->j->bsload != 0)
#define dr_ldbsu(c, dest, src1, src2) (c->j->bsload)(c, DR_U, 0, dest, src1, src2)
#define dr_ldbsui(c, dest, src, imm) (c->j->bsloadi)(c, DR_U, 0, dest, src, imm)
#define dr_ldul(c, dest, src1, src2) (c->j->load)(c, DR_UL, 0, dest, src1, src2)
#define dr_lduli(c, dest, src, imm) (c->j->loadi)(c, DR_UL, 0, dest, src, imm)
#define dr_stul(c, dest, src1, src2) (c->j->store)(c, DR_UL, 0, dest, src1, src2)
#define dr_stuli(c, dest, src, imm) (c->j->storei)(c, DR_UL, 0, dest, src, imm)
#define dr_has_ldbs(c) (c->j->bsload != 0)
#define dr_ldbsul(c, dest, src1, src2) (c->j->bsload)(c, DR_UL, 0, dest, src1, src2)
#define dr_ldbsuli(c, dest, src, imm) (c->j->bsloadi)(c, DR_UL, 0, dest, src, imm)
#define dr_ldus(c, dest, src1, src2) (c->j->load)(c, DR_US, 0, dest, src1, src2)
#define dr_ldusi(c, dest, src, imm) (c->j->loadi)(c, DR_US, 0, dest, src, imm)
#define dr_stus(c, dest, src1, src2) (c->j->store)(c, DR_US, 0, dest, src1, src2)
#define dr_stusi(c, dest, src, imm) (c->j->storei)(c, DR_US, 0, dest, src, imm)
#define dr_has_ldbs(c) (c->j->bsload != 0)
#define dr_ldbsus(c, dest, src1, src2) (c->j->bsload)(c, DR_US, 0, dest, src1, src2)
#define dr_ldbsusi(c, dest, src, imm) (c->j->bsloadi)(c, DR_US, 0, dest, src, imm)
#define dr_retc(c, src) (c->j->ret)(c, DR_I, 0, src)
#define dr_retci(c, imm) (c->j->reti)(c, DR_C, 0, imm)
#define dr_retuc(c, src) (c->j->ret)(c, DR_I, 0, src)
#define dr_retuci(c, imm) (c->j->reti)(c, DR_UC, 0, imm)
#define dr_rets(c, src) (c->j->ret)(c, DR_I, 0, src)
#define dr_retsi(c, imm) (c->j->reti)(c, DR_S, 0, imm)
#define dr_retus(c, src) (c->j->ret)(c, DR_I, 0, src)
#define dr_retusi(c, imm) (c->j->reti)(c, DR_US, 0, imm)
#define dr_reti(c, src) (c->j->ret)(c, DR_I, 0, src)
#define dr_retii(c, imm) (c->j->reti)(c, DR_I, 0, imm)
#define dr_retu(c, src) (c->j->ret)(c, DR_U, 0, src)
#define dr_retui(c, imm) (c->j->reti)(c, DR_U, 0, imm)
#define dr_retl(c, src) (c->j->ret)(c, DR_L, 0, src)
#define dr_retli(c, imm) (c->j->reti)(c, DR_L, 0, imm)
#define dr_retul(c, src) (c->j->ret)(c, DR_UL, 0, src)
#define dr_retuli(c, imm) (c->j->reti)(c, DR_UL, 0, imm)
#define dr_retp(c, src) (c->j->ret)(c, DR_P, 0, src)
#define dr_retpi(c, imm) (c->j->reti)(c, DR_P, 0, (unsigned long) imm)
#define dr_retd(c, src) (c->j->ret)(c, DR_D, 0, src)
#define dr_retdi(c, imm) (c->j->reti)(c, DR_D, 0, imm)
#define dr_retf(c, src) (c->j->ret)(c, DR_F, 0, src)
#define dr_retfi(c, imm) (c->j->reti)(c, DR_F, 0, imm)
#define dr_pret(c, type, src) (c->j->ret)(c, type, 0, src)
#define dr_movc(c, dest, src) (c->j->mov)(c, DR_C, 0, dest, src)
#define dr_movuc(c, dest, src) (c->j->mov)(c, DR_UC, 0, dest, src)
#define dr_movs(c, dest, src) (c->j->mov)(c, DR_S, 0, dest, src)
#define dr_movus(c, dest, src) (c->j->mov)(c, DR_US, 0, dest, src)
#define dr_movi(c, dest, src) (c->j->mov)(c, DR_I, 0, dest, src)
#define dr_movu(c, dest, src) (c->j->mov)(c, DR_U, 0, dest, src)
#define dr_movl(c, dest, src) (c->j->mov)(c, DR_L, 0, dest, src)
#define dr_movul(c, dest, src) (c->j->mov)(c, DR_UL, 0, dest, src)
#define dr_movp(c, dest, src) (c->j->mov)(c, DR_P, 0, dest, src)
#define dr_movd(c, dest, src) (c->j->mov)(c, DR_D, 0, dest, src)
#define dr_movf(c, dest, src) (c->j->mov)(c, DR_F, 0, dest, src)
#define dr_setc(c, dest, imm) (c->j->set)(c, DR_C, 0, dest, imm)
#define dr_setuc(c, dest, imm) (c->j->set)(c, DR_UC, 0, dest, imm)
#define dr_sets(c, dest, imm) (c->j->set)(c, DR_S, 0, dest, imm)
#define dr_setus(c, dest, imm) (c->j->set)(c, DR_US, 0, dest, imm)
#define dr_seti(c, dest, imm) (c->j->set)(c, DR_I, 0, dest, imm)
#define dr_setu(c, dest, imm) (c->j->set)(c, DR_U, 0, dest, imm)
#define dr_setl(c, dest, imm) (c->j->set)(c, DR_L, 0, dest, imm)
#define dr_setul(c, dest, imm) (c->j->set)(c, DR_UL, 0, dest, imm)
#define dr_setp(c, dest, imm) (c->j->set)(c, DR_P, 0, dest, imm)
#define dr_setd(c, dest, imm) (c->j->setf)(c, DR_D, 0, dest, imm)
#define dr_setf(c, dest, imm) (c->j->setf)(c, DR_F, 0, dest, imm)
#define dr_piset(c, type, dest, imm) (c->j->set)(c, type, 0, dest, imm)
#define dr_push_arg(c, type, reg) (c->j->push)(c, type, reg)
#define dr_push_init(c) (c->j->push)(c, DR_V, -1)
#define dr_push_argi(c, reg) (c->j->push)(c, DR_I, reg)
#define dr_push_argii(c, imm) (c->j->pushi)(c, DR_I, imm)
#define dr_push_argu(c, reg) (c->j->push)(c, DR_U, reg)
#define dr_push_argui(c, imm) (c->j->pushi)(c, DR_U, imm)
#define dr_push_argl(c, reg) (c->j->push)(c, DR_L, reg)
#define dr_push_argli(c, imm) (c->j->pushi)(c, DR_L, imm)
#define dr_push_argul(c, reg) (c->j->push)(c, DR_UL, reg)
#define dr_push_arguli(c, imm) (c->j->pushi)(c, DR_UL, imm)
#define dr_push_argp(c, reg) (c->j->push)(c, DR_P, reg)
#define dr_push_argpi(c, imm) (c->j->pushi)(c, DR_P, (long) imm)
#define dr_push_argf(c, reg) (c->j->push)(c, DR_F, reg)
#define dr_push_argfi(c, imm) (c->j->pushfi)(c, DR_F, imm)
#define dr_push_argd(c, reg) (c->j->push)(c, DR_D, reg)
#define dr_push_argdi(c, imm) (c->j->pushfi)(c, DR_D, imm)
extern int dr_scalli(drisc_ctx c, void *ptr, char *arg_str, ...);
#define dr_calli(c, ptr) c->j->calli(c, DR_I , ptr)
#define dr_callri(c, src) c->j->callr(c, DR_I , src)
extern int dr_scallu(drisc_ctx c, void *ptr, char *arg_str, ...);
#define dr_callu(c, ptr) c->j->calli(c, DR_U , ptr)
#define dr_callru(c, src) c->j->callr(c, DR_U , src)
extern int dr_scalll(drisc_ctx c, void *ptr, char *arg_str, ...);
#define dr_calll(c, ptr) c->j->calli(c, DR_L , ptr)
#define dr_callrl(c, src) c->j->callr(c, DR_L , src)
extern int dr_scallul(drisc_ctx c, void *ptr, char *arg_str, ...);
#define dr_callul(c, ptr) c->j->calli(c, DR_UL , ptr)
#define dr_callrul(c, src) c->j->callr(c, DR_UL , src)
extern int dr_scallf(drisc_ctx c, void *ptr, char *arg_str, ...);
#define dr_callf(c, ptr) c->j->calli(c, DR_F , ptr)
#define dr_callrf(c, src) c->j->callr(c, DR_F , src)
extern int dr_scalld(drisc_ctx c, void *ptr, char *arg_str, ...);
#define dr_calld(c, ptr) c->j->calli(c, DR_D , ptr)
#define dr_callrd(c, src) c->j->callr(c, DR_D , src)
extern void dr_scallv(drisc_ctx c, void *ptr, char *arg_str, ...);
#define dr_callv(c, ptr) c->j->calli(c, DR_V , ptr)
#define dr_callrv(c, src) c->j->callr(c, DR_V , src)
#define dr_pcall(c, type, ptr) c->j->calli(c, type, ptr)
#define dr_pcallr(c, type, src) c->j->callr(c, type, src)
#define dr_savei(c, reg) c->j->save_restore(c, 0, DR_I, reg)
#define dr_restorei(c, reg) c->j->save_restore(c, 1, DR_I, reg)
#define dr_saveu(c, reg) c->j->save_restore(c, 0, DR_U, reg)
#define dr_restoreu(c, reg) c->j->save_restore(c, 1, DR_U, reg)
#define dr_savel(c, reg) c->j->save_restore(c, 0, DR_L, reg)
#define dr_restorel(c, reg) c->j->save_restore(c, 1, DR_L, reg)
#define dr_saveul(c, reg) c->j->save_restore(c, 0, DR_UL, reg)
#define dr_restoreul(c, reg) c->j->save_restore(c, 1, DR_UL, reg)
#define dr_savep(c, reg) c->j->save_restore(c, 0, DR_P, reg)
#define dr_restorep(c, reg) c->j->save_restore(c, 1, DR_P, reg)
#define dr_saved(c, reg) c->j->save_restore(c, 0, DR_D, reg)
#define dr_restored(c, reg) c->j->save_restore(c, 1, DR_D, reg)
#define dr_savef(c, reg) c->j->save_restore(c, 0, DR_F, reg)
#define dr_restoref(c, reg) c->j->save_restore(c, 1, DR_F, reg)
#define dr_jmp_a3_size 50
#define dr_jmp_a2_size 14
#define dr_jmp_branch_size 42
#define dr_jmp_convert_size 0
#define dr_jv(c, label) (c->j->jv)(c, (unsigned long) label)
#define dr_jp(c, dest_reg) (c->j->jp)(c, (unsigned long) dest_reg)
#define dr_jpi(c, dest_imm) (c->j->jpi)(c, (unsigned long) dest_imm)
#define dr_jalp(c, return_addr_reg, target) (c->j->jal)(c, return_addr_reg, target)
