#ifndef QOS_MGR_H
#define QOS_MGR_H

#include "qosadapt.h"

struct _qos_apps 
{
	/* general information */
	int active;
	int pid;
	struct _qos_apps *next;
	struct _qos_apps *prev;
	struct task_struct *proc;
	CManager cm;
	EControlContext cc;
	char *app_id;
	char *group_id;
	int server_time;
	/* CPU related information */
	int use_cpu;
	/* Network related information */
	int use_net;
	EChannel chan;
	ECSourceHandle handle;
	struct socket *socket;
	rwlock_t app_lock;
	ECSinkHandle sink_handle;

	/*quality information*/
	int fps_desired;
	int fps_client;
	int fps_server;
	int cpuidle_server;
	int cpuidle_client;
	int prev_cpuidle_server;
	int prev_cpuidle_client;

	/*adaptation information*/
	int changed;
	int cpu;

	/*extension functions*/
	int dynamic;
	ecl_parse_context context;
	ecl_code gen_code;
 	void *controller;
	ecl_parse_context mcontext;
        ecl_code mgen_code;
	void *filter;
};

typedef struct _qos_apps *qos_apps;

struct _hosts {
	int used;
	char hostname[MAXHOSTNAMELEN];
	int runqueuelen;
	int loadavg;
	int freemem;
	int netmon;
	int uinfo1;
	int uinfo2;
	int uinfo3;
};

typedef struct _hosts host_entry;

typedef struct
{
	host_entry *input_hosts;	
} list_of_res;

typedef struct _hosts *hosts;

typedef struct _local_resources {
	int loadavg;
	int freemem;
	int netmon;
} local_resources, *plocal_resources;

struct qfabric_event {
	int type; /* 0 = MON, 1 = CON */
	char hostname[MAXHOSTNAMELEN];
	int runqueuelen;
	int loadavg;
	int freemem;
	int netmon;
	int uinfo1;
	int uinfo2;
	int uinfo3;
};

struct qfabric_event2 {
	int type; /* 2 = CODE DISTRIBUTION */
	char hostname[MAXHOSTNAMELEN];
	int runqueuelen;
	int loadavg;
	int freemem;
	int netmon;
	int uinfo1;
	int uinfo2;
	int uinfo3;
	char hook[MAXHOSTNAMELEN];
	char par1[MAXHOSTNAMELEN];
	int par2;
	int par3;
	int len;
};

typedef struct _mon_event *mon_event;

extern int qos_register(char *, char *);
extern int con_register(char *, char *, void *);
extern int con_unregister(char *, char *);

#endif //QOS_MGR_H
