#ifndef _QOS_ADAPT_H_
#define _QOS_ADAPT_H_
typedef struct _q_event
{
//source information
#define S_RM 	1
#define S_APP	2
#define C_RM 	3
#define C_APP 	4
#define QUALITY 5
	short type;
	
//fps information
	int 	fps_client;		//fps client is getting
	int 	fps_server;		//fps server is generating
	int 	fps_desired;	//fps that the user has specified

//cpu information	
	int		cpuidle_server;	//idle cpu jiffies on the server
	int		cpuidle_client;	//idle cpu jiffies on the client
	int 	cputotal_server;
	int 	cputotal_client;
	
//network information
	long 	netq_delay;			//network delay for the stream
	long 	netq_len;			//network queue length for the stream
	
//quality event information
//flags indicating adaptaion status
#define ADAPT_UP 	1
#define ADAPT_DOWN	-1
#define NO_CHANGE	0
	int 	adapt_client_app;	//client app should adapt itself 
	int 	adapt_client_cpu;	//client CPU RM should change the priority of the app
	int 	adapt_client_net;	//client Net RM should change the recieving rate of the app
	int 	adapt_server_cpu;	//server CPU RM should change the priority of the app
	int 	adapt_server_net;	//server NET RM shoudl change the sending rate of the app
	int 	adapt_server_app;	//server app should adapt itself

	int 	adapt_server_delay;
	unsigned long long time;
	
	int server_app;
	int client_app;
	int server_rm;
	int client_rm;
} q_event, *q_event_ptr;

#endif
